Package: catmodeling
Type: Package
Title: Catastrophe Model Simulation and Adjustment
Version: 0.0.1
Authors@R: 
    person(given="Stephen",
	family="Jewson",
	email= "stephen.jewson@gmail.com", 
	role = c("aut", "cre"),
        comment = c(ORCID = "0000-0002-6011-6262"))
Maintainer: Stephen Jewson <stephen.jewson@gmail.com>
Description: Manipulation of catastrophe model outputs, including
    tasks such as simulating year loss tables (YLTs) from event loss tables (ELTs), 
    adjusting the frequencies of events in YLTs to create new YLTs, 
    applying catastrophe exceedance of loss contracts (catXL),
    applying hours clauses,
    and calculating diagnostics from ELTs and YLTs, such as average annual loss 
    and exceedance probability curves. Frequency adjustment routines are 
    based on the paper "A new simulation algorithm for 
    more precise estimates of change in catastrophe risk models, with application to 
    hurricanes and climate change", Jewson, S. (2023); <doi:10.1007/s00477-023-02409-0>.
    Uses the compiled language 'Rust' in places and so requires
    a Rust compiler to be installed, or a binary installation.
Imports: stats, dplyr, utils, pracma, geosphere
Depends: R (>= 4.2)
License: AGPL-3
BugReports: https://github.com/stephenjewson/catmodeling/issues
URL: https://www.catmodeling.info
Encoding: UTF-8
RoxygenNote: 7.3.3
Config/rextendr/version: 0.5.0
SystemRequirements: Cargo (Rust's package manager), rustc >= 1.65.0, xz
NeedsCompilation: yes
Packaged: 2026-07-11 11:45:59 UTC; steph
Author: Stephen Jewson [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-6011-6262>)
Repository: CRAN
Date/Publication: 2026-07-23 12:00:02 UTC

#' Checks a YLT for two events on the same day
#'
#' @description
#' The assumption is that two events on the same day is bad, so if it
#' finds two events on the same day, it stops running, and gives a message
#' saying what day they are on.
#'
#' @param longylt			The input longylt, which needs a \code{day} column.
#'
#' @returns
#' Screen output listing when there are two events on the same day
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_537_ylt_check_for_2_events_on_same_day.R
#'
#' @export
#'
ylt_check_for_2_events_on_same_day=function(longylt){

	input_checks(longylt,c("day"),"ylt_check_for_2_events_on_same_day")

	shortylt=ylt_long2short(longylt)

	for (i in 1:length(shortylt$year)){
		start		=shortylt$longylt_start_row[i]
		nevents	=shortylt$nevents_in_year[i]
		end=start+nevents-1
#	message("year=",i)
#	message(" start,nevents,end=",start,nevents,end)
		oneyear=longylt$day[start:end]
#	message(" oneyear=",oneyear)
		maxt=max(tabulate(oneyear))
		if(maxt>1){
			message(" There are 2 events on the same day in year:",i)
			message(" days in this year=",oneyear)
			message(" So I'm stopping the code now,")
			message(" inside check_ylt_for_2_events_on_same_day.")
			stop()
		}
		message("...check complete")
	}
}

#
# create an elt
#
mrate=seq(0.1,0.5,0.1)
mloss=seq(100,500,100)
cat=c(1,1,1,2,2)
elt=data.frame(mrate,mloss,cat)
#
# make the rate adjustments (two sets, for comparison)
#
adjustmentsbycatevent1=matrix(1,7,5)
adjustmentsbycatevent2=matrix(2,7,5)
#
# calculate the AAE and AAL 3 ways
#
op0=elt_diagnostics_aaeaal(elt)
op1=elt_diagnostics_aaeaal_with_adj(elt,adjustmentsbycatevent1)
op2=elt_diagnostics_aaeaal_with_adj(elt,adjustmentsbycatevent2)
#
cat("no adjustments (from the basic elt_diagnostics routine, for comparison):\n")
cat(" AAE=",op0$AAE,"\n")
cat(" AAL=",op0$AAL,"\n")
cat("no adjustments (from this routine, but with adjustments all set to 1):\n")
cat(" AAE=",op1$AAE,"\n")
cat(" AAL=",op1$AAL,"\n")
cat("with adjustments (this routine, with some actual adjustments):\n")
cat(" AAE=",op2$AAE,"\n")
cat(" AAL=",op2$AAL,"\n")

#' Adds a cat column to a long ylt, based on windspeed
#'
#' @description
#' Calculates cat from windspeed, and adds a column for that.
#' Requires \code{wspd} in the input longylt.
#'
#' @param longylt			A data frame containing the long YLT
#' @param units				"knots","mph" 
#'
#' @returns
#' A new longylt with a cat column added
#'
#' @details
#' Cat runs from -1 to 5. 
#' Different people use different cat boundaries.
#' To see the boundaries being used, type \code{ws2catf}.
#' 
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_539_ylt_add_cat_2_longylt.R
#'
#' @export
#'
ylt_add_cat_2_longylt=function(longylt,units){

	input_checks(longylt,c("year","wspd"),"ylt_add_cat_2_longylt")

	nyltevents=length(longylt$year)
	catbyyltevent=matrix(0,nyltevents)

	for (ie in 1:nyltevents){
			ws=longylt$wspd[ie]
			catbyyltevent[ie]=ws2catf(ws,units)
	}
		
	longylt2=longylt
	longylt2$cat=catbyyltevent

	return(longylt2)
}

#' Writes results from N YLTs to csv format.
#'
#' @description
#' Writes various results from N YLTs to csv.
#' Can be used with \code{sink()} to make a nicely formatted csv file.
#' The result are:
#' AAE and AAL by cat, AEP, OEP and threshold counting.
#'
#' @param nyearsinylt 			number of years
#' @param mincat						minimum cat
#' @param maxcat						maximum cat
#' @param nrp								number of return periods
#' @param nylt							number of ylts
#' @param	maxnumberevents	related to the threshold counting
#' @param bsaepsd						bootstraps sds for AEP
#' @param bsoepsd						bootstraps sds for OEP
#' @param	aal								AAL results
#' @param	pcaal							AAL as percentages
#' @param	aalbc							AAL results by cat
#' @param	pcaalbc						AAL as percentages by cat
#' @param	aae								AAE results
#' @param	pcaae							AAE as percentages
#' @param	aaebc							AAE results by cat
#' @param	pcaaebc						AAE as percentages by cat
#' @param	nbc								Number by cat results
#' @param pcaaebc						AAE results as percentage
#' @param aalbc							AAL results
#' @param probs							return probabilities being used
#' @param rps								return levels being used
#' @param aep								AEP results
#' @param daep							AEP changes
#' @param oep								OEP results
#' @param doep							OEP changes
#' @param lossthresholds		For the threshold counting
#' @param	thresholdcounts		threshold counting results
#' @param justone						logical if there's just one run to be processed
#' @param iylt							if there's just one, what is the i
#'
#' @returns
#' CSV output, for screen or file.
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_554_ylt_writeNresults2csv.R
#'
#' @export
#'
writeNresults2csv=function(nyearsinylt,mincat,maxcat,nrp,nylt,maxnumberevents,bsaepsd,bsoepsd,
		aal,pcaal,aalbc,pcaalbc,
		aae,pcaae,aaebc,pcaaebc,
		nbc,
		probs,rps,aep,daep,oep,doep,lossthresholds,thresholdcounts,justone=FALSE,iylt){

		ncat=1+maxcat-mincat
		ncatp1=ncat+1

# 1 write out AAE changes
		message("")
		message("AAE by cat")

# write headings for AAE section
		if(justone){
			message(",ylt1#,ylt2#,ylt1,ylt2,change,change %,",appendLF=FALSE)
		} else {
			message(",mean1#,mean2#,mean1,mean2,dmean,dmean %,sd %,",appendLF=FALSE)
		}
# write headings for individual models
		if(!justone){for (iy in 1:nylt)message(",#",iy," (%)",appendLF=FALSE)}
		message("")

# make rownames
		rownames=matrix(0,ncatp1)
		for (ic in 1:ncat){rownames[ic]=paste("cat",(mincat+ic-1),sep="")}
		rownames[ncatp1]="All cat"

# write rows of AAE results
		for (i in 1:ncatp1){
			if(justone){
				meanaae1=round(aaebc[1,iylt,i],digits=2)
				meanaae2=round(aaebc[2,iylt,i],digits=2)
				dmeanaae=round(aaebc[2,iylt,i]-aaebc[1,iylt,i],digits=2)
				meanaaepc=round(pcaaebc[iylt,i],digits=1)
				message(rownames[i],",",
								nbc[1,iylt,i],",",
								nbc[2,iylt,i],",",
								meanaae1,",",
								meanaae2,",",
								dmeanaae,",",
								meanaaepc,", ",appendLF=FALSE)
			} else {
				meanaae1=round(mean(aaebc[1,,i]),digits=2)
				meanaae2=round(mean(aaebc[2,,i]),digits=2)
				dmeanaae=round(mean(aaebc[2,,i])-mean(aaebc[1,,i]),digits=2)
				meanaaepc=round(mean(pcaaebc[,i]),digits=1)
				sdaaepc=round(sd(pcaaebc[,i]),digits=1)
				meannbc1=mean(nbc[1,,i])
				meannbc2=mean(nbc[2,,i])
				message(rownames[i],",",
								meannbc1,",",
								meannbc2,",",
								meanaae1,",",
								meanaae2,",",
								dmeanaae,",",
								meanaaepc,",",
								sdaaepc,",",appendLF=FALSE)
			}
			if(!justone){for (iy in 1:nylt)message(",",pcaaebc[iy,i],appendLF=FALSE)}
			message("")
		}

# 2 write out AAL changes
		message("")
		message("AAL by cat")

# write headings for AAL section
		if(justone){
			message(",ylt1,ylt2,change,change %,",appendLF=FALSE)
		} else {
			message(",mean1,mean2,dmean,dmean %,sd %,",appendLF=FALSE)
		}
# write headings for individual models
		if(!justone){for(iy in 1:nylt)message(",#",iy," (%)",appendLF=FALSE)}
		message("")

# use rownames from AAE section

# write rows of AAL results
		for (i in 1:ncatp1){
			if(justone){
				meanaal1=round(aalbc[1,iylt,i],digits=2)
				meanaal2=round(aalbc[2,iylt,i],digits=2)
				dmeanaal=round(aalbc[2,iylt,i]-aalbc[1,iylt,i],digits=2)
				meanaalpc=round(pcaalbc[iylt,i],digits=1)
				message(rownames[i],",",
								meanaal1,",",
								meanaal2,",",
								dmeanaal,",",
								meanaalpc,",",appendLF=FALSE)
			} else {
				meanaal1=round(mean(aalbc[1,,i]),digits=2)
				meanaal2=round(mean(aalbc[2,,i]),digits=2)
				dmeanaal=round(mean(aalbc[2,,i])-mean(aalbc[1,,i]),digits=2)
				meanaalpc=round(mean(pcaalbc[,i]),digits=1)
				sdaalpc=round(sd(pcaalbc[,i]),digits=1)
				message(rownames[i],",",
								meanaal1,",",
								meanaal2,",",
								dmeanaal,",",
								meanaalpc,",",
								sdaalpc,",",appendLF=FALSE)
			}
			if(!justone){for (iy in 1:nylt)message(",",pcaalbc[iy,i],appendLF=FALSE)}
			message("")
		}

# 3 write out EPs
		for (kk in 1:2){
			message("")
			if(kk==1){
				message("AEPs")
				ep=aep
				dep=daep
				bsepsd=bsaepsd
			} else {
				message("OEPs")
				ep=oep
				dep=doep
				bsepsd=bsaepsd
			}
			if(justone){message("P,RP,ylt1,ylt2,change,change %,",appendLF=FALSE)
				}else{message("P,RP,mean1,mean2,dmean,dmean %,sd %,SE,",appendLF=FALSE)}
			if(!justone)for (iy in 1:nylt)message(",#",iy," (%)",appendLF=FALSE)
			message("")
			for (i in 1:nrp){
				if(justone){
					meanep1=round(ep[1,iylt,i],digits=2)
					meanep2=round(ep[2,iylt,i],digits=2)
					dmeanep=round(ep[2,iylt,i]-ep[1,iylt,i],digits=2)
					meandeppc=round(dep[iylt,i],digits=1)
					message(probs[i],",",
									rps[i],",",
									meanep1,",",
									meanep2,",",
									dmeanep,",",
									meandeppc,",",appendLF=FALSE)
				} else{
					meanep1=round(mean(ep[1,,i]),digits=2)
					meanep2=round(mean(ep[2,,i]),digits=2)
					dmeanep=round(mean(ep[2,,i])-mean(ep[1,,i]),digits=2)
					meandeppc=round(mean(dep[,i]),digits=1)
					sddeppc=round(sd(daep[,i]),digits=1)
					message(probs[i],",",
							rps[i],",",
							meanep1,",",
							meanep2,",",
							dmeanep,",",
							meandeppc,",",
							sddeppc,",",
							bsepsd[i],",",appendLF=FALSE)
				}
				if(!justone){for (iy in 1:nylt)message(",",dep[iy,i],appendLF=FALSE)}
				message("")
			}
		}

# write out loss threshold results
#	thresholdcounts	=array(0,c(2,nylt,nlossthresholds,maxnumberevents)
		for (it in 1:length(lossthresholds)){
			message("")
			message("Loss threshold,",lossthresholds[it])

# absolute values
			message("events per year,mean1,mean2,dmean,dmean %,",appendLF=FALSE)
			if(!justone)for (iy in 1:nylt)message(",#",iy," (%)",appendLF=FALSE)
			message("")
			for (ie in 0:maxnumberevents){
				message(ie,",",appendLF=FALSE)
				if(justone){
					mean1=round(thresholdcounts[1,iylt,it,(ie+1)],digits=1)
					mean2=round(thresholdcounts[2,iylt,it,(ie+1)],digits=1)
					dmean=round(thresholdcounts[2,iylt,it,(ie+1)]-thresholdcounts[1,iylt,it,(ie+1)],digits=1)
					dmeanpc=round(100*dmean/mean1,digits=1)
					message(mean1,",",
									mean2,",",
									dmean,",",
									dmeanpc,",",appendLF=FALSE)
				} else {
					mean1=round(mean(thresholdcounts[1,,it,(ie+1)]),digits=1)
					mean2=round(mean(thresholdcounts[2,,it,(ie+1)]),digits=1)
					dmean=round(mean(thresholdcounts[2,,it,(ie+1)])-mean(thresholdcounts[1,,it,(ie+1)]),digits=1)
					dmeanpc=round(100*dmean/mean1,digits=1)
					message(mean1,",",
									mean2,",",
									dmean,",",
									dmeanpc,",",appendLF=FALSE)
				}
				if(!justone)for (iy in 1:nylt){message(",",thresholdcounts[2,iy,it,(ie+1)],appendLF=FALSE)}
				message("")
			}

# relative values
			message("events per year,mean1,mean2,dmean,dmean %,",appendLF=FALSE)
			if(!justone)for (iy in 1:nylt)message(",#",iy," (%)",appendLF=FALSE)
			message("")
			thresholdcountspy=thresholdcounts/nyearsinylt
			for (ie in 0:maxnumberevents){
				message(ie,",",appendLF=FALSE)
				if(justone){
					mean1=thresholdcountspy[1,iylt,it,(ie+1)]
					mean2=thresholdcountspy[2,iylt,it,(ie+1)]
					dmean=mean2-mean1
					dmeanpc=round(100*dmean/mean1,digits=1)
					message(round(mean1,digits=2),",",
							round(mean2,digits=2),",",
							round(dmean,digits=2),",",
							dmeanpc,",",appendLF=FALSE)
				} else {
					mean1=mean(thresholdcountspy[1,,it,(ie+1)])
					mean2=mean(thresholdcountspy[2,,it,(ie+1)])
					dmean=mean2-mean1
					dmeanpc=round(100*dmean/mean1,digits=1)
					message(round(mean1,digits=2),",",
							round(mean2,digits=2),",",
							round(dmean,digits=2),",",
							dmeanpc,",",appendLF=FALSE)
				}
				if(!justone)for (iy in 1:nylt){message(",",round(thresholdcountspy[2,iy,it,(ie+1)],digits=2),appendLF=FALSE)}
				message("")
			}

		}

}

#' Make an EP curve by sorting losses
#'
#' @description
#' Reads in a vector of losses, sorts them, and picks out certain return level losses
#'
#' @param losses		A vector of annual losses
#' @param rps				A vector of return periods at which losses are required
#' Must be 1 or greater. 
#'
#' @returns
#' Losses at the specified return periods, as integers.
#' 
#' @details
#' Assumes the input losses are one loss per year.
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_023_make_ep_by_sorting.R
#'
#' @export
#'
make_ep_by_sorting=function(losses,rps){

		nyears=length(losses)

		rpi=pmax(round(nyears/rps),1)

		slosses=sort(losses,decreasing=TRUE)

		ep=round(slosses[rpi],digits=0)

	return(ep)
}

#' Checks the columns in an input data frame.
#'
#' @description
#' A utility that checks the columns in the input data frame versus a list of required names
#'
#' @param df				data frame to check
#' @param names 		names to check
#' @param location  print where it's being called from
#'
#' @returns
#' x
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_027_input_checks.R
#'
#' @export
input_checks=function(df,names,location=FALSE){

	stop=FALSE
	for (i in 1:length(names)){
		namei=names[i]
		if(!namei%in%colnames(df)){
			message("The data frame is missing the ",namei," column...exiting.")
			if(location!=FALSE)message("From routine: ",location)
			message(" ")
			stop=TRUE
		}
	}

	if(stop)stop()

}

#' Bootstrap EP uncertainty
#'
#' @description
#' Reads in a vector of annual losses, bootstraps, and calculates
#' the standard deviation of losses at a list of return levels
#'
#' @param losses	A vector of losses
#' @param nbs			The number of bootstrap resamples required
#' @param rps			The return periods required
#'
#' @returns
#' A vector of standard deviations, one for each return level
#'
#' @details
#' Can be used with \code{make_ep_by_sorting}, for the basic EP curve.
#' Obviously using more bootstrap samples is better, but slower.
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_025_bootstrap_ep_uncertainty.R
#'
#' @export
#'
bootstrap_ep_uncertainty=function(losses,nbs,rps){

	  nrp=length(rps)

# calculate the indices for finding the return levels
	  nyears=length(losses)
		rpi=pmax(round(nyears/rps),1)

		bsaep=matrix(0,nbs,nrp)
		bsasd=numeric(nrp)
		baseaep=(sort(losses,decreasing=TRUE))[rpi]

# bootstrap loop
		for (ib in 1:nbs){
# randomly resample the losses
			asample=sample(losses,replace=TRUE)
# sort them
			sasample=sort(asample,decreasing=TRUE)
# and pick out the aep losses
			bsaep[ib,]=sasample[rpi]
		}

# calculate the standard deviation across the bootstrapped losses
# for each return level
		for (ir in 1:nrp){
			bsasd[ir]=round(100*stats::sd(bsaep[,ir])/baseaep[ir],digits=1)
		}

	return(bsasd)
}

#
# create an long ylt with 4 years and 10 events
#
set.seed(1)
#
# essentials, illustrating:
# -multiple events in one year
# -some events repeat, but could have different losses
yrid=c(1,1,1,2,2,2,3,3,4,4)
evid=c(1000,1001,1002,1003,1001,1004,1005,1000,1006,1007) 
loss=seq(100,1000,100)
#
# now make the ylt
# column ordering is optional, but the following is standard
longylt=data.frame(yrid,evid,loss)
#
# and have a look at it, in different ways
print(longylt)
head(longylt,n=5)

#' Prints AAE and AAL from a Long YLT to the screen
#'
#' @description
#' Because it's a longylt, you have to specify the \code{nyearsinylt}.
#' If you have a full ylt, better to use \code{ylt_diagnostics_aaeaal_print},
#' because then you don't have to specify that.
#'
#' @param longylt				A data frame containing the long YLT
#' @param nyearsinylt  Sometimes, by chance, the long YLT might not have any
#' events in year 100, even
#' though technically it's supposed to be 100 years long. So it's good to specify
#' the number of actual years (in this example, 100). Then the short YLT will have
#' 100 years in it. The last year just won't have any events in it. If you just leave
#' this to the default value of 0, then the short YLT will just stop at the last year
#' in the long YLT.
#'
#' @returns
#' Prints AAE, AAL to the screen
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_581_ylt_diagnostics_aaeaal_printf.R
#'
#' @export
ylt_diagnostics_aaeaal_printf=function(longylt,nyearsinylt=0){

		diag1=ylt_diagnostics_aaeaal(longylt,nyearsinylt)
		aae=diag1$AAE
		aal=diag1$AAL
		message("   nevents=",length(longylt$year))
		message("   ylt aae,aal=",round(aae,4),",",aal)

}

#' Adjusts a long YLT to make a new long YLT using the surgery algorithm
#'
#' @description
#' The simulated YLT is copied from the input YLT, with events added and deleted to reflect
#' the specified rates changes, according to the 'surgery' algorithm.
#' This algorithm attempts to minimize differences due to random noise between the two YLTs
#' and gives more accurate estimates of change than just simulating the second YLT using independent simulation.
#' The rates changes are specified by event.
#' They can be scalar or log-normal distributed, in order to capture adjustment uncertainty.
#' Adjustment uncertainty is simulated using the 'stochastic parameter' simulation algorithm.
#'
#' @param longylt1		A data frame containing a YLT
#' @param rate_adjustments_by_event A matrix of multiplicative adjustments for the Poisson rate.
#' The first column gives the mean rate adjustment and the second column gives the standard deviation of the rate adjustment.
#' Both columns must be of same length as the columns in the input ylt.
#' @param columns2copy Specifies a list of columns to be copied from the original YLT, such as \code{cat}.
#' @param verbose A logical.
#' @param randomday Do you want the days to be randomized or copied?
#' (requires \code{sloss} column). Not implemented yet.
#'
#' @returns
#' A data frame containing the new long YLTs.
#'
#' @details
#' The input mean and standard deviation rate adjustments are used to define a log-normal distribution for each event.
#' The log-normal is used to simulate different rate adjustments for each year.
#' The log-normal adjustments are perfectly correlated between different events.
#'
#' The rate adjustments are specified for all the events in the YLT, in order.
#' The algorithm consists of two parts.
#' In the first part, events may or may not be copied from YLT1 to YLT2, depending on a coin flip,
#' based on a probability derived from the rate adjustment.
#' If there is no adjustment, an event will be copied. If there is a large reduction in the rate,
#' it may well not be copied.
#' YLT1 provides the evid for each event, which is used to determine the rate adjustment.
#' In the second part, events with increasing rates are selected randomly from YLT1 (weighted by the increase),
#' and added to YLT2.
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@gmail.com}
#'
#' @references
#'
#' For the stochastic parameter simulation algorithm see: https://doi.org/10.1007/s00477-023-02409-0
#'
#' and: https://en.wikipedia.org/wiki/Year_loss_table#Incremental_Simulation
#'
#' For the incremental simulation algorithm see: https://doi.org/10.1007/s00477-022-02198-y
#'
#' and: https://en.wikipedia.org/wiki/Year_loss_table#Stochastic_Parameter_YLTs
#'
#' @example man/examples/example_105_yltsurgery.R
#'
#' @export
#'
yltsurgery=function(longylt1,rate_adjustments_by_event,columns2copy=NULL,verbose=FALSE,randomday=TRUE){

	input_checks(longylt1,c("year","evid","loss",columns2copy),"yltsurgery")

	if(verbose)message(" inside yltsurgery")
	debug=TRUE
	debug=FALSE

	ncopy=length(columns2copy)

# make the corresponding shortylt
	shortylt1=ylt_long2short(longylt1)

# convert rate adjustments (which are real mean and sd) to log parameters (logmean and logsd)
	ee=rate_adjustments_by_event[,1]
	vv=rate_adjustments_by_event[,2]
	if(debug)message("ee=",ee[1:7])
	if(debug)message("vv=",vv[1:7])
	ff=1+vv/(ee*ee)
	mu=log(ee/sqrt(ff))
	sg=sqrt(log(ff))
	if(debug)message("mu=",mu[1:7])
	if(debug)message("sg=",sg[1:7])

# note whether day data is included (used later)
	dayflag 	=ifelse("day"%in%colnames(longylt1),TRUE, FALSE)

# set up random days
	if(dayflag&&randomday)alldays=longylt1$day

# initialize
	nevents_in_ylt1=length(longylt1$loss)
	nyears_in_ylt1=length(shortylt1$year)
	extrarate=matrix(0,nevents_in_ylt1)
	if(verbose)message("nevents_in_ylt1=",nevents_in_ylt1)
	if(verbose)message("nyears_in_ylt1=",nyears_in_ylt1)

# longylt outputs
# -since we don't know the final length, and appending in R is slow, I've used the old-fashioned
# -method of just setting aside masses of memory (3x the length of the original YLT).
# -This method would fail if the rates increases are around 3x the original rates, but that's way beyond typical use cases.
# -Ideally, I guess, I would code up the periodic increases method.
	initial_nrows_in_ylt2=nevents_in_ylt1*3
#	message("  initial_nrows_in_ylt2=",initial_nrows_in_ylt2)
	year2	=matrix(0,initial_nrows_in_ylt2)
	ipeid2=matrix(0,initial_nrows_in_ylt2)
	oldyltrow2	=matrix(0,initial_nrows_in_ylt2)
	oldyear2		=matrix(0,initial_nrows_in_ylt2)
	newyltrow2	=matrix(0,initial_nrows_in_ylt2)
	evid2		=matrix(0,initial_nrows_in_ylt2)
	origin2	=matrix(0,initial_nrows_in_ylt2)
	day2	=matrix(0,initial_nrows_in_ylt2)
	loss2=matrix(0,initial_nrows_in_ylt2)
	copydata=matrix(0,ncopy,initial_nrows_in_ylt2)

# loop over the years
	longyltrow2=1
	if(verbose)message(" -simulating...")
	for (j in 1:nyears_in_ylt1){
		if(verbose&&((j%%10000)==0))message(" --simulation year:",j)
		if(debug)message("copy section for year",j)
#
# set up outputs that don't depend on event occurrences, and hence which can be set up now
#
#		year2[j]=j

# for each year, create a single z value, and the actual rate adjustments for all events
# which leads to the changes for different events to be perfectly correlated
		if(debug)message(" simulate z")
		z=rnorm(1)
		actual_rate_adjustments_by_event=exp(mu+z*sg)
		if(debug)message("actual_rate_adjustments_by_event=",actual_rate_adjustments_by_event[1:7])
#
# part 1 of 2 parts: copying
#

#
# if there are events in ylt1 in this year...
#
		nevents_in_year1=shortylt1$nevents_in_year[j]
		if(nevents_in_year1>0){

# extract this year, if there are some events this year
			if(debug)message(" extract year ",j)
			start_row1=shortylt1$longylt_start_row[j]
#
# loop thru all events in that year in YLT1
#
			if(debug)message(" loop thru events in this year in YLT1")
			for (k in 1:nevents_in_year1){
				copythisevent=FALSE
#
# extract information about this event from the ylt
#
				longylt1_row=start_row1+k-1 #this is the row for the event in ylt1
# copying for lowering rates (i.e. rate changes <1)
				if(actual_rate_adjustments_by_event[longylt1_row]<1){
					copyrandom=rbinom(1,1,actual_rate_adjustments_by_event[longylt1_row]);
					if(copyrandom==1){copythisevent=TRUE}
#	copying for same or higher rates (i.e. rate changes >1)
				} else if (actual_rate_adjustments_by_event[longylt1_row]>=1){
					copythisevent=TRUE
				}
				if(copythisevent){
					if(debug)message("copying an event in year:",j,longyltrow2)
# extract event loss
					simloss=longylt1$loss[longylt1_row]
# longylt output
					year2 [longyltrow2]	=j
					loss2[longyltrow2]	=simloss
					oldyear2	[longyltrow2]=longylt1$year[longylt1_row]
					oldyltrow2[longyltrow2]	=longylt1_row
					newyltrow2[longyltrow2]	=longyltrow2
					origin2[longyltrow2]	="copied"
# copy other columns that must exist in the input YLT
					evid2[longyltrow2]	=longylt1$evid[longylt1_row]
#
# and for optional copy columns
#
	if(ncopy>0){
		for (i in 1:ncopy){
			copydata[i,longyltrow2]=noquote(longylt1[longylt1_row,columns2copy[i]])
		}
	}
					longyltrow2=longyltrow2+1;
				}#end of copy event loop
			}#end of loop over events in ylt1 for copying
		} #end of if for >0 events in this year

# note that we're still inside the year loop

#
# part 2 of 2: adding extras
# -calculate extra rate, and then just simulate like in yltsim
#
# calculate extra rate over the whole ylt, just for this one year
		if(debug)message("add",j)
		totalextrarate=0
# without vectorization, this next line increases run-time by 10x
		extrarate=(1/nyears_in_ylt1)*pmax((actual_rate_adjustments_by_event-1),0)
		totalextrarate=sum(extrarate);
		if(debug)	message("totalextrarate=",totalextrarate)
#		message("totalextrarate=",totalextrarate)
#		stop()

# now just do regular simulation for this year, but based on totalextrarate

# simulate total number of extra storms in this year
			nextraevents_in_year2=rpois(1,totalextrarate)

# loop over events in year j (but only if there is at least one event)
# -this is the number of extra events we are putting into year j...nothing to do with ylt1
			if(nextraevents_in_year2>0){
				for (ievent in 1:nextraevents_in_year2){
# select which events will occur in year j
					selectedid=sample(c(1:nevents_in_ylt1),1,prob=extrarate) #note that it's weighted by extrarate now

# get the lossF
					simloss=longylt1$loss[selectedid]

# create output
# longylt output
					year2	[longyltrow2]	=j
					loss2[longyltrow2]	=simloss
					oldyear2	[longyltrow2]=longylt1$year[selectedid]
					oldyltrow2[longyltrow2]	=selectedid
					newyltrow2[longyltrow2]	=longyltrow2
					origin2[longyltrow2]	="added"

# copy over certain other fields if they exist in the YLT
					if(dayflag){
						if(randomday){
							day2	[longyltrow2]=sample(alldays,1)
						} else{
							day2	[longyltrow2]=longylt1$day	 [selectedid]
						}
					}
					evid2[longyltrow2]	=longylt1$evid[selectedid]
#
# and for the optional copy columns
#
	if(ncopy>0){
		for (i in 1:ncopy){
			copydata[i,longyltrow2]=noquote(longylt1[selectedid,columns2copy[i]])
		}
	}

# increment
					longyltrow2=longyltrow2+1

				}#end of loop over events in year j
			}#end of if statement
	}#end of year loop


	if(debug)message("end of simulation loop.")

# format output

	longylt2 =data.frame(	year	=year2	[1:(longyltrow2-1)],
												origin	=origin2	[1:(longyltrow2-1)],
												oldyear	=oldyear2	[1:(longyltrow2-1)],
												oldyltrow	=oldyltrow2	[1:(longyltrow2-1)],
												evid	=evid2	[1:(longyltrow2-1)],
												newyltrow	=newyltrow2	[1:(longyltrow2-1)],
												day		=day2		[1:(longyltrow2-1)],
												loss	=loss2	[1:(longyltrow2-1)])

# and then other random columns as specified by the user
	if(ncopy>0){
		for (i in 1:ncopy){
			longylt2[,columns2copy[i]]=copydata[i,1:(longyltrow2-1)]
		}
	}

# return
	return(longylt=longylt2)

}

#' Applies an hours clause to a long YLT stored in csv file, and returns the adjusted
#' YLT in memory and to a csv file
#'
#' @description
#' Can be called from \code{800_hours_clause_wrapper_example}.
#'
#' @param ipfilename						Input filename containing the input long YLT
#' @param	settingsfilename			Output filename for the settings output
#' @param	opfilename						Output filename containing the output YLT
#' @param nyearsinylt						Number of years in the input YLT
#' @param	hcdays								Hours clause parameter, number of days
#' @param hckm									Hours clause parameter, distance in km
#' @param byregion							Whether to use regions, or distances, to measure closeness
#' @param rust									Rust flag
#' @param rrrr									R flag
#' @param	test									Logical, not sure what it does
#' @param verbose								Logical, meaning obvious
#'
#' @returns
#' A data frame containing the original long YLT, and the adjusted YLTs.
#'
#' @details
#' Just a pretty dumb wrapper, that writes out the settings, reads the input file, checks it,
#' looks at some diagnostics, calls the hours clause routine to
#' apply the hours clause, looks at some diagnostics, writes out the results and returns the results.
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@gmail.com}
#'
#' @example man/examples/example_800_hours_clause_wrapper.R
#'
#' @export
#'
hours_clause_wrapper_ylt=function(ipfilename,settingsfilename,opfilename,nyearsinylt,
	hcdays,hckm,byregion,rust,rrrr,
	test=FALSE,verbose=FALSE){
#
#
# 1 write out the settings
#
	if(verbose)message("1: write out the settings to a csv file")
	hours_clause_write_settings(ipfilename,settingsfilename,opfilename,hcdays,hckm)
#
# 2 read in the input longylt from a csv file
#
	if(verbose)message("2: read the input longylt")
	longylt1=read.csv(ipfilename)
#
# 3 input checks and initialisations
#
	if(verbose)message("3: input checks and initialisations")
	input_checks(longylt1,c("year","day","evid","lat","lon","loss"))
#
# look at some diagnostics on the input ylt
#
	if(verbose){
		message("4: aae and aal for the input ylt:")
#		diaglongylt(longylt1,nyearsinylt)
		ylt_diagnostics_aaeaal_printf(longylt1,nyearsinylt)
	}
#
# comparing the R and rust test the distance routines
# conclusion: they give the same results
#
#	compare_distance_routines(longylt1)
#	compare_time_routines(longylt1)
#	stop()
#
# 5 call the hours clause routine
#
	if(verbose)message("5: make the adjusted ylt")
#	ylt2=hours_clause(longylt1,hcdays,hckm)
	longylt2=hours_clause(longylt1,hcdays,hckm,byregion,rust=rust,rrrr=rrrr,verbose=FALSE)
#
# look at some diagnostics on the adjusted ylt
#
	if(verbose){
		message("6: aae and aal for the adjusted ylt:")
		ylt_diagnostics_aaeaal_printf(longylt2,nyearsinylt)
	}

# look at % changes in aae, aal
#
	if(verbose){
		message("7: aae and aal changes:")
		ylt_diagnostics_aaeaal_change_printf(longylt1,longylt2,nyearsinylt)
	}

#
# 8 write out the new long ylt
#
	if(verbose)message("8: write out the new longylt")
#	write.csv(ylt2$longylt,file=opfilename,row.names=FALSE)
	write.csv(longylt2,file=opfilename,row.names=FALSE)
#
# 9 return
#
	if(verbose)message("9: and return")
#	return(list(longylt1=longylt1,ylt2=ylt2))
	return(list(longylt1=longylt1,longylt2=longylt2))
}

#' Simulates a long YLT from a Poisson ELT
#'
#' @description
#' Simulates a long YLT (long format year loss table) from an ELT (event loss table)
#' using the Poisson distribution,
#' with or without secondary uncertainty.
#' Copies standard columns by default, and extra columns if asked to. 
#' Previous versions included the short YLT, but now the idea is that this routine
#' just produces the longylt, and \code{ylt_long2short} can be used to generate
#' the shortylt if it is required.
#' 
#' @param nyearsinylt	The number of years of simulation required.
#' @param elt			A data frame containing the ELT.
#' Must contain \code{evid}, \code{mrate} and \code{mloss} columns, at least.
#' @param columns2copy Which extra columns to copy
#' @param verbose A logical.
#' @param secuncb A logical to indicate whether secondary uncertainty should be simulated.
#' Requires \code{sloss} and \code{expo} columns.
#'
#' @returns
#' A data frame containing a long YLT.
#'
#' @details
#' Uses Poisson simulation.
#'
#' The ELT data frame must contain the following two columns
#'\itemize{
#'\item \code{evid:  } The event ids
#'\item \code{mloss: } The mean losses by event
#'\item \code{mrate: } The mean rates by event (can be constant if appropriate).
#'}
#'
#' If secondary uncertainty is required, the ELT data frame must also contain
#' the following two columns:
#'\itemize{
#'\item \code{sloss: } The standard deviation of losses by event
#'\item \code{expo: }  The exposure by event
#'}
#'
#' The following columns will be passed through into the output YLT.
#'\itemize{
#'\item \code{evid: } 
#'\item \code{mloss:} 	
#'}
#' Other columns can be passed thru if they are specified (see the example).
#'
#' The whole issue of event ids is complicated. Here's what I do:
#'\itemize{
#'\item \code{evid: } 	The event id. This will have
#'whatever numbers it had in the ELT. They don't have to start from one.
#'This might end up
#'repeated in the YLT, if the simulations end up repeating that event.
#'\item \code{eltrow: } 	I number the events in the ELT from 1. This is that number.
#'This might end up
#'repeated in the YLT, if the simulations end up repeating that event.
#'\item \code{yltrow: } 	I number the events in the YLT from 1. This is that number.
#'This will not repeat in the YLT, even if two events are the same.
#'So this is just the row in the YLT.
#' }
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@gmail.com}
#'
#' @seealso
#'\itemize{
#'\item \code{yltsim_inc: } 	YLT simulation, but incrementally.
#'\item \code{yltreduce: } 		YLT length reduction
#'\item \code{eltmerge: }  A routine for merging historical and model ELTs
#'\item \code{catxl: }  A routine for evaluating catxl towers.
#'}
#'
#' @example man/examples/example_100_yltsim.R
#'
#' @export
#'
yltsim=function(nyearsinylt,elt,columns2copy=NULL,verbose=FALSE,secuncb=FALSE){

	if(verbose)message(" inside yltsim\n")
	if(verbose)message(" -simulating",nyearsinylt,"nyearsinylt\n")

# checks
	input_checks(elt,c("evid","mrate","mloss",columns2copy))
	evidflag	=ifelse("evid"%in%colnames(elt),TRUE, FALSE)

	ncopy=length(columns2copy)

# secunc related
	slossflag =ifelse("sloss"%in%colnames(elt),TRUE, FALSE)
	expoflag	=ifelse("expo"%in%colnames(elt),TRUE, FALSE)
	if((secuncb)&&(!slossflag)){message("You've selected secunc, but not provided sloss...exiting\n");stop()}
	if((secuncb)&&(!expoflag)){message("You've selected secunc, but not provided expo...exiting\n");stop()}
	if(secuncb){
#		betaparams=calcbeta(elt$mloss,elt$sloss,elt$expo)
#		betaparams=calc_beta_params(elt$mloss,elt$sloss,elt$expo)
		elt2=calc_beta_params(elt)
		eventalpha=elt2$eventalpha
		eventbeta	=elt2$eventbeta
		expo=elt$expo
	}

# calculate total annual rate
	totalrate=sum(elt$mrate)
	if(verbose)message(" -total annual rate (aka mean # per year)=",totalrate,"\n")

# simulate number of storms in each year,
	nevents_in_year=rpois(nyearsinylt,totalrate)
#	message("nevents_in_year=",nevents_in_year,"\n")

# calculate total number of events and number of simulated nevents_in_elt
	nevents_in_elt=length(elt$mrate)
	nsimevents=sum(nevents_in_year)
#	message("nsimevents=",nsimevents,"\n")

#	message(" -number of simulated storms per year=",nevents_in_year,"\n")
	if(verbose)message(" -total number of simulated storms=",nsimevents,"\n")

# initialize
# shortylt
#	yearshort=matrix(0,nyearsinylt)
#	loss_in_year=matrix(0,nyearsinylt)
#	max_loss_in_year=matrix(0,nyearsinylt)
#	longylt_start_row=matrix(0,nyearsinylt)
# longylt
	longyltrow=1
	yearlong=matrix(0,nsimevents)
	yltrow=matrix(0,nsimevents)
	eltrow=matrix(0,nsimevents)
	evid	=matrix(0,nsimevents)
#	eltid	=matrix(0,nsimevents)
	expo2	=matrix(0,nsimevents)
	loss	=matrix(0,nsimevents)
	mloss	=matrix(0,nsimevents)
	sloss	=matrix(0,nsimevents)
	copydata=matrix(0,ncopy,nsimevents)

# loop over years
	if(verbose)message(" -simulating...\n")
	for (j in 1:nyearsinylt){
		if(verbose&&((j%%10000)==0))message(" --simulation year:",j,"\n")
#		yearshort[j]=j
#		longylt_start_row[j]=longyltrow #but only increment if there is actually an event

# loop over events in year j (but only if there is at least one event)
		if(nevents_in_year[j]>0){
			for (ievent in 1:nevents_in_year[j]){
# select which events will occur in year j
				selectedid=sample(c(1:nevents_in_elt),1,prob=elt$mrate)

# create a loss for the selected event
				if(secuncb){
					simloss=expo[selectedid]*rbeta(1,eventalpha[selectedid],eventbeta[selectedid]);
				} else {
					simloss=elt$mloss[selectedid]
				}

# create output
#				loss_in_year[j]=loss_in_year[j]+simloss  	1					#total loss in year j
#				max_loss_in_year[j]=max(max_loss_in_year[j],simloss)	#max loss in year j
# longylt output
#				message("j,longyltrow=",j,longyltrow,elt$lfreg[selectedid],"\n")
				yearlong[longyltrow]=j
				yltrow	[longyltrow]=longyltrow
				eltrow	[longyltrow]=selectedid
				mloss		[longyltrow]=elt$mloss[selectedid]
				loss		[longyltrow]=simloss

# copy over certain other fields if they exist in the ELT
#				if(evidflag) eltid[longyltrow]=elt$evid [selectedid]
				if(evidflag) evid	[longyltrow]=elt$evid [selectedid]
				if(slossflag)sloss[longyltrow]=elt$sloss[selectedid]
				if(expoflag) expo2[longyltrow]=elt$expo [selectedid]

#
# and for the copy variables
#
	if(ncopy>0){
		for (i in 1:ncopy){
			copydata[i,longyltrow]=elt[selectedid,columns2copy[i]]
		}
	}

# increment
				longyltrow=longyltrow+1

			}#end of loop over events in year j
	  } else { #if no events in the year
#		  	longylt_start_row[j]=NA
	  }#end of if statement
  }#end of loop over all years


# format output
#	shortylt=data.frame(year=yearshort,longylt_start_row,nevents_in_year,loss_in_year,max_loss_in_year)
	expo=expo2

# start with some essentials
	longylt=data.frame(year=yearlong,yltrow,eltrow)
# then some optionals
#	if(evidflag)longylt["eltid"]=evid
	if(evidflag)longylt["evid"]=evid
	if(expoflag)longylt["expo"]=expo
# then some more essentials
	longylt["mloss"]=mloss
	longylt["loss"]=loss
# then antoher optional
	if(slossflag)longylt["sloss"]=sloss

# and then other random columns as specified by the user
	if(ncopy>0){
		for (i in 1:ncopy){
			longylt[,columns2copy[i]]=copydata[i,]
		}
	}

# note that eltrow just numbers the events from 1...nevents in the order they occur in the input elt
# yltrow is the row in the longylt
# while the eltid can be anything from the vendor, which doesn't necessarily occur in order (although often do)

# return
	return(longyly=longylt)
#	output=list(	shortylt=shortylt,
#								longylt=longylt)
}

#' Converts rate adjustments from cat to event, for events in an ELT
#'
#' @description
#' Converts rate adjustments by cat to rate adjustments by event.
#' So that you can specify rate adjustments by cat (which is easy to do),
#' and then run this routine to assign those adjustments to all the events
#' in an ELT.
#'
#' @param elt			A data frame containing the ELT. Requires \code{cat}.
#' @param rate_adjustments_by_cat		A list of two vectors containing the mean and sd adjustments by cat,
#' given by \code{adjustments_by_cat$mn}, \code{adjustments_by_cat$sd}
#'
#' @returns
#' A matrix with the adjustments by event
#' column 1 is the mean of the adjustments.
#' column 2 is the sd of the adjustments.
#'
#' @details
#' Doesn't do anything except just copy the adjustments. No calculations.
#' Cat is a positive integer.
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_422_elt_rate_adjustments_cat_2_event.R
#'
#' @export
#'
elt_rate_adjustments_cat_2_event=function(elt,rate_adjustments_by_cat){

	input_checks(elt,c("cat"),"rate_adjustments_elt_cat_2_event")

  neventsinelt=length(elt$cat)
  rate_adjustments_by_event=matrix(0,neventsinelt,2)
  maxcat=length(rate_adjustments_by_cat$mn)
  for (ie in 1:neventsinelt){
  	cat=elt$cat[ie]
  	if(cat>maxcat){
  		message("some cats exceed the length of the specified mean adjustments, so stopping.")
  		message("...for event",ie)
  		message("...which has cat",cat)
  		message("...while the max cat specified is",maxcat)
  		stop()
  	}
# old: my cats run from -1 to 5, so need to add 2 to make it an index
#  	rate_adjustments_by_event[ie,1]=rate_adjustments_by_cat$mn[cat+2]
#  	rate_adjustments_by_event[ie,2]=rate_adjustments_by_cat$sd[cat+2]
# new:
  	rate_adjustments_by_event[ie,1]=rate_adjustments_by_cat$mn[cat]
  	rate_adjustments_by_event[ie,2]=rate_adjustments_by_cat$sd[cat]
  }

  return(rate_adjustments_by_event)
}

#
filename=tempfile(fileext=".csv")
#
int=3
#
write.csv(int,file=filename,row.names=FALSE)
#
int2=filetest(filename)
#
message("temporary file name = ",filename)
message("before = ",int," and after = ",int2[1,1])

#
# 1 create a 10 year YLT
# -2 regions
# -7 cats
#
cat("1. longylt:\n")
year	=c(1,1,1,2,2,3,3,4,4,4)
cat		=c(-1,0,1,2,3,4,5,5,5,5)
region=c(1,1,1,1,1,2,2,2,2,2)
longylt=data.frame(year,cat,region)
print(head(longylt))
#
# 2 make adjustments
#
mn=matrix(0,2,7)
for (i in 1:2){
	for (j in 1:7){
		mn[i,j]=(i-1)*cat[j]+cat[j]
	}
}
sd=matrix(0,2,7)
ratesbycatreg=list(mn=mn,sd=sd)
# 3 convert adjustments
#
adj=ylt_rate_adjustments_catreg_2_row(longylt,ratesbycatreg)
print(head(adj))

#
# 1 set the hours clause settings
#
hcdays=15
hckm=200
#
# 2 make a single year of a ylt
#
cat("1. make longylt:\n")
nyearsinylt=8
nevents_in_year1=10
thisyearloss	=seq(10,55,5)
thisyearday		=c(1	,2	,51	,101,151,201,251,300,350,360)
thisyearlat		=c(10	,11	,30	,30	,30	,30	,30	,30	,30	,50)
thisyearlon		=c(10	,11	,30	,30	,30	,30	,30	,30	,30	,50)
thisyearregion=rep("A",nevents_in_year1)
#
# 3 apply the hours clause routine to position 1
#
cat("1. apply the hours clause calculator:\n")
output=hours_clause_apply_part2(hcdays,hckm,byregion=FALSE,thisyearloss,
				thisyearday,thisyearlon,thisyearlat,thisyearregion,
				nevents_in_year1,k=1)
#
# 4 look at the output
#
cat("losses=",output$temploss,"\n")
cat("hccounter=",output$hccounter,"\n")

#' Calculates AAE and AAL from an ELT
#'
#' @description
#' Calculates AAE and AAL from an ELT,
#' taking into account an input matrix of stochastic parameter adjustments by cat and event.
#' It doesn't produce an adjusted ELT, just gives the AAE and AAL you would get.
#' It could, for instance, be used to test code that produces adjusted YLTs.
#'
#' @param elt											A data frame containing the ELT.
#' The ELT must contain \code{mrate}, \code{mloss} and \code{cat} columns.
#'
#' @param adjustmentsbycatevent		A matrix with rate adjustments (cat 1-ncat, event)
#' An adjustment of 1 means no change.
#' Copes with any number of cats, set by the first dimension of this matrix.
#'
#' @details
#' For historical reasons the adjustments are stored in a matrix by cat-event, not just by event,
#' which is a bit inefficient.
#' I could change that at some point.
#'
#' @returns
#' AAE and AAL.
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_412_elt_diagnostics_aaeaal_with_adj.R
#'
#' @export
#'
elt_diagnostics_aaeaal_with_adj=function(elt,adjustmentsbycatevent){

input_checks(elt,c("mrate","mloss","cat"),"adj_elt_diagnostics")

stopifnot(length(dim(adjustmentsbycatevent))==2)

ncat=dim(adjustmentsbycatevent)[1]

# calculates diagnostics for an adjusted elt (adjusted with stochastic parameters)

	nevents=length(elt$mloss)

	meansim=matrix(0,ncat) 		#mean event rate adjustment by cat...comes up in some analytical formulas
	varsim=matrix(0,ncat)			#mean event rate adjustment by cat...comes up in some analytical formulas
	er=matrix(0,ncat,nevents)	#base event rates by cat
	erl=matrix(0,ncat,nevents)	#total event rates by cat, weighted by mloss

# extract from the input elt
	sevent_rate=elt$mrate
	sevent_loss=elt$mloss

	for (i in 1:ncat){
		meansim[i]=mean(adjustmentsbycatevent[i,])
		varsim[i]=var(adjustmentsbycatevent[i,])
#		er[i,]=sevent_rate*flagsm15[i,]
#		erw[i,]=sevent_rate*flagsm15[i,]*sevent_ws
#		erl[i,]=sevent_rate*flagsm15[i,]*sevent_loss
		er[i,]=sevent_rate*as.numeric(elt$cat[]==i)
		erl[i,]=sevent_rate*sevent_loss*as.numeric(elt$cat[]==i)
	}

	ser=matrix(0,ncat)				#total event rates by cat
	serl=matrix(0,ncat)			#total event rates by cat, loss weighted

	for (i in 1:ncat){
		ser[i]=sum(er[i,])
		serl[i]=sum(erl[i,])
	}

# now combine the simulated adjustments with the input event set to estimate first adjusted aae, aal
	aae=sum(meansim*ser)
	aal=sum(meansim*serl)

	return(list(AAE=aae,AAL=aal))

}

#' Prints AAE and AAL from a YLT to the screen
#'
#' @description
#' Just a way to print the results from \code{ylt_diagnostics_aaeaal_by_catf}
#' to the screen in a pretty way.
#'
#' @param longylt				The YLT
#' @param nyearsinylt		The number of years in the YLT.
#' @param mincat  			The minimum cat that is counted
#' @param maxcat  			The maximum cat that is counted
#' @param verbose				Logical
#'
#' @returns
#' Prints changes in AAE, AAL to the screen
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_584_ylt_diagnostics_aaeaal_by_cat_printf.R
#'
#' @export
ylt_diagnostics_aaeaal_by_cat_printf=function(longylt,nyearsinylt=0,mincat,maxcat,verbose=FALSE){

		message("*: AAE by cat")
		ncat=1+maxcat-mincat
		if((ncat<5)||(ncat>7)){
			message("For the routine ylt_change_diagnostics_aaeaal_by_cat_print, ncat must be 5,6 or 7")
			stopi()
		}

		y1=ylt_diagnostics_aaeaal_by_catf(longylt,nyearsinylt,mincat=mincat,maxcat=maxcat)
		if(verbose)message("dim(y1)=",dim(y1$AAEbycat),"")
		y1e=y1$AAEbycat
		y1a=y1$AALbycat


		df=t(data.frame(round(y1e,digits=2)))
		if(verbose)message("dim(df)=",dim(df),"")
		row.names(df)=c("   ylt")
# note the all cat at the end...that's returned from the routine above...without that the dimensions would be wrong
		if(ncat==5)colnames(df)=c("  cat 1","  cat 2","  cat 3","  cat 4","  cat 5","all cat")
		if(ncat==6)colnames(df)=c("  cat 0","  cat 1","  cat 2","  cat 3","  cat 4","  cat 5","all cat")
		if(ncat==7)colnames(df)=c("  cat-1","  cat 0","  cat 1","  cat 2","  cat 3","  cat 4","  cat 5","all cat")
# 2CRAN: please don't disallow this usage of print. This whole function is to print nice output to the screen by choice
		print(df)
		message("")

		message("*: AAL by cat")
		df=t(data.frame(round(y1a,digits=0)))
		row.names(df)=c("   ylt")
		if(ncat==5)colnames(df)=c("  cat 1","  cat 2","  cat 3","  cat 4","  cat 5","all cat")
		if(ncat==6)colnames(df)=c("  cat 0","  cat 1","  cat 2","  cat 3","  cat 4","  cat 5","all cat")
		if(ncat==7)colnames(df)=c("  cat-1","  cat 0","  cat 1","  cat 2","  cat 3","  cat 4","  cat 5","all cat")
# 2CRAN: please don't disallow this usage of print. This whole function is to print nice output to the screen by choice
		print(df)
		message("")

}

#
# 1 make YLT1
#
cat("1. make ylt1:\n")
year=c(1,1,1,2,2,3,3,3)
loss=seq(10,80,10)
cat=c(1,1,1,2,2,3,4,5)
longylt1=data.frame(year,loss,cat)
#
# 2 make YLT2
#
cat("1. make ylt2:\n")
year=c(1,1,2,2,2,2,3,3)
loss=seq(20,90,10)
cat=c(1,1,1,2,2,3,4,5)
longylt2=data.frame(year,loss,cat)
#
# look at changes
#
cat("calling ylt_change_diagnostics_aaeaal_by_cat_print:\n")
ylt_diagnostics_aaeaal_by_cat_change_printf(longylt1,longylt2,mincat=1,maxcat=5)

#' Calculates AAE and AAL from an ELT
#'
#' @description
#' Calculates AAE and AAL from an ELT
#'
#' @param elt			A data frame containing the ELT.
#' The ELT must contain \code{mrate} and \code{mloss} columns.
#' See the example for how to make the ELT.
#'
#' @returns
#' AAE and AAL.
#' EP curves are in a separate routine \code{epfromelt3}.
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_410_elt_diagnostics.R
#'
#' @export
#'
elt_diagnostics_aaeaal=function(elt){

input_checks(elt,c("mrate","mloss"),"elt_diagnostics")

AAE=sum(elt$mrate)
AAL=sum(elt$mloss*elt$mrate)

list(AAE=AAE,AAL=AAL)

}

#' Make an ELT in memory
#'
#' @description
#' This code does nothing at all. But the example shows how to make an ELT in memory.
#'
#' @returns
#' Nothing.
#'
#' @details
#' This code just exists as a way to present the example.
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@gmail.com}
#'
#' @example man/examples/example_003_make_elt.R
#'
#' @export
#'
make_elt=function(){
	message("This code does nothing.\n")
	message("It just exists as a way to present the example.\n")
}

#' When using \code{hours_clause_wrapper}, writes out the settings to a file.
#'
#' @description
#' Just for record keeping.
#'
#' @param ipfilename						Input filename containing the input long YLT
#' @param	settingsfilename			Output filename for the settings output
#' @param opfilename						Output filename containing the input long YLT
#' @param	time									Hours clause parameter, number of days
#' @param distance							Hours clause parameter, distance in km
#'
#' @returns
#' Just writes to a file
#'
#' @details
#' Just to provide a record of each analysis.
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@gmail.com}
#'
#' @references
#' x
#'
#' @example man/examples/example_805_hours_clause_write_settings.R
#'
#' @export
#'
hours_clause_write_settings=function(ipfilename,settingsfilename,opfilename,time,distance){

	row=matrix(0,5)
	row[ 1]="Your selections:"
	row[ 2]=paste("IPfilename=,",ipfilename)
	row[ 3]=paste("OPfilename=,",opfilename)
	row[ 4]=paste("Time=,",time)
	row[ 5]=paste("Distance=,",distance)
	write.table(row,settingsfilename,row.names=FALSE,quote=FALSE,col.names=FALSE)

}

#
# make an elt
#
set.seed(1)
evid=c(1,2,3)
mrate=seq(0.1,0.3,0.1)
mloss=seq(100,300,100)
elt=data.frame(evid,mrate,mloss)
print(elt)
#
# and check if it contains the two columns
#
input_checks(elt,c("evid","mrate","mloss"))
#

#' An example workflow for applying \code{ylt_surgery_groups} or \code{ylt_surgery_groups} to NAHU.
#'
#' @description
#' Shows how to take a YLT (that must have wspd, lat and lon columns) and apply climate
#' change adjustments.
#'
#' @param type_of_analysis		"groups" or "notgroups"
#' @param ipfilename					ipfilename
#' @param settingsfilename		settingsfilename
#' @param ylt_opfilename			ylt_opfilename
#' @param results_opfilename	results_opfilename
#' @param nyearsinylt					nyearsinylt
#' @param rcp									rcp
#' @param baseyear1						baseyear1
#' @param baseyear2						baseyear2
#' @param targetyear					targetyear
#' @param k2020settings				k2020settings
#' @param frequnc							frequnc
#' @param quantile						quantile
#' @param units								units
#' @param randomseed					randomseed
#' @param manual							manual
#' @param manualadjustments		manualadjustments
#' @param mincat						  The minimum cat that is counted
#' @param maxcat  						The maximum cat that is counted
#' @param test								test
#' @param verbose							verbose
#'
#' @returns
#' Returns the two YLTs (each consisting of a long and short ylt),
#' and writes the new longylt to a csv file.
#'
#' @details
#'
#' The sections in the code are as follows:
#'
#' 1-writes out the settings to a csv file, for future reference
#'
#' 2-reads an input longylt from the file ipfilename
#'
#' 3-makes some input checks, to make sure the right columns are available in the input file
#'
#' 4-uses the wspd column to add a cat column to the longylt (from 1 to 7, which is cat -1 to 5)
#' (change this line if you want to make adjustments based on some other feature of the events)
#'
#' 5-uses the lon lat columns to add global region as a column to the longylt (regions from 1 to 18, from the Jewson BAMS paper)
#' (change this line if you want to use different regions)
#'
#' 6-looks at some diagnostics on the input ylt
#'
#' 7-sets up the GMST scenarios
#' (change this line if you want to use different GMST scenarios)
#'
#' 8-sets up the rates changes from the BAMS article supporting material on zenodo
#' (change this line if you want to use different rate changes)
#'
#' 9-does the temporal interpolation based on the input options, GMST scenarios, and zenodo rates
#'
#' 10-converts the adjustments from “by reg-cat” to “by-event”, so they are ready to apply to the ylt
#'
#' 11-defines groups in a certain way...currently just by cat)
#' (change this line if you want to define groups differently)
#'
#' 12-actually does the adjustment, and makes a new ylt
#'
#' 13-makes joint ylts from the input and results
#'
#' 14-looks at some diagnostics for the new ylt
#'
#' 15-looks at AAE, AAL change diagnostics
#'
#' 16-looks at AAE, AAL change diagnostics, now by cat
#'
#' 17-writes out the new longylt to a csv file
#'
#' 18-returns
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@gmail.com}
#'
#' @example man/examples/example_201_nahu_ylt_surgery.R
#'
#' @export
#'
nahu_ylt_surgery=function(type_of_analysis,ipfilename,settingsfilename,ylt_opfilename,results_opfilename,nyearsinylt,
	rcp,baseyear1,baseyear2,targetyear,k2020settings,frequnc,quantile,units,randomseed,
	manual,manualadjustments,mincat,maxcat,
	test=FALSE,verbose=FALSE){
#
# This code applies 'yltsurgery' to a ylt.
# It produces a new ylt, which is similar to the input ylt, but with individual events
# deleted or duplicated, in order to make the required adjustments
#
# The sections in the code are as follows:
#	1-writes out the settings to a csv file
# 2-reads an input longylt
# 3-makes some input checks
# 4-uses the wspd column to add a cat column to the longylt (from 1 to 7, which is cat -1 to 5)
# 5-uses the lon lat to add global region as a column to the longylt (regions from 1 to 18, from my BAMS paper)
# 6-sets up the GMST scenarios
# 7-sets up the rates from the zenodo
# 8-does the temporal interpolation based on input options, GMST and zenodo rates
# 9-converts adjustments from reg-cat to by-event
# 10-uses yltsurgery to make the adjusted ylt based on the by-event adjustments
# 11-writes out the new ylt
#
# 0 set the seed
#
	set.seed(randomseed)
#
# 1 write out the settings
#
	if(verbose)message("1: write out the settings to a csv file")
	nahu_write_settings(ipfilename,settingsfilename,rcp,baseyear1,baseyear2,targetyear,
		k2020settings,frequnc,quantile,randomseed,manual,manualadjustments)
#
# 2 read in the input longylt from a csv file
#
	if(verbose)message("2: read the input longylt")
	longylt1=read.csv(ipfilename)
#
# 3 do some input checks
#
	if(verbose)message("3: input checks")
	input_checks(longylt1,c("year","loss","wspd","lflat","lflon"),"nahu_ylt_surgery_groups")
#
# 4 add cat as a column (uses windspeed column to assign cat from -1 to 5)
#
	if(verbose)message("4: add cat as a new column in the ylt, based on wspd")
	longylt1=ylt_add_cat_2_longylt(longylt1,units)

# 5 add region as a column (based on lon lat)
#
	if(verbose)message("5: add region as a new column in the ylt, based on lflat,lflon")
	longylt1=ylt_add_region_2_longylt(longylt1)
#
# 6 look at some diagnostics on the input ylt
#
	if(verbose){
		message("6: aae and aal for the input ylt:")
		ylt_diagnostics_aaeaal_printf(longylt1,nyearsinylt)
	}
#
# 7 set up the gmst scenarios
#
	if(verbose)message("7: set up the gmst scenarios")
	gmst=nahu_define_gmst_scenarios(verbose)
#
# 8 set up the rates from zenodo
# -for the landfall model only at this point, although could extend easily
# -returns landfallmodel[19 regions,2 mean/sd,7 cats]
# -these are for 2 deg C
	if(verbose)message("8: set up the rate adjustments, from the zenodo files related to the BAMS paper")
	landfallmodel=nahu_define_k2020_zenodo_landfall_adj()
#
# 9 do the temporal interpolation based inputs, gmst and zenodo rates, and return rates changes by type
# -returns ratesbycatreg$mn1[19,7], $sd1
	if(verbose)message("8: do the temporal interpolation based on inputs, gmst and zenodo rates")
	ratesbycatreg=nahu_k2020_rates_interpolation(rcp,baseyear1,baseyear2,targetyear,
										k2020settings,frequnc,quantile,randomseed,
										gmst,landfallmodel,test,verbose,reflectinputs=FALSE)
#
# 10 convert those mean/sd adjustments by reg-cat into mean/sd adjustments by event
# -because that's what the various routines need
#
	if(verbose)message("9: convert adjustments to adjustments by event")
	if(manual){
		rate_adjustments_by_row=ylt_rate_adjustments_cat_2_row(longylt1,manualadjustments)
	} else {
		rate_adjustments_by_row=ylt_rate_adjustments_catreg_2_row(longylt1,ratesbycatreg)
	}
#
# 11 make groups...which have to be cat and region, at least
#
# this weird equation gives each event a group based on its cat and region
# for 7 cats, and regions. It works for 19 regions, although NAHU only uses 1 to 4.
# method 1, that uses regions
#	groups=(longylt1$cat+2)+7*(longylt1$region-1)
# method 2, that just uses cats
	groups=(longylt1$cat+2)
#
# 12 make an adjusted ylt using ylt surgery *************************************************
#
	if(verbose)message("12: make the adjusted ylt using ylt surgery")

#	ylt2=yltsurgery_groups_v1(longylt1,rate_adjustments_by_row,groups)

	if(type_of_analysis=="groups"){
		longylt2=yltsurgery_groups(longylt1,rate_adjustments_by_row,groups,
			columns2copy=c("wspd","lflat","lflon","cat","region"))
	} else {
		longylt2=yltsurgery(longylt1,rate_adjustments_by_row,
			columns2copy=c("wspd","lflat","lflon","cat","region"))
	}

#
# 13 put the results into joint ylts, for some of the subsequent returns, and for returning
#
#	message("13: make joint ylts, with both short and long ylts")
#	ylt1=list(shortylt=ylt_long2short(longylt1),longylt=longylt1) #this diag routine needs a combined short and long ylt
#	ylt2=list(shortylt=ylt_long2short(longylt2),longylt=longylt2) #this diag routine needs a combined short and long ylt

#
# 14 look at some diagnostics on the adjusted ylt
#
	if(verbose){
		message("14: nevents, aae and aal for the adjusted ylt:")
		ylt_diagnostics_aaeaal_printf(longylt2,nyearsinylt)
	}
#
# 15 look at % changes in aae, aal
#
	if(verbose){
		message("15: look at % changes in aae, aal")
		ylt_diagnostics_aaeaal_change_printf(longylt1,longylt2,nyearsinylt)
	}
#
# 16 look at pc changes in AAE and AAL by cat
#
	if(verbose){
		message("16: look at % changes in aae, aal by cat")
		ylt_diagnostics_aaeaal_by_cat_change_printf(longylt1,longylt2,mincat,maxcat)
	}
#
# 17 write out the new long ylt at a csv file
#
	if(verbose)message("17: write out the new longylt")
	write.csv(longylt2,file=ylt_opfilename,row.names=FALSE)
#
# ** optional code to write out results to a csv file
#
#	message("***************** csv results ****************")
#	sink(results_opfilename)
#		writeresults2csv(ylt1,ylt2)
#	closeAllConnections()

#
# 18 returns both ylts
#
	return(list(longylt1=longylt1,longylt2=longylt2))
#	return(list(ylt1=ylt2,ylt2=ylt2))

}

#' Prints changes in AAE and AAL from a two YLTs to the screen
#'
#' @description
#' Only works for the case where there are *exactly* 5 cats in both YLTs.
#' Which is a bit limiting. Could improve that I guess.
#'
#' @param longylt1		A data frame containing YLT1
#' @param longylt2		A data frame containing YLT2
#' @param mincat  		The minimum cat that is counted
#' @param maxcat  		The maximum cat that is counted
#' @param nyearsinylt	Number of years in the YLT
#' @param verbose			Logical
#'
#' @returns
#' Prints changes in AAE, AAL to the screen
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_585_ylt_diagnostics_aaeaal_by_cat_change_printf.R
#'
#' @export
ylt_diagnostics_aaeaal_by_cat_change_printf=function(longylt1,longylt2,mincat,maxcat,nyearsinylt=0,verbose=FALSE){

		message("*: Event numbers by cat, and % changes")
		ncat=1+maxcat-mincat
		if((ncat<5)||(ncat>7)){
			message("For the routine ylt_change_diagnostics_aaeaal_by_cat_print, ncat must be 5,6 or 7")
			stopi()
		}

		y1=ylt_diagnostics_aaeaal_by_catf(longylt1,nyearsinylt,mincat=mincat,maxcat=maxcat)
		if(verbose)message("dim(y1)=",dim(y1$AAEbycat),"")
		y1e=y1$AAEbycat
		y1a=y1$AALbycat

		y2=ylt_diagnostics_aaeaal_by_catf(longylt2,nyearsinylt,mincat=mincat,maxcat=maxcat)
		y2e=y2$AAEbycat
		y2a=y2$AALbycat

		df=t(data.frame(round(y1e,digits=2),round(y2e,digits=2),round(100*(y2e-y1e)/y1e,digits=2)))
		if(verbose)message("dim(df)=",dim(df),"")
		row.names(df)=c("   ylt1","   ylt2","   % change")
# note the all cat at the end...that's returned from the routine above...without that the dimensions would be wrong
		if(ncat==5)colnames(df)=c("  cat 1","  cat 2","  cat 3","  cat 4","  cat 5","all cat")
		if(ncat==6)colnames(df)=c("  cat 0","  cat 1","  cat 2","  cat 3","  cat 4","  cat 5","all cat")
		if(ncat==7)colnames(df)=c("  cat-1","  cat 0","  cat 1","  cat 2","  cat 3","  cat 4","  cat 5","all cat")
		print(df)
		message("")

		message("*: Loss by cat, and % changes")
		df=t(data.frame(round(y1a,digits=0),round(y2a,digits=0),round(100*(y2a-y1a)/y1a,digits=2)))
		row.names(df)=c("   ylt1","   ylt2","   % change")
		if(ncat==5)colnames(df)=c("  cat 1","  cat 2","  cat 3","  cat 4","  cat 5","all cat")
		if(ncat==6)colnames(df)=c("  cat 0","  cat 1","  cat 2","  cat 3","  cat 4","  cat 5","all cat")
		if(ncat==7)colnames(df)=c("  cat-1","  cat 0","  cat 1","  cat 2","  cat 3","  cat 4","  cat 5","all cat")
		print(df)
		message("")

}

#' Testing using files
#'
#' @description
#' This is just a test function to illustrate how to open files in functions
#' inside a package.
#' 
#' @param filename	the filename
#'
#' @returns
#' an integer read in from the file
#'
#' @details
#' The answer to: how can I open a file in a function in a R package, 
#' and test that using an example?
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@gmail.com}
#'
#' @example man/examples/example_001_filetest.R
#'
#' @export
#'
filetest=function(filename){
	int=read.csv(filename)
	return(int)
}

#' Calculates AAE and AAL from an ELT, and by cat
#'
#' @description
#' Calculates AAE and AAL from an ELT, and AAE and AAL by cat.
#' There can be any number of cats, labelled using integers.
#' So this routine is not only applicable to hurricane: the cat can indicate anything, for any peril.
#'
#' @param elt			A data frame containing the ELT.
#' Must contain \code{mrate}, \code{mloss} and \code{cat} columns.
#' See the example for how to make the ELT.
#'
#' @returns
#' A list containing AAE and AAL, and then AAE and AAL by cat.
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_411_elt_diagnostics_aaeaal_by_cat.R
#'
#' @export
#'
elt_diagnostics_aaeaal_by_cat=function(elt){

input_checks(elt,c("mrate","mloss","cat"),"elt_diagnostics_by_cat")

ncat=max(elt$cat)

AAEbycat=matrix(0,ncat)
AALbycat=matrix(0,ncat)

df=elt
df$mlossrate=(elt$mloss)*(elt$mrate)

for (ic in 1:ncat){
	AAEbycat[ic]=sum(elt[elt$cat==ic, "mrate"])
	AALbycat[ic]=sum(df[df$cat==ic, "mlossrate"])
}
AALbycatpc=100*AALbycat/sum(df$mlossrate)

list(AAEbycat=AAEbycat,AALbycat=AALbycat,AALbycatpc=AALbycatpc)

}

#
# 1 create losses
#
message("1. make losses")
losses=seq(1,1000,1)
#
# 2 set the return periods to look at
#
rps=c(2,3,4,5,10,20,50,100)
#
#
message("2. calculate the losses at the given return levels")
ep=make_ep_by_sorting(losses,rps)
print(ep)
#
message("3. calculate the sd of the uncertainty around those losses")
epsd=bootstrap_ep_uncertainty(losses,nbs=100,rps)
#
print(epsd)

#
# create an elt
#
evid=c(1,2,2,3,3,3,4,4,4,4) #evid is required
#mloss is not required, but is processed intelligently
mloss=rep(1,10)
#jim is not required, but is copied because we specify that
jim=c(1000:1009)
bob=c(2000:2009)
#
elt1=data.frame(evid,mloss,jim,bob)
elt2=elt_collapse_regions(elt1,columns2copy=c("jim"),verbose=TRUE)
#
message("elt1=\n")
print(elt1)
message("elt2=\n")
print(elt2)

#' Function for testing that R and Rust give the same distances between events
#'
#' @description
#' This isn't actually used for anything, except doing this test.
#' But it's an important test. Getting R and Rust to agree was difficult.
#'
#' @param	longylt				Input YLT
#'
#' @returns
#' Writes mismatches to the screen.
#' Always stops.
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@gmail.com}
#'
#' @example man/examples/example_806_hours_clause_compare_distance_routines.R
#'
#' @export
#'
compare_distance_routines=function(longylt){

		message("comparing the distance routines...")

		input_checks(longylt,c("year","lon","lat"))

		lon1=longylt$lon[1]
		lat1=longylt$lat[1]
		len=length(longylt$year)
		n=0
		message("len=",len)
		for (i in 1:len){
			lon2=longylt$lon[i]
			lat2=longylt$lat[i]
			rdiff=0.001*geosphere::distm(c(lon1, lat1), c(lon2, lat2), fun = distHaversine)
			rustdiff=0.001 * rust_dist_haversine(lon1, lat1, lon2, lat2)
			diff=abs(rdiff-rustdiff)
			if(diff>0){
				message("i,diff=",i,diff)
				n=n+1
			}
		}
		message("comparison complete")
		message("number of differences=",n)
}

#' Prints changes in AAE and AAL from a two longylts to the screen
#'
#' @description
#' Because they are longylts, requires the number of years.
#'
#' @param longylt1				A data frame containing longylt1
#' @param longylt2				A data frame containing longylt2
#' @param nyearsinylt			nyearsinylt
#'
#' @returns
#' Prints changes in AAE, AAL to the screen
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_582_ylt_diagnostics_aaeaal_change_printf.R
#'
#' @export
ylt_diagnostics_aaeaal_change_printf=function(longylt1,longylt2,nyearsinylt=0){

		diag1=ylt_diagnostics_aaeaal(longylt1,nyearsinylt)
		aae1=diag1$AAE
		aal1=diag1$AAL

		diag2=ylt_diagnostics_aaeaal(longylt2,nyearsinylt)
		aae2=diag2$AAE
		aal2=diag2$AAL

		message("*: % changes in aae and aal")
		aaepc=100*(aae2-aae1)/aae1
		aalpc=100*(aal2-aal1)/aal1
		message("   pc changes aae,aal=",round(aaepc,2),",",aalpc)
}

#
# 1 create a YLT
#
cat("1. longylt:\n")
year=c(1,1,1,2,2,3,3,4,4,4,5,5,5,5,5)
loss=seq(10,150,10)
longylt=data.frame(year,loss)
print(head(longylt))
#
cat("\n2. calculate results by loss thresholds:\n")
lossthresholds=c(10,30)
maxnumber=3
op=ylt_diagnostics_loss_thresholds(longylt,lossthresholds,maxnumber)
print(op)

#
# 1 create losses
#
cat("1. make losses:\n")
losses=seq(1,1000,1)
#
# 2 set the return periods to look at
#
rps=c(0.5,1,2,3,4,5,10,20,50,100,1000,10000)
#
cat("2. calculate the EP:\n")
op=make_ep_by_sorting(losses,rps)
#
print(op)

#
# 1 create an example ELT
#
nevents=1000
totalannualrate=3
evid=c(1:nevents)
mloss=(c(1:nevents)^2)/100 #max is 10k
mrate=rep(totalannualrate/nevents,nevents)
elt=data.frame(evid,mrate,mloss)
#
# 2 example 1
#
message("**************************************************************")
message("Example 1: 2 years of simulation, 2 layers, detailed outputs  ")
message("**************************************************************")
#
# 3 simulate a 2 year YLT
#
nyears=2
set.seed(3)
ylt=yltsim(nyears=nyears,elt)
#
# 4 set up 2 catXL layers
#
limit=c(2000,4000)
deductible=c(1000,3000)
nrst=c(2,2)
premium=1000
rst_premium_pc=c(80,90)
#
# 5 analyze the catXL
#
catxlresults=catxl(ylt,limit,deductible,nrst,premium,rst_premium_pc)
#
# 6 look at the results
#
message("\nsummary:")
print(catxlresults$summary)
message("\nshortrecord:")
print(catxlresults$shortrecord)
message("\nlongrecord:")
print(catxlresults$longrecord)
#
# 7 example 2
#
message("**************************************************************")
message("Example 2: 1k years of simulation, 1 layer, summary outputs")
message("**************************************************************")
nyears=100
#
# 8 simulate 2x 1k YLTs to investigate convergence
#
set.seed(1);ylt1=yltsim(nyears=nyears,elt)
set.seed(2);ylt2=yltsim(nyears=nyears,elt)
#
# 9 set up 1 catXL layer this time
#
limit=c(2000)
deductible=c(1000)
nrst=c(1)
premium=1000
rst_premium_pc=c(80)
#
# 10 analyze the catXL and look at the summary results
#
message("\nylt1 summary:")
print(catxl(ylt1,limit,deductible,nrst,premium,rst_premium_pc)$summary)
message("\nylt2 summary:")
print(catxl(ylt2,limit,deductible,nrst,premium,rst_premium_pc)$summary)

#' Applies an hours clause to a long YLT, and returns a YLT
#'
#' @description
#' I could simplify the code by just returning a long YLT,
#' and then leaving the user to create a short YLT using long2short.
#'
#' @param longylt1				The input long YLT
#' @param	hcdays					Hours clause parameter, number of days
#' @param hckm						Hours clause parameter, distance in km
#' @param byregion				Whether to use regions, or distances, to measure closeness
#' @param rust						Rust logical
#' @param rrrr						R logical
#' @param verbose					Logical, meaning obvious
#'
#' @returns
#' A long YLT with hours clause applied.
#'
#' @details
#' Can be called from \code{hours_clause_wrapper}, which manages the file i/o.
#' Note that exactly what 'applying an hours clause' means some explanation.
#' We don't have access to footprints, just days of the year (one day per event)
#' and locations (one point per event). The algorithm looks at the days and
#' the locations and merges events which are close in both time and space. It only
#' applies a maximum of one hours clause per year, which is chosen to give the
#' maximum possible event loss (i.e., the largest possible max loss recovery
#' for the cedant).
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@gmail.com}
#'
#' @example man/examples/example_801_hours_clause.R
#'
#' @export
#'
# notes:
# -there is no secondary uncertainty anymore
#
hours_clause=function(longylt1,hcdays,hckm,byregion=FALSE,rust,rrrr,verbose=FALSE){

	if(verbose)message(" inside hours clause")
	debug=TRUE
	debug=FALSE

	if(rust){
		message("Using rust")
	} else{
		message("Using R")
	}

# 1 make the corresponding shortylt
	shortylt1=ylt_long2short(longylt1)

# 2 figure out what extra columns the YLT has, that will be copied
	regionflag 	=ifelse("region"%in%colnames(longylt1),TRUE, FALSE)

# 3 test for the essential columns
	input_checks(longylt1,c("year","day","evid","lat","lon","loss"))
  if(byregion)input_checks(longylt1,c("region"))

# 4 initialize
	nevents_in_ylt1=length(longylt1$loss)
	nyears_in_ylt1=length(shortylt1$year)
	if(verbose)message("nevents_in_ylt1=",nevents_in_ylt1)
	if(verbose)message("nyears_in_ylt1=",nyears_in_ylt1)

# 5 longylt outputs
	nrows_in_ylt2=nevents_in_ylt1
	yearlong2	=matrix(0,nrows_in_ylt2)
	rowid2=matrix(0,nrows_in_ylt2)
	ipeid2=matrix(0,nrows_in_ylt2)
	evid2	=matrix(0,nrows_in_ylt2)
	day2	=matrix(0,nrows_in_ylt2)
	loss2=matrix(0,nrows_in_ylt2)
	lat2=matrix(0,nrows_in_ylt2)
	lon2=matrix(0,nrows_in_ylt2)
	region2=matrix(0,nrows_in_ylt2)
	hccounter2	=matrix(0,nrows_in_ylt2)

# 6 loop over the years in the input longylt
	longyltrow2=1
	if(verbose)message(" -simulating...")
	countdiffs=0
	for (j in 1:nyears_in_ylt1){
		if(verbose&&((j%%10000)==0))message(" --simulation year:",j)
		if(debug)message("copy section for year",j)

#
# part 1 of 2 parts: copying
#

# if there are events in ylt1 in this year...
		nevents_in_year1=shortylt1$nevents_in_year[j]
		if(nevents_in_year1>0){

# ...then extract this year
			if(debug)message(" extract year ",j)
			start_row1=shortylt1$longylt_start_row[j]
			eventsthisyear1=matrix(0,nevents_in_year1)
			for (k in 1:nevents_in_year1){
				kk=start_row1+k-1
				eventsthisyear1[k]=longylt1$evid[kk]
			}
			if(debug)message("  eventsthisyear1=",j,eventsthisyear1)
#
# To process this year, loop thru all events in the year
#
			if(debug)message(" loop thru events in this year in YLT1")
			for (k in 1:nevents_in_year1){
#
# extract information about this event from the ylt
#
				longylt1_row=start_row1+k-1 #this is the row for the event in ylt1
#				message("elt_row=",elt_row)
				if(debug)message("copying an event in year:",j,longyltrow2)
# extract event loss
				simloss=longylt1$loss[longylt1_row]
# longylt output for this event
				yearlong2 [longyltrow2]	=j
				rowid2[longyltrow2]	=longylt1_row
				loss2[longyltrow2]	=simloss
				evid2	[longyltrow2]	=longylt1$evid[longylt1_row]
				day2	[longyltrow2]	=longylt1$day[longylt1_row]
				lat2[longyltrow2]		=longylt1$lat[longylt1_row]
				lon2[longyltrow2]		=longylt1$lon[longylt1_row]
				hccounter2[longyltrow2]	=1
# -copy over certain other fields if they exist in YLT1
				if(regionflag)		region2[longyltrow2] 	=longylt1$region[longylt1_row]
				longyltrow2=longyltrow2+1;
			}#end of loop over events in ylt1 for copying
		}#end of if for >0 events in this year
#
# now do hours clause, inside the year loop still ############################
#
		if(nevents_in_year1>1){ #no hours clause if there's just one event

# extract this year, if there are some events this year
			if(debug)message(" extract year ",j)
			start_row1=shortylt1$longylt_start_row[j]
			end_row=start_row1+nevents_in_year1-1
			thisyearevid	=longylt1$evid[start_row1:end_row]
			thisyearloss	=as.numeric(longylt1$loss	[start_row1:end_row])
			thisyearday		=as.numeric(longylt1$day	[start_row1:end_row])
			thisyearlon		=as.numeric(longylt1$lon	[start_row1:end_row])
			thisyearlat		=as.numeric(longylt1$lat	[start_row1:end_row])
			if(byregion)thisyearregion=longylt1$region[start_row1:end_row]
			if(debug)message("  eventsthisyear1=",j,eventsthisyear1)
#			message("thisyearday=",thisyearday)
#loop thru every possible hours clause, calculate the largest event loss in each case
#and then settle on the hours clause that maximises the largest event loss
			maxloss=matrix(0,(nevents_in_year1-1))
			for (k in 1:(nevents_in_year1-1)){
				temploss=thisyearloss
				if(rust){
					hcoutput1rust=rust_hours_clause_apply_part2(hcdays,hckm,byregion,temploss,
						thisyearday,thisyearlon,thisyearlat,thisyearregion,nevents_in_year1,k)
					maxloss[k]=max(hcoutput1rust$temploss)
				}
				if(rrrr){
					hcoutput1rrrr=hours_clause_apply_part2(hcdays,hckm,byregion,temploss,
						thisyearday,thisyearlon,thisyearlat,thisyearregion,nevents_in_year1,k)
					maxloss[k]=max(hcoutput1rrrr$temploss)
				}
# next bit was just for checking
				if(rust&rrrr){
					maxrust=max(hcoutput1rust$temploss)
					maxrrrr=max(hcoutput1rrrr$temploss)
					maxdiff=maxrust-maxrrrr
					if(maxdiff>0){
						message("2 x maxes:",j,k,maxrust,maxrrrr,maxdiff)
					}
				}
# now find which hours clause gives the max loss
			}
			maxk=which.max(maxloss)
#			message("maxk=",maxk)
# and apply it
# note that now I use 'part2' for both parts...'part1' is gone, for simplicity
			if(rust){
				hcoutput2=rust_hours_clause_apply_part2(hcdays,hckm,byregion,thisyearloss,
					thisyearday,thisyearlon,thisyearlat,thisyearregion,nevents_in_year1,maxk)
			}
			if(rrrr){
				hcoutput2=hours_clause_apply_part2(hcdays,hckm,byregion,thisyearloss,
					thisyearday,thisyearlon,thisyearlat,thisyearregion,nevents_in_year1,maxk)
			}
# the output contains:
# -all the losses...and they might all change
# -all the hccounter values...and they might all change

# copy out the vector of losses
# force the new losses into the newlong ylt, overwriting previous copied losses
			kk0=shortylt1$longylt_start_row[j]
			kk1=kk0+shortylt1$nevents_in_year[j]-1
			loss2[kk0:kk1]=hcoutput2$temploss
			hccounter2[kk0:kk1]=hccounter2[kk0:kk1]+hcoutput2$hccounter
# -and add 'old loss' and 'nloss' columns

		}#end of if for >0 events in this year

	}#end of year loop

	if(debug)message("end of simulation loop")

	longylt2 =data.frame(	year	=yearlong2	[1:(longyltrow2-1)],
												day		=day2		[1:(longyltrow2-1)],
												evid	=evid2	[1:(longyltrow2-1)],
												lon	=lon2	[1:(longyltrow2-1)],
												lat	=lat2	[1:(longyltrow2-1)],
												loss	=loss2	[1:(longyltrow2-1)],
												hccounter	=hccounter2	[1:(longyltrow2-1)])

	return(longylt2)
}

#' Convert windspeed in knots into a generalized version of the SSHWS category.
#'
#' @description
#' Converts windspeed 
#' @param ws			input windspeed in units
#' @param units		The units: knots, mph or mph2
#'
#' @returns
#' The cat from -1,0,1,2,3,4,5, where -1 means TD and 0 means TS.
#' 
#' @details
#' I took the definitions from Wikipedia/Saffir-Simpson_scale.
#' Note that the definitions on Wikipedia have gaps, such as between
#' 63 and 64 knots. I close the gaps by using halves. 
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_028_ws2cat.R
#'
#' @export
ws2catf=function(ws,units){

	if(units=="knots"){
		b00=33.5
		b01=63.5
		b12=82.5
		b23=95.5
		b34=112.5
		b45=136.5
	} else if (units=="mph"){
		b00=38.5
		b01=73.5
		b12=95.5
		b23=110.5
		b34=129.5
		b45=156.5
	} else{
		message("Units not recognized, so stopping.")
		stopi("ws2cat")
	}

		if		  	(								(ws<=b00	))	{j=-1
		} else if ((ws>b00)   &&	(ws<=b01  ))	{j=0
		} else if ((ws>b01)   &&	(ws<=b12  ))	{j=1
		} else if ((ws>b12)   &&	(ws<=b23  ))	{j=2
		} else if ((ws>b23)   &&	(ws<=b34	))	{j=3
		} else if ((ws>b34)   &&	(ws<=b45  ))	{j=4
		} else if ((ws>b45)   						)		{j=5
		}

		return(j)
}

#' Makes rates adjustments by event, for events in a YLT
#'
#' @description
#' Maps rate adjustments by cat to rate adjustments by event, which
#' is what \code{yltsurgery} needs as input.
#'
#' @param longylt				A data frame containing the long YLT
#' @param ratesbycat		A list containing the mean and sd adjustments, each of which is a
#' vector with dimension ncat.
#'
#' @returns
#' A matrix with the adjustments by event
#' column 1 is the mean of the adjustments.
#' column 2 is the sd of the adjustments.
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_562_ylt_rate_adjustments_cat_2_row.R
#'
#' @export
#'
ylt_rate_adjustments_cat_2_row=function(longylt,ratesbycat){

	input_checks(longylt,c("year","cat"),"ylt_rate_adjustments_cat_2_row")

  neventsinylt=length(longylt$year)
  rate_adjustments_by_row=matrix(0,neventsinylt,2)
  maxcat=7
  for (ie in 1:neventsinylt){
  	cat=longylt$cat[ie]
  	if(cat>maxcat){
  		message("some types exceed the length of the specified mean adjustments, so stopping.")
  		message("...for event",ie)
  		message("...which has cat",cat)
  		message("...while the max cat specified is",maxcat)
  		stop()
  	}
# my cats run from -1 to 5, so need to add 2 to make it an index
  	rate_adjustments_by_row[ie,1]=ratesbycat$mn[cat+2]
  	rate_adjustments_by_row[ie,2]=ratesbycat$sd[cat+2]
  }

  return(rate_adjustments_by_row)
}

#' Simulates an Adjusted long YLT using Incremental Simulation,
#' based on an input ELT and long YLT
#'
#' @description
#' You have an ELT. And you have a long YLT that you have previously simulated from the ELT using
#' Poisson simulation (perhaps using the \code{longyltsim}).
#' Now you want to simulate an adjusted version of the long YLT, based on multiplicative
#' adjustments which are specified for each event in the ELT, as a mean and a sd for each event.
#'
#' @details
#' The simulated long YLT is copied from the input long YLT, and events are then added and deleted to reflect
#' the specified rates changes, according to the 'incremental simulation' algorithm.
#' This algorithm is relevant for the workflow situation in which the base long YLT was simulated from the ELT.
#' If you have a long YLT that wasn't simulated from an ELT, or you've lost the ELT, use \code{yltsurgery} instead.
#' Incremental simulation attempts to minimize differences due to random noise between the two YLTs
#' and gives more accurate estimates of change than just simulating the second YLT using independent simulation.
#' The rates changes are specified by event.
#' They can be scalar or log-normal distributed, or other distributed, in order to capture adjustment uncertainty.
#' Adjustment uncertainty is simulated using the 'stochastic parameter' simulation algorithm.
#' Changes within years are perfectly correlated.
#'
#' @param elt				A data frame containing the ELT.
#' Must contain \code{mrate} and \code{mloss} columns.
#' @param longylt1	A data frame containing a longylt in the format produced by the routine \code{yltsim()}.
#' @param rate_adjustments_by_event A matrix of multiplicative adjustments for the Poisson rate.
#' The first column gives the mean rate adjustment and the second column gives the standard deviation of the rate adjustment. Both columns must be of same length as the columns in \code{elt}.
#' @param verbose A logical.
#' @param secuncb A logical to indicate whether secondary uncertainty should be simulated
#' (requires \code{sloss} column). Not implemented yet.
#' @param randomday A logical. \code{TRUE} means days are randomized, \code{FALSE} means they are copied.
#'
#' @returns
#' A data frame containing the new long YLTs.
#'
#' @details
#' The input mean and standard deviation rate adjustments are used to define a log-normal distribution for each event.
#' The log-normal is used to simulate different rate adjustments for each year.
#' The log-normal adjustments are perfectly correlated between different events.
#'
#' The assumption is that YLT1 was sampled from the ELT, using the rates in the ELT.
#' The rate adjustments are specified for all the events in the ELT
#' (some of which may not even occur in YLT1).
#' The eltrow in the longylt in YLT1 must correspond to the events in the ELT and in the specified rate adjustments
#' (which it will if the longylt was created by \code{longyltsim}.
#' The algorithm consists of two parts.
#' In the first part, events may or may not be copied from YLT1 to YLT2, depending on a coin flip,
#' based on a probability derived from the rate adjustment.
#' If there is no adjustment, an event will be copied. If there is a large reduction in the rate,
#' it may well not be copied.
#' The longylt part of YLT1 provides the eltrow for each event, which is used to determine the rate adjustment.
#' In the second part, events with increasing rates are selected randomly from the ELT (weighted by the increase),
#' and added to the YLT.
#'
#' The whole issue of event ids is complicated. Here's what I do:
#'\itemize{
#'\item \code{evid: } 	An event id. This will have
#'whatever numbers it had in the ELT. They don't have to start from one.
#'This might end up
#'repeated in the YLT, if the simulations end up repeating that event.
#'\item \code{eltrow: } 	I number the events in the ELT from 1. This is that number.
#'This might end up
#'repeated in the YLT, if the simulations end up repeating that event.
#'\item \code{oldyltrow: } 	For new events, there is no \code{oldyltrow}, because new events are selected
#'from the ELT, not the old YLT, and so the value is not uniquely defined.
#'\item \code{yltrow: } 	The row in the new YLT. Might well not be the same as the 
#' row in the old YLT, because of new events being added.
#' This doesn't repeat in the new YLT.
#' }
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@gmail.com}
#'
#' @references
#'
#' For the stochastic parameter simulation algorithm see: https://doi.org/10.1007/s00477-023-02409-0
#'
#' and: https://en.wikipedia.org/wiki/Year_loss_table#Incremental_Simulation
#'
#' For the incremental simulation algorithm see: https://doi.org/10.1007/s00477-022-02198-y
#'
#' and: https://en.wikipedia.org/wiki/Year_loss_table#Stochastic_Parameter_YLTs
#'
#' @example man/examples/example_101_yltsim_inc.R
#'
#' @export
#'
yltsim_inc=function(elt,longylt1,rate_adjustments_by_event,verbose=FALSE,secuncb=FALSE,randomday=TRUE){

	nyears=length(longylt1$year)
	
	if(verbose)message(" inside yltsim")
	if(verbose)message(" -simulating incrementally",nyears,"nyears")
	debug=TRUE
	debug=FALSE

# make the shortylt
	shortylt1=ylt_long2short(longylt1)
	
# convert rate adjustments (which are real mean and sd) to log parameters (logmean and logsd)
	ee=rate_adjustments_by_event[,1]
	vv=rate_adjustments_by_event[,2]
	if(debug)message("ee=",ee[1:5])
	if(debug)message("vv=",vv[1:5])
	ff=1+vv/(ee*ee)
	mu=log(ee/sqrt(ff))
	sg=sqrt(log(ff))
	if(debug)message("mu=",mu[1:5])
	if(debug)message("sg=",sg[1:5])

# figure out what extra columns the ELT has, that will be copied
#	eltidflag =ifelse("eltid"%in%colnames(elt),TRUE, FALSE)
	evidflag	=ifelse("evid"%in%colnames(elt),TRUE, FALSE)
	dayflag 	=ifelse("day"%in%colnames(elt),TRUE, FALSE)
	wspdflag	=ifelse("wspd"%in%colnames(elt),TRUE, FALSE)
	lflatflag =ifelse("lflat"%in%colnames(elt),TRUE, FALSE)
	lflonflag =ifelse("lflon"%in%colnames(elt),TRUE, FALSE)
	lfregflag =ifelse("lfreg"%in%colnames(elt),TRUE, FALSE)
	catflag 	=ifelse("cat"%in%colnames(elt),TRUE, FALSE)

# set up random days
	if(dayflag&&randomday)alldays=elt$day

# secunc related
	slossflag =ifelse("sloss"%in%colnames(elt),TRUE, FALSE)
	expoflag =ifelse("expo"%in%colnames(elt),TRUE, FALSE)
	if((secuncb)&&(!slossflag)){message("You've selected secunc, but not provided sloss...exiting");stop()}
	if((secuncb)&&(!expoflag)){message("You've selected secunc, but not provided expo...exiting");stop()}
	if(secuncb){
#		betaparams=calc_beta_params(elt$mloss,elt$sloss,elt$expo)
		elt2=calc_beta_params(elt)
		eventalpha=elt2$eventalpha
		eventbeta	=elt2$eventbeta
		expo=elt$expo
	}


# initialize
	nevents_in_elt=length(elt$mloss)
	nrows_in_ylt1=length(longylt1$mloss)
	extrarate=matrix(0,nevents_in_elt)

# this one is needed in the algorithm, even if we aren't producing a shortylt	
	longylt_start_row2=matrix(0,nyears)

		
# shortylt outputs
#	year2=matrix(0,nyears)
#	loss_in_year2=matrix(0,nyears)
#	max_loss_in_year2=matrix(0,nyears)
#	nevents_in_year2=matrix(0,nyears)

# longylt outputs
# -since we don't know the final length, and appending in R is slow, I've used the old-fashioned
# -method of just setting aside masses of memory (3x the length of the original YLT).
# -This method would fail if the rates increases are around 3x the original rates, but that's way beyond typical use cases.
# -Ideally, I guess, I would code up the periodic increases method.
#	longyltrow=1
	initial_nrows_in_ylt2=nrows_in_ylt1*3
	if(verbose)message("  initial_nrows_in_ylt2=",initial_nrows_in_ylt2)
	yrid2	=matrix(0,initial_nrows_in_ylt2)
	origin2=matrix(0,initial_nrows_in_ylt2)
	oldyltrow2=matrix(0,initial_nrows_in_ylt2)
	yltrow2=matrix(0,initial_nrows_in_ylt2)
	eltrow2=matrix(0,initial_nrows_in_ylt2)
#	eltid2=matrix(0,initial_nrows_in_ylt2)
	evid2=matrix(0,initial_nrows_in_ylt2)
	day2	=matrix(0,initial_nrows_in_ylt2)
	mloss2=matrix(0,initial_nrows_in_ylt2)
	wspd2	=matrix(0,initial_nrows_in_ylt2)
	lflat2=matrix(0,initial_nrows_in_ylt2)
	lflon2=matrix(0,initial_nrows_in_ylt2)
	lfreg2=matrix(0,initial_nrows_in_ylt2)
	cat2	=matrix(0,initial_nrows_in_ylt2)

	longyltrow2=1
	if(verbose)message(" -simulating...")
# loop over the years ###################################################################
	for (j in 1:nyears){
		if(verbose&&((j%%10000)==0))message(" --simulation year:",j)
		if(debug)message("copy section for year",j)
#
# set up outputs that don't depend on event occurrences, and hence which can be set up now
#
# -shortylt
#		year2[j]=j

# for each year, create a single z value, and the actual rate adjustments for all events
# which leads to the changes for different events to be perfectly correlated
		if(debug)message(" simulate z")
		z=rnorm(1)
		actual_rate_adjustments_by_event=exp(mu+z*sg)
		if(debug)message("actual_rate_adjustments_by_event=",actual_rate_adjustments_by_event[1:5])

#
# part 1 of 2 parts: copying
#

#
# if there are no events in ylt1 in this year, then there's no event copying, but there's still a row in the shortylt, so need to set up shortylt output
#
		longylt_start_row2[j]=longyltrow2 # if there are no events, will set to NA later
#		nevents_in_year2[j]=0
#		loss_in_year2[j]=0
#		max_loss_in_year2[j]=0
		emptyyear=TRUE
#
# if there are events in ylt1 in this year, extract them, loop thru them, and decide whether to copy
#
		nevents_in_year1=shortylt1$nevents_in_year[j]
		if(nevents_in_year1>0){
			arethereanyeventsgoingintothisyear=FALSE
			longylt_start_row2[j]=longyltrow2 #overwrite the NA is some events are copied
#
# extract the events in this year from ylt1, if there are some events this year
#
			if(debug)message(" extract year ",j)
			start_row1=shortylt1$longylt_start_row[j]
			k1=start_row1
			k2=start_row1+nevents_in_year1-1
			eventsthisyear1=longylt1$eltrow[k1:k2]
#
# loop thru all events in that year in YLT1
#
			if(debug)message(" loop thru events in this year in YLT1")
			for (k in 1:nevents_in_year1){
				copythisevent=FALSE
#
# extract information about this event from the elt
#
				longylt1_row=start_row1+k-1 #this is the row for the event in ylt1
				elt_row=longylt1$eltrow[longylt1_row] #this is the row for the event in the elt, which we need to access the rate adjustment table, which is by event
#				message("elt_row=",elt_row)
# copying for lowering rates (i.e. rate changes <1)
				if(actual_rate_adjustments_by_event[elt_row]<1){
					copyrandom=rbinom(1,1,actual_rate_adjustments_by_event[elt_row]);
					if(copyrandom==1){copythisevent=TRUE}
#	copying for same or higher rates (i.e. rate changes >1)
				} else if (actual_rate_adjustments_by_event[elt_row]>=1){
					copythisevent=TRUE
				}
#
# actually copy if necessary
#
				if(copythisevent){
					emptyyear=FALSE
					if(debug)message("copying an event in year:",j,longyltrow2)
# extract event loss
					simloss=longylt1$mloss[longylt1_row]
# shortylt output
#					nevents_in_year2[j]=nevents_in_year2[j]+1
#					loss_in_year2[j]=loss_in_year2[j]+simloss
#					max_loss_in_year2[j]=max(max_loss_in_year2[j],simloss)
# longylt output
					yrid2 [longyltrow2]=j
					origin2[longyltrow2]="copied"
					oldyltrow2[longyltrow2]=longylt1_row
					yltrow2[longyltrow2]=longyltrow2
					eltrow2[longyltrow2]=elt_row
					mloss2[longyltrow2]=simloss
# -copy over certain other fields if they exist in the ELT
					if(dayflag) 	day2	[longyltrow2]=longylt1$day[longylt1_row]
#					if(evidflag)	eltid2[longyltrow2]=longylt1$eltid[longylt1_row]
					if(evidflag)	evid2[longyltrow2]=longylt1$evid[longylt1_row]
					if(wspdflag)	wspd2 [longyltrow2]=longylt1$wspd [longylt1_row]
					if(lflatflag)	lflat2[longyltrow2]=longylt1$lflat[longylt1_row]
					if(lflonflag)	lflon2[longyltrow2]=longylt1$lflon[longylt1_row]
					if(lfregflag)	lfreg2[longyltrow2]=noquote(longylt1$lfreg[longylt1_row])
					if(catflag)		cat2	[longyltrow2]=longylt1$cat[longylt1_row]
					longyltrow2=longyltrow2+1;
				}#end of copy event loop
			}#end of loop over events in ylt1 for copying
		}#end of if for >0 events in this year

# note that we're still inside the year loop

#
# part 2 of 2: adding extras
# -calculate extra rate, and then just simulate like in yltsim
#
# calculate extra rate over the whole elt, just for this one year
		if(debug)message("add",j)
		totalextrarate=0
# without vectorization, this next line increases run-time by 10x
		extrarate=(elt$mrate)*pmax((actual_rate_adjustments_by_event-1),0)
		totalextrarate=sum(extrarate);
		if(debug)	message("totalextrarate=",totalextrarate)

# now just do regular simulation for this year, but based on totalextrarate

# simulate total number of extra storms in this year
			nextraevents_in_year2=rpois(1,totalextrarate)

# loop over events in year j (but only if there is at least one event)
# -this is the number of extra events we are putting into year j...nothing to do with ylt1
			if(nextraevents_in_year2>0){
				emptyyear=FALSE
				for (ievent in 1:nextraevents_in_year2){
# select which events will occur in year j
					selectedid=sample(c(1:nevents_in_elt),1,prob=extrarate) #note that it's weighted by extrarate now

# create a loss for the selected event
					if(secuncb){
						simloss=expo[selectedid]*rbeta(1,eventalpha[selectedid],eventbeta[selectedid]);
					} else {
						simloss=elt$mloss[selectedid]
					}

# create output
# shortylt output
#					nevents_in_year2[j]=nevents_in_year2[j]+1
#					loss_in_year2[j]=loss_in_year2[j]+simloss
#					max_loss_in_year2[j]=max(max_loss_in_year2[j],simloss)
# longylt output
#					message("j,longyltrow=",j,longyltrow,elt$lfreg[selectedid])
					yrid2	[longyltrow2]=j
					origin2[longyltrow2]="added"
					oldyltrow2[longyltrow2]="not defined"
					yltrow2[longyltrow2]=longyltrow2
					eltrow2[longyltrow2]=selectedid
					mloss2[longyltrow2]=simloss

# copy over certain other fields if they exist in the ELT
# -this time we're copying from the elt, because it's the elt index that we've got to hand
# -and because some events might not even exist in YLT1
#					if(evidflag)	eltid2[longyltrow2]=elt$evid[selectedid]
					if(evidflag)	evid2[longyltrow2]=elt$evid[selectedid]
					if(dayflag){
						if(randomday){
							day2	[longyltrow2]=sample(alldays,1)
						} else{
							day2	[longyltrow2]=elt$day	 [selectedid]
						}
					}
					if(wspdflag)	wspd2 [longyltrow2]=elt$wspd [selectedid]
					if(lflatflag)	lflat2[longyltrow2]=elt$lflat[selectedid]
					if(lflonflag)	lflon2[longyltrow2]=elt$lflon[selectedid]
					if(lfregflag)	lfreg2[longyltrow2]=noquote(elt$lfreg[selectedid])
					if(catflag)		cat2	[longyltrow2]=elt$cat[selectedid]

# increment
					longyltrow2=longyltrow2+1

				}#end of loop over events in year j
			}#end of if statement
			if(emptyyear)longylt_start_row2[j]=NA # if there are no events, will set to NA later

	}#end of year loop


	if(debug)message("end of simulation loop")


# format output
#	shortylt2=data.frame(year=year2,
#											longylt_start_row=longylt_start_row2,
#											nevents_in_year=nevents_in_year2,
#											loss_in_year=loss_in_year2,
#											max_loss_in_year=max_loss_in_year2)

	longylt2 =data.frame(	yrid	=yrid2	[1:(longyltrow2-1)],
												origin	=origin2	[1:(longyltrow2-1)],
												oldyltrow	=oldyltrow2	[1:(longyltrow2-1)],
												yltrow	=yltrow2	[1:(longyltrow2-1)],
												eltrow=eltrow2	[1:(longyltrow2-1)],
#												eltid	=eltid2	[1:(longyltrow2-1)],
												evid	=evid2	[1:(longyltrow2-1)],
												day		=day2		[1:(longyltrow2-1)],
												mloss	=mloss2	[1:(longyltrow2-1)],
												wspd	=wspd2	[1:(longyltrow2-1)],
												lflat	=lflat2	[1:(longyltrow2-1)],
												lflon	=lflon2	[1:(longyltrow2-1)],
												lfreg	=lfreg2	[1:(longyltrow2-1)],
												cat		=cat2		[1:(longyltrow2-1)])

# return
	return(longylt=longylt2)
#	output=list(	shortylt=shortylt2,
#								longylt=longylt2)

}

ipfilename="settings.csv"
settingsfilename=tempfile(fileext=".csv")
rcp=8
baseyear1=1900
baseyear2=2022
targetyear=2099
k2020settings="Linear and Landfall"
frequnc="Use distribution"
quantile=90
randomseed=0
manual=FALSE
manualadjustments=list(mn=1,sd=0)
#
nahu_write_settings(ipfilename,settingsfilename,rcp,baseyear1,baseyear2,targetyear,
		k2020settings,frequnc,quantile,randomseed,manual,manualadjustments)

#' Checks a YLT for the same event occurring twice in one year
#'
#' @description The assumption is that this is undesirable, and so if it happens
#' then the code stops and reports back when it happened.
#'
#' @param longylt			The input long, which needs a \code{evid} column.
#'
#' @returns
#' Screen output listing when an event occurs twice in the same year
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_538_ylt_check_for_same_events_in_one_year.R
#'
#' @export
#'
ylt_check_for_same_events_in_one_year=function(longylt){

	input_checks(longylt,c("evid"),"ylt_check_for_same_events_in_one_year")

	shortylt=ylt_long2short(longylt)
	
	for (i in 1:length(shortylt$year)){
		start			=shortylt$longylt_start_row[i]
		nevents		=shortylt$nevents_in_year[i]
		end=start+nevents-1
#	message("start,nevents,end=",start,nevents,end)
		oneyear=longylt$evid[start:end]
#	message("oneyear=",oneyear)
		maxt=max(tabulate(oneyear))
		if(maxt>1){
			message("There are 2 events the same in year:",i)
			message("ylt=",oneyear)
			message("So I'm stopping the code now,")
			message("inside ylt_check_for_same_events_in_one_year.")
			stop()
		}
	}
	message("...check complete")
}

#
# 1 make filenames
#
ipfilename=tempfile(fileext=".csv")
opfilename=tempfile(fileext=".csv")
settingsfilename=tempfile(fileext=".csv")
#
# 2 hc settings
#
time=1
distance=2
#
# 3 call the routine
#
hours_clause_write_settings(ipfilename,settingsfilename,opfilename,time,distance)
#
# 4 have a look at the file it produced
#
x=read.csv(settingsfilename)
print(x)

#' Function that loops through events in one year and applies an hours clause
#'
#' @description
#' Quite hard to understand.
#' Having previously found out which value of k gives the hours clause with the
#' largest loss, this routine applies the hours clause starting with that event.
#' It also registers which events have been moved, which part 1 does not do.
#' There are two separate, but very similar, routines, just to make the search
#' go faster, since in the initial search, there is no need to register which
#' events have been moved.
#'
#' @param	hcdays					Hours clause parameter, number of days
#' @param hckm						Hours clause parameter, distance in km
#' @param byregion				Whether to use regions, or distances, to measure closeness
#' @param temploss				Not sure. Part of the algorithm.
#' @param	thisyearday			For events in this year, the days
#' @param thisyearlon			For events in this year, the lons
#' @param thisyearlat			For events in this year, the lats
#' @param thisyearregion	For events in this year, the regions
#' @param nevents_in_year Number of events in this year
#' @param k								The index of the hours clause to apply, of all possible hours clauses
#'
#' @returns
#' A loss and a counter
#'
#' @details
#' To be called from \code{hours_clause}, which loops thru the whole YLT,
#' and which itself is called from \code{hours_clause_wrapper}, which manages the file i/o.
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@gmail.com}
#'
#' @references
#' x
#'
#' @example man/examples/example_803_hours_clause_apply_part2.R
#'
#' @export
#'
hours_clause_apply_part2=function(hcdays,hckm,byregion=FALSE,temploss,
	thisyearday,thisyearlon,thisyearlat,thisyearregion,
	nevents_in_year,k){

# counter for number of events making up a loss
	hccounter=matrix(0,length(temploss))

# apply the hours clause to event k in the year

# now test whether each subsequent event is captured within the hours clause
				for (kk in (k+1):nevents_in_year){

# hcdays
					daydiff=abs(thisyearday[kk]-thisyearday[k])

# space
					lon1=thisyearlon[kk]
					lat1=thisyearlat[kk]
					lon2=thisyearlon[k]
					lat2=thisyearlat[k]
#					message("lons=",lon1,lon2)
#					message("lats=",lat1,lat2)
					kmdiff=0.001*distm(c(lon1, lat1), c(lon2, lat2), fun = distHaversine)
#					message("kmdiff=",kmdiff)

					close=FALSE
					if(byregion){
						region1=thisyearregion[kk]
						region2=thisyearregion[k]
						if(region1==region2)close=TRUE
					} else{
						if(kmdiff<=hckm)close=TRUE
					}

# if it falls within the hours clause, move the loss onto the earlier event
					if((daydiff<=hcdays)&&(close)){
						temploss[k]=temploss[k]+temploss[kk]
						temploss[kk]=0
						hccounter[k]=hccounter[k]+1
						hccounter[kk]=-1
					}
				}
	return(list(temploss=temploss,hccounter=hccounter))
}

#' Counts number of events per year above loss thresholds
#'
#' @description
#' Reads in a longylt, and some thresholds, and counts the number of years in which
#' there are \code{n} or more events exceeding each loss threshold
#' (think carefully: it's a complicated thing actually).
#'
#' @param longylt					A data frame containing the long YLT
#' @param lossthresholds	A vector of loss thresholds
#' @param maxnumber				Count up to this number of events
#' @param countequalto		Logical for how to count
#'
#' @returns
#' A matrix (lossthresholds by events) with the counts
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_590_ylt_diagnostics_loss_thresholds.R
#'
#' @export
#'
ylt_diagnostics_loss_thresholds=function(longylt,lossthresholds,maxnumber=12,countequalto=TRUE){

	shortylt=ylt_long2short(longylt)
	
	input_checks(longylt,	c("loss"),"ylt_loss_thresholds")

#	yt	=array(0,c(2,nylt,nlossthresholds,nthresholdevents)
	nlossthresholds=length(lossthresholds)
	lossthresholdresults=matrix(0,nlossthresholds,(maxnumber+1)) #+1 so that it starts with zero

	for (it in 1:nlossthresholds){
		threshold=lossthresholds[it]
# loop thru years
		for (iy in 1:length(shortylt$year)){
			nevents_in_year=shortylt$nevents_in_year[iy]
			nbigevents=0
			if(nevents_in_year>0){
# loop thru events in year and count big events
				for (ie in 1:nevents_in_year){
					longyltrow=shortylt$longylt_start_row[iy]+ie-1
					if(longylt$loss[longyltrow]>=threshold)nbigevents=nbigevents+1
				}
# increment counter
				nbigevents=min(nbigevents,maxnumber)
				if(countequalto){
					lossthresholdresults[it,(nbigevents+1)]=lossthresholdresults[it,(nbigevents+1)]+1
				} else {
					lossthresholdresults[it,1:(nbigevents+1)]=lossthresholdresults[it,1:(nbigevents+1)]+1
				}
			} # end of nevents_in_year>0
		} # end of loop thru years
	} # end of loop thru thresholds

	return(lossthresholdresults)
}

#' Writes out settings to file for \code{nahu_ylt_surgery}
#'
#' @param ipfilename				ipfilename
#' @param settingsfilename  settingsfilename
#' @param rcp								rcp
#' @param baseyear1					baseyear1
#' @param baseyear2					baseyear2
#' @param targetyear				targetyear
#' @param k2020settings			k2020settings
#' @param frequnc 					frequnc 
#' @param quantile					quantile
#' @param randomseed				randomseed
#' @param manual						manual
#' @param manualadjustments	manualadjustments
#' 
#' @returns
#' Writes out a csv file
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@gmail.com}
#'
#' @example man/examples/example_202_nahu_write_settings.R
#'
#' @export
#'
nahu_write_settings=function(ipfilename,settingsfilename,rcp,baseyear1,baseyear2,targetyear,
		k2020settings,frequnc,quantile,randomseed,manual,manualadjustments){

	row=matrix(0,10)
	row[ 1]="Your selections:"
	row[ 2]="1. Source of adjustments,	K7"
	row[ 3]=paste("2. Input file,",ipfilename)
	row[ 4]="3. Number of simulations, N/A"
	row[ 5]=paste("4. RCP,",rcp)
	row[ 6]=paste("5. Historical baseline start year,",baseyear1)
	row[ 7]=paste("6. Historical baseline end year,",baseyear2)
	row[ 8]=paste("7. Target year,",targetyear)
	row[ 9]=paste("8. K7 selection,",k2020settings)
	row[10]="10. Secondary Uncertainty,N/A"
	row[11]=paste("11. Frequency uncertainty distribution,",frequnc)
	row[12]=paste("11.1. Other quantile,",quantile)
	row[13]="12. Units	mph (direct method),N/A"
	row[14]=paste("13. Random seed,",randomseed)
	row[15]="14. Simulation algorithm,N/A"
	row[16]=paste("15. Manual Rate adjustments,",manual)
	row[17]=paste("15. Manual Rate adjustments cat,-1,0,1,2,3,4,5")
	row[18]=paste("15. Manual Rate adjustments mean,",paste(manualadjustments$mn,collapse=","))
	row[19]=paste("15. Manual Rate adjustments sd,",paste(manualadjustments$sd,collapse=","))
	row[20]="16. YRAT output,N/A"
	row[21]="17. Loss region definition,N/A"
	write.table(row,settingsfilename,row.names=FALSE,quote=FALSE,col.names=FALSE)

}

#' Calculates YLT AAE and AAL by Cat
#'
#' @description
#' Deals with the number-of-years issue because that's given by the shortylt.
#'
#' @param longylt				A data frame containing the YLT
#' @param nyearsinylt		The number of years in the YLT.
#' @param mincat  			The minimum cat that is counted
#' @param maxcat  			The maximum cat that is counted
#'
#' @returns
#' AAE, AAL, SAE and SAL.
#'
#' @details
#' Let me explain mincat and maxcat.
#' For hurricane the cat column goes from -1 to 5
#' the code deals with that using dcat
#' if you specify minc and maxc, then that's what it counts
#' if you don't specify them, it uses the data
#' but using the data has the problem that the returned data shape depends on the data
#' which is really awkward for any further processing
#' so it's best to specify
#' 
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_583_ylt_diagnostics_aaeaal_by_catf.R
#'
#' @export
#'
ylt_diagnostics_aaeaal_by_catf=function(longylt,nyearsinylt=0,mincat=999,maxcat=999){

input_checks(longylt,c("year","loss","cat"),"ylt_diagnostics_aaeaal_by_cat")

shortylt=ylt_long2short(longylt,nyearsinylt)	
	
#
# I've now added an extra 'cat' at the end which is the sum over all cats

if(mincat==999)mincat=as.integer(min(longylt$cat))
if(maxcat==999)maxcat=as.integer(max(longylt$cat))
ncat=1+maxcat-mincat
dcat=1-mincat
nyears=length(shortylt$year)
ncatp1=ncat+1

Nbycat=matrix(0,ncatp1)

AAEbycat=matrix(0,ncatp1)
TAAEbycat=matrix(0,ncatp1)
AALbycat=matrix(0,ncatp1)

df=longylt
df$one=1+longylt$year*0

for (ic in 1:ncat){
	Nbycat[ic]=sum(df[df$cat==(ic-dcat), "one"])
	AAEbycat=Nbycat/nyears
	AALbycat[ic]=sum(df[df$cat==(ic-dcat), "loss"])/nyears
}
Nbycat	[ncatp1]=sum(Nbycat)
AAEbycat[ncatp1]=sum(AAEbycat)
AALbycat[ncatp1]=sum(AALbycat)

return(list(	Nbycat=Nbycat,
							AAEbycat=AAEbycat,AALbycat=AALbycat))

}

#' Interpolates rates in time
#'
#' @description
#' Longer description
#'
#' @param rcp						rcp
#' @param baseyear1			baseyear1
#' @param baseyear2			baseyear2
#' @param targetyear		targetyear
#' @param k2020settings	k2020settings
#' @param frequnc				frequnc
#' @param quantile			quantile
#' @param randomseed		randomseed
#' @param gmst					gmst
#' @param landfall			landfall
#' @param test					test
#' @param verbose				verbose
#' @param reflectinputs	reflectinputs
#'
#' @returns
#' Mean rate, sd rate, and GMST change
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@gmail.com}
#'
#' @export
#'
nahu_k2020_rates_interpolation=function(rcp,baseyear1,baseyear2,targetyear,
	k2020settings,frequnc,quantile,randomseed,gmst,landfall,
	test=FALSE,verbose=FALSE,reflectinputs=FALSE){
#
# 1 reflect inputs
#
	if(reflectinputs){
	  message("you specified the following inputs:")
	  message(" rcp=",rcp)
	  message(" baseyear1=",baseyear1)
	  message(" baseyear2=",baseyear2)
	  message(" targetyear=",targetyear)
	  message(" k2020settings=",k2020settings)
	  message(" frequnc=",frequnc)
	  message(" quantile=",quantile)
	  message(" randomseed=",randomseed)
	}
#
# 2 check inputs
#
	if(!(rcp %in% c(2,4,6,8))){message("rcp not valid...must be 2,4,6 or 8...stopping.");stop()}

	if((baseyear1<1880)	||(baseyear1>2025)) {message("baseyear1 not valid...must be >1878 and <2026...stopping.");stop()}
	if((baseyear2<1880)	||(baseyear2>2025)) {message("baseyear2 not valid...must be >1878 and <2026...stopping.");stop()}
	if((targetyear<1880)||(targetyear>2099)){message("targetyear not valid...must be >1878 and <2100...stopping.");stop()}

	if((k2020settings!="Linear and Landfall")){message("k2020settings not valid...must be 'Linear and Landfall'...stopping.");stop()}

	if((frequnc!="Use distribution")
		&&(frequnc!="Use mean of distribution")
		&&(frequnc!="Use other quantile")
		){message("frequnc not valid...must be 'Use distribution' or 'Use mean of distribution'...stopping.");stop()}
	if((quantile<1)||(quantile>99.0)){message("quantile must be >=1 and <=99.9...stopping.");stop()}
#
# 3 calculate the mean gmst change (line 324 in index.js)
#
	ircp=rcp/2
	year0=1879
	baseyear1a=baseyear1-year0
	baseyear2a=baseyear2-year0
	targetyeara=targetyear-year0
	gmst1=mean(gmst[ircp,baseyear1a:baseyear2a])
	gmst2=gmst[ircp,targetyeara]
	gmstchange=gmst2-gmst1
	if(verbose)message("   resulting gmstchange=",gmstchange) #agrees perfectly with online software
#
# 4 use the mean gmst change to convert the location and scale parameters
#
	mn0=landfall[,1,]
	sd0=landfall[,2,]

# method 1, via loc sca

# convert to loc sca
	loc0=log(mn0*mn0/(sqrt(sd0*sd0+mn0*mn0)))
	sca0=sqrt(log(1+sd0*sd0/(mn0*mn0)))

# interpolate using gmst
	loc1=loc0*gmstchange/2
	sca1=sca0*gmstchange/2

#

# convert back
	mn1=exp(loc1+0.5*sca1*sca1)
	v1a=-1+exp(sca1*sca1)
	v1b=exp(2*loc1+sca1*sca1)
	sd1=sqrt(v1a*v1b)

	if(frequnc=="Use mean of distribution"){
		sd1=0*sd1
	}

	if(frequnc=="Use other quantile"){
		mn1=exp(loc1+sca1*qnorm(0.01*quantile))
		sd1=0*sd1
	}



#
# 5 and return
#

# there's an option to override with test values for testing purposes
	if(test){
		message("***overwriting with test rate changes***")
		for (ir in 1:19){
			mn1[ir,]=c(0.9,1.0,1.1,1.2,1.3,1.4,1.5)
			sd1[ir,]=c(0,0,0,0,0,0,0)
		}
	}
#

	return(list(mn1=mn1,sd1=sd1,gmstchange=gmstchange))
}

#
# 1 make longylt
#
cat("1. make longylt:\n")
year=c(1,1,1)
lon=c(-111.8817,-111.1963,-119.891)
lat=c(35.1067,31.4196,39.3254)
longylt=data.frame(year,lon,lat)
#
# 2 run
#
compare_distance_routines(longylt)

#
# 1 create a long YLT
#
cat("1. longylt:\n")
year=c(1,1,1,2,2,3,3,4,4,4,5,5,5,5,5)
wspd=seq(10,150,10)
longylt1=data.frame(year,wspd)
print(longylt1)
#
longylt2=ylt_add_cat_2_longylt(longylt1,units="knots")
#
print(longylt2)

#
# 1 make filenames
#
ipfilename=tempfile(fileext=".csv")
opfilename=tempfile(fileext=".csv")
settingsfilename=tempfile(fileext=".csv")
#
# 2 set the hours clause settings
#
hcdays=15
hckm=200
#
# 3 make an 8 year ylt with 10 events
#
cat("1. make longylt:\n")
nyearsinylt=8
year	=c(1	,1	,1	,2	,4	,5	,6	,7	,8	,8)
day		=c(1	,2	,51	,101,151,201,251,300,350,360)
evid	=c(1	,2	,3	,4	,5	,6	,7	,8	,9	,10)
lat		=c(10	,11	,30	,30	,30	,30	,30	,30	,30	,50)
lon		=c(10	,11	,30	,30	,30	,30	,30	,30	,30	,50)
region=c("A"	,"A"	,"B"	,"B"	,"B"	,"B"	,"B"	,"B"	,"B"	,"B")
loss	=seq(10,55,5)
longylt=data.frame(year,day,evid,lat,lon,loss,region)
write.csv(longylt,file=ipfilename,row.names=FALSE)
#
# 4 apply the hours clause and generate a new ylt
#
ylts=hours_clause_wrapper_ylt(ipfilename,settingsfilename,opfilename,nyearsinylt,
	hcdays,hckm,
	byregion=TRUE,
	rust=TRUE,rrrr=FALSE,
	test=FALSE,verbose=TRUE)
#
longylt1=ylts$longylt1
longylt2=ylts$longylt2
#
print(head(longylt1,n=6))
print(head(longylt2,n=6))
#
#

#
# 1 make elt
#
nx=100
mrate=runif(nx)
elt=data.frame(mrate)
#
# 2 make the curves
#
op=elt_diagnostics_epcurves(elt)
#
# 3 add some loss data
#
loss=sort(rnorm(nx))
#
# 4 plot
#
old_par <- par(no.readonly = TRUE)
par(old_par)
par(mfrow=c(2,2))
#
plot(loss,op$cep,main="CEP")
lines(loss,op$cep,col="red")
#
plot(loss,op$eef,main="EEF")
lines(loss,op$eef,col="red")
#
plot(loss,op$oep,main="OEP")
lines(loss,op$oep,col="red")
#
par(old_par)

#
# set up all the arguments
#
rcp=8
baseyear1=1900
baseyear2=2022
targetyear=2099
k2020settings="Linear and Landfall"
frequnc="Use distribution"
quantile=90
randomseed=0
gmst=nahu_define_gmst_scenarios()
landfall=nahu_define_k2020_zenodo_landfall_adj()
#
# and calculate the implied landfall rates changes
#
rates=nahu_k2020_rates_interpolation(rcp,baseyear1,baseyear2,targetyear,
	k2020settings,frequnc,quantile,randomseed,gmst,landfall)
#
# have a look at region 1, mean change, all 7 cats
#
print(rates$mn1[1,])

#' Converts rate adjustments from region and cat to event, for events in an ELT
#'
#' @description
#' Converts rate adjustments by region and cat to rate adjustments by event.
#' So that you can specify rate adjustments by region and cat (which is easy to do),
#' and then run this routine to assign those adjustments to all the events
#' in an ELT.
#'
#' @param elt			A data frame containing the ELT. Requires \code{cat} and \code{reg}
#' @param rate_adjustments_by_regcat		A list of two matrices containing the mean and sd adjustments by reg-cat,
#' given by \code{adjustments_by_cat$mn}, \code{adjustments_by_cat$sd}
#'
#' @returns
#' A matrix with the adjustments by event
#' column 1 is the mean of the adjustments.
#' column 2 is the sd of the adjustments.
#'
#' @details
#' Doesn't do anything except just copy the adjustments. No calculations.
#' Cat is a positive integer.
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_423_elt_rate_adjustments_regcat_2_event.R
#'
#' @export
#'
elt_rate_adjustments_regcat_2_event=function(elt,rate_adjustments_by_regcat){

	input_checks(elt,c("cat","region"),"rate_adjustments_elt_regcat_2_event")

  neventsinelt=length(elt$cat)
  rate_adjustments_by_event=matrix(0,neventsinelt,2)
  maxreg=dim(rate_adjustments_by_regcat$mn)[1]
  maxcat=dim(rate_adjustments_by_regcat$mn)[2]
  for (ie in 1:neventsinelt){
  	cat=elt$cat[ie]
  	reg=elt$region[ie]
  	if(cat>maxcat){
  		message("some cats exceed the length of the specified mean adjustments, so stopping.")
  		message("...for event",ie)
  		message("...which has cat",cat)
  		message("...while the max cat specified is",maxcat)
  		stop()
  	}
  	if(reg>maxreg){
  		message("some regions exceed the length of the specified mean adjustments, so stopping.")
  		message("...for event",ie)
  		message("...which has region",reg)
  		message("...while the max reg specified is",maxreg)
  		stop()
  	}
# old: my cats run from -1 to 5, so need to add 2 to make it an index
#  	rate_adjustments_by_event[ie,1]=adjustments_by_reg_cat$mn1[reg,cat+2]
#  	rate_adjustments_by_event[ie,2]=adjustments_by_reg_cat$sd1[reg,cat+2]
# my cats run from -1 to 5, so need to add 2 to make it an index
  	rate_adjustments_by_event[ie,1]=rate_adjustments_by_regcat$mn[reg,cat]
  	rate_adjustments_by_event[ie,2]=rate_adjustments_by_regcat$sd[reg,cat]
  }

  return(rate_adjustments_by_event)
}

#
# create an elt with 10 rows
#
set.seed(1)
#
# essentials
evid=seq(1000,1009,1) 
mrate=rep(0.1,10)
mloss=seq(100,1000,100)
#
# add an optional column
wspd=seq(50,59,1) 
#
# now make the elt
# the ordering of columns isn't important, but the following is standard
elt=data.frame(evid,mrate,mloss,wspd)
#
# and have a look at it, in different ways
print(elt)
head(elt,n=5)

# Generated by extendr: Do not edit by hand
# nolint start

#' @usage NULL
#' @useDynLib catmodeling, .registration = TRUE
NULL

#' Return string `"Hello world!"` to R.
#' Just a test. 
#' @return A message to the screen.
rust_hello_world <- function() .Call(wrap__rust_hello_world)

#' Square an integer.
#' Just an example.
#' @param x An integer.
#' @return The square of the input.
rust_square <- function(x) .Call(wrap__rust_square, x)

#' Hours clause function
#' For a given start event, calculates all possible hours clauses, returns new losses AND a counter
#' @param hcdays           Definition of the hours clause in days
#' @param hckm             Definition of the hours clause in km
#' @param byregion			Whether to use regions, or distances, to measure closeness
#' @param temploss         The losses by event for this year  
#' @param thisyearday      The days by event for this year
#' @param thisyearlon      The lons by event for this year   
#' @param thisyearlat      The lats by event fo rthis year
#' @param thisyearregion	For events in this year, the regions
#' @param nevents_in_year  The number of events in the full year
#' @param k                The starting event
#' @return Returns a vector of the new losses
rust_hours_clause_apply_part2 <- function(hcdays, hckm, byregion, temploss, thisyearday, thisyearlon, thisyearlat, thisyearregion, nevents_in_year, k) .Call(wrap__rust_hours_clause_apply_part2, hcdays, hckm, byregion, temploss, thisyearday, thisyearlon, thisyearlat, thisyearregion, nevents_in_year, k)

#' Function to calculate the Haversine distance between two points.
#' This matches the functionality of geosphere::distHaversine in R.
#' @param lon1 Lon of first point.
#' @param lat1 Lat of first point.
#' @param lon2 Lon of second point.
#' @param lat2 You guess.
#' @return Returns distance in meters.
#' @return A message to the screen.
rust_dist_haversine <- function(lon1, lat1, lon2, lat2) .Call(wrap__rust_dist_haversine, lon1, lat1, lon2, lat2)

#' Adds two vectors element-wise up to length n.
#' 
#' @param x A reference to the first input vector (slice of f64)
#' @param y A reference to the second input vector (slice of f64)
#' @param n The number of elements to process
#' @return The sum of the two input vectors, as a vector.
addvectors <- function(x, y, n) .Call(wrap__addvectors, x, y, n)

# nolint end

#
# 1 make YLT
#
cat("1. make ylt1:\n")
year=c(1,1,1,2,2,3,3,3)
loss=seq(10,80,10)
cat=c(1,1,1,2,2,3,4,5)
longylt=data.frame(year,loss,cat)
#
# 2 look 
#
cat("2. print the diagnostics\n")
op=ylt_diagnostics_aaeaal_by_cat_printf(longylt,mincat=1,maxcat=5)

#
# 1 make elt with mrate and cat columns
#
nevents=100
mrate=runif(nevents)
cat=sample(7,nevents,replace=TRUE)
elt=data.frame(mrate,cat)
#
# 2 make some adjustments by catyear
# -value of 1 does nothing
#
nyears=1000
ncats=7
adjustmentsbycatyear=matrix(2,ncats,nyears)
#
# 2 make the curves
#
op0=elt_diagnostics_epcurves(elt)
op1=elt_diagnostics_epcurves_with_adj(elt,adjustmentsbycatyear)
#
# 3 add some loss data
#
loss=sort(rnorm(nevents))
#
# 4 plot unadjusted
#
old_par <- par(no.readonly = TRUE)
par(mfrow=c(2,3))
#
plot(loss,op0$cep,main="CEP")
lines(loss,op0$cep,col="red")
#
plot(loss,op0$eef,main="EEF")
lines(loss,op0$eef,col="red")
#
plot(loss,op0$oep,main="OEP")
lines(loss,op0$oep,col="red")
#
#
# 4 plot adjusted (only the EEF changes because the adjustments are constant)
#
plot(loss,op1$cep,main="CEP")
lines(loss,op1$cep,col="red")
#
plot(loss,op1$eef,main="EEF")
lines(loss,op1$eef,col="red")
#
plot(loss,op1$oep,main="OEP")
lines(loss,op1$oep,col="red")
#
par(old_par)

#
# create an elt with 3 rows
#
set.seed(1)
evid=seq(1000,1002,1)
mrate=seq(0.1,0.3,0.1)
mloss=seq(100,300,100)
elt=data.frame(evid,mrate,mloss)
nevents=length(mrate)
message("*************************elt*************************")
print(elt)
#
# simulate longylt1 with 15 years
#
nyears=15
longylt1=yltsim(nyears,elt)
message("*************************ylt1*************************")
print(longylt1)
#
# define adjustments
#
rate_adjustments_by_event=matrix(0,nevents,2)
rate_adjustments_by_event[,1]=2 #double the rates
rate_adjustments_by_event[,2]=0
#
# simulate longylt2 with those adjustments
#
longylt2=yltsim_inc(elt,longylt1,rate_adjustments_by_event)
message("*************************ylt2*************************")
print(longylt2)

#' Calculate a Short YLT from a Long YLT
#'
#' @description
#' Calculates a Short YLT from a Long YLT.
#' Requires \code{year} and \code{loss}.
#' Assumes that the \code{year} should start from 1 (if there is an event in the first year).
#' Assumes that the years are in order.
#' The short YLT output includes years that have no events in the long YLT input.
#' The example shows how to combine them to make a full YLT.
#'
#' @param longylt					A data frame containing the long YLT
#' @param nyearsinylt  Sometimes, by chance, the long YLT might not have any
#' events in year 100, even
#' though technically it's supposed to be 100 years long. So it's good to specify
#' the number of actual years (in this example, 100). Then the short YLT will have
#' 100 years in it. The last year just won't have any events in it. If you just leave
#' this to the default value of 0, then the short YLT will just stop at the last year
#' in the long YLT.
#' @param zeroeventyearsincluded What if year 17 doesn't have any events in it? Should
#' it be included in the short YLT? Yes, it should. And that's the default.
#' But if you set this to FALSE, then that year will not be included.
#' @param	verbose If you set this to true, you get some nice information about the
#' number of years, etc.
#'
#' @returns
#' A data frame containing the short YLT, with columns
#' \code{year}, \code{longylt_start_row}, \code{nevents_in_year},
#' \code{loss_in_year}, \code{max_loss_in_year}.
#' Note that if there are years that are missing from the long YLT because they
#' don't contain any events, they will be listed as start_row=NA, nevents=0.
#' You might think I could just put the start now, not NA.
#' But if this is the last year, you need NA, because there is no row in the long YLT.
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_500_ylt_long2short.R
#'
#' @export
#'
ylt_long2short=function(longylt,nyearsinylt=0,zeroeventyearsincluded=TRUE,verbose=FALSE){
#
# there are two versions, to give different answers to this question:
# Q: what if the longylt contains years 1,2 and 4 only, with no events in year 3
#
# zeroeventyearsincluded=TRUE
# A: I included year 3. It does appear in the shortylt, with zero events in it
#
# zeroeventyearsincluded=FALSE
# A: I skip year 3. It doesn't appear in the shortylt.
# I don't like this one any more.
# It gives incorrect AAE and AAL relative to expectations.
# Because my AAE and AAL routines count the number of rows in the shortylt
#
# Also...the longylt might have 999 years in it.
# If it's really supposed to be 1000 years, set nyearsinylt=1000
# In the code nyearsdata=999.

# check the necessary columns exist
	input_checks(longylt,c("year","loss"),"ylt_long2short")

# there is
# the number of years in the data (the final year)
# the number of years actually implied by the longylt (might be larger)
#
	nevents=length(longylt$year)
	nyearsdata=longylt$year[nevents]
	if(nyearsinylt>0){
		if(nyearsinylt<nyearsdata){
			message("You've set nyearsinylt to be less than the max year in the input.")
			message("That doesn't make sense, so I'm stopping.")
			stop()
		} else{
			nyears=nyearsinylt
		}
	} else{
		nyears=nyearsdata
	}

	if(verbose)message("nevents=",nevents)
	if(verbose)message("nyearsdata=",nyearsdata)
	if(verbose)message("nyearsinylt=",nyearsinylt)
	if(verbose)message("nyears=",nyears)

# check that the years are in order
	for (ie in 2:nevents){
		year1=longylt$year[ie-1]
		year2=longylt$year[ie]
		if(year2<year1){
			message("The years are not in order, so stopping.")
			message("The problem occurred with events ",ie-1," and ",ie)
			stop()
		}
	}

	if(zeroeventyearsincluded){
#-------------------------------------------------------------------------
# find the years and count how many times they occur
		nevents_in_year=as.vector(tabulate(longylt$year)) #tabulate includes years with zero events, so different from table
#no idea why I have to say 'as.vector', but I do, otherwise it's not a vector.

# loop thru years and events
		year=numeric(nyears)
		loss_in_year=numeric(nyears)
		max_loss_in_year=numeric(nyears)
		longylt_start_row=numeric(nyears)

		longyltrow=0
		for (iy in 1:nyearsdata){
			sumloss=0
			maxloss=0
			if(nevents_in_year[iy]==0){
				longylt_start_row[iy]=NA
#				longylt_start_row[iy]=longyltrow+1
			} else {
				longylt_start_row[iy]=longyltrow+1
				for (ie in 1:nevents_in_year[iy]){
					longyltrow=longyltrow+1
					oneloss=longylt$loss[longyltrow]
					sumloss=sumloss+oneloss
					maxloss=max(maxloss,oneloss)
				}
			}
			year[iy]=iy
			loss_in_year[iy]=sumloss
			max_loss_in_year[iy]=maxloss
		}
# now add the extra years to make it up to nyearsinylt
		if(nyearsinylt>nyearsdata){
			for (iy in (nyearsdata+1):nyearsinylt){
				year[iy]=iy
				longylt_start_row[iy]=NA
#				longylt_start_row[iy]=longyltrow+1
				nevents_in_year[iy]=0
				loss_in_year[iy]=0
				max_loss_in_year[iy]=0
			}
		}
	} else{ #end of zeroeventyearsincluded=TRUE section
#-------------------------------------------------------------------------

# find the years and count how many times they occur
		distinctyears		=unique(longylt$year)
		nevents_in_year	=as.vector(table(longylt$year))
#no idea why I have to say 'as.vector', but I do, otherwise it's not a vector.

# how many distinct years are there?
# (some years may be skipped if there are no events, so not the same as the max year)
		ndistinctyears=length(distinctyears)

# loop thru years and events
		year=numeric(ndistinctyears)
		loss_in_year=numeric(ndistinctyears)
		longylt_start_row=numeric(ndistinctyears)

		longyltrow=0
		for (iy in 1:ndistinctyears){
			sumloss=0
			maxloss=0
			longylt_start_row[iy]=longyltrow+1
			for (ie in 1:nevents_in_year[iy]){
				longyltrow=longyltrow+1
				oneloss=longylt$loss[longyltrow]
				sumloss=sumloss+oneloss
				maxloss=max(maxloss,oneloss)
			}
			year[iy]=distinctyears[iy] #not iy, because some years may be skipped
			loss_in_year[iy]=sumloss
			max_loss_in_year[iy]=maxloss
		}
	}#end of zeroeventyearsincluded=FALSE section
#-------------------------------------------------------------------------

	shortylt=data.frame(year,longylt_start_row,nevents_in_year,loss_in_year,max_loss_in_year)
	names(shortylt)=c("year","longylt_start_row","nevents_in_year","loss_in_year","max_loss_in_year")

	return(shortylt)
}

#
# 1 create a YLT
#
cat("1. longylt:\n")
year=c(1,2)
lflat=c(40,10)
lflon=c(-40,-40)
loss=c(10,20)
longylt=data.frame(year,loss,lflat,lflon)
print(longylt)
#
op=ylt_add_region_2_longylt(longylt)
print(op)

#' Writes results from 2 YLTs to csv format.
#'
#' @description
#' Writes various results from 2 YLTs to a csv format.
#' Not to a csv file...but to standard output that could be sent to a csv file
#' using the \code{sink()} function. 
#' The result are:
#' AAE and AAL by cat, and AEP.
#'
#' @param longylt1 The first YLT
#' @param longylt2 The first YLT
#' @param rps	 The return periods you want to calculate
#' 
#' @returns
#' A csv file.
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_552_ylt_write2results2csv.R
#'
#' @export
#'
ylt_write2results2csv=function(longylt1,longylt2,rps){

	input_checks(longylt1,c("year","loss","cat"),"ylt_write2results2csv")
	input_checks(longylt2,c("year","loss","cat"),"ylt_write2results2csv")

	shortylt1=ylt_long2short(longylt1)
	
# 1 calculate AAEs and AALs	by cat

		y1=ylt_diagnostics_aaeaal(longylt1)
		y2=ylt_diagnostics_aaeaal(longylt2)
		y1c=ylt_diagnostics_aaeaal_by_catf(longylt1)
		y2c=ylt_diagnostics_aaeaal_by_catf(longylt2)

		y1a=y1$AAL
		y2a=y2$AAL

		y1ce=round(y1c$AAEbycat,digits=2)
		y2ce=round(y2c$AAEbycat,digits=2)
		pcye=round(100*(y2ce-y1ce)/y1ce,digits=1)

		y1ca=round(y1c$AALbycat,digits=0)
		y2ca=round(y2c$AALbycat,digits=0)
		pcya=round(100*(y2ca-y1ca)/y1ca,digits=1)


# 2 calculate AEPs by cat
		nyears=length(shortylt1$year)
		rpi=pmax(round(nyears/rps),1)
		sy1=sort(longylt1$loss)
		sy2=sort(longylt2$loss)
		aep1=round(sy1[rpi],digits=0)
		aep2=round(sy2[rpi],digits=0)
		daep=round(100*(aep2-aep1)/aep1,digits=1)

# 3 write out AAE and AAL changes
		message(" ")
		message("AAE and AAL by cat,")
		message("****,AAE1,AAE2,% change,AAL1,AAL2,% change,")
		rownames=c("cat1","cat2","cat3","cat4","cat5")
		for (i in 1:5){
			message(rownames[i],",",
							y1ce[i],",",
							y2ce[i],",",
							pcye[i],",",
							y1ca[i],",",
							y2ca[i],",",
							pcya[i],",")
		}

# 5 write out AEPs
		message(" ")
		message("AEPs,")
		message("P,RP,AEP1,AEP2,% change,")
		pcaal=round(100*(y2a-y1a)/y1a,digits=2)
		for (i in 1:length(rps)){
			message(rpi[i],",",
							rps[i],",",
							aep1[i],",",
							aep2[i],",",
							daep[i],",")
		}
		message("AAL,",	y1a,",",
									y2a,",",
									pcaal,",")

}

#
# create an elt with cat
#
mrate=seq(0.1,0.5,0.1)
mloss=seq(100,500,100)
cat=c(1,1,1,2,2)
elt=data.frame(mrate,mloss,cat)
#
op1=elt_diagnostics_aaeaal(elt)
op2=elt_diagnostics_aaeaal_by_cat(elt)
#
cat("AAE=",op1$AAE,"\n")
cat("AAL=",op1$AAL,"\n")
cat("AAEbycat=",op2$AAEbycat,"\n")
cat("AALbycat=",op2$AALbycat,"\n")
cat("AALbycatpc=",op2$AALbycatpc,"\n")

#' Make 2 EP curves by sorting losses
#'
#' @description
#' Calculates 2 EPs, from two vectors of losses, just by calling 
#' \code{make_ep_by_sorting} twice.
#' This somewhat trivial routine is included because it is a very common 
#' operation, to compare losses between two cases (two models, often 
#' an original model and an adjusted model). 
#'
#' @param losses1			A vector of losses.
#' @param losses2			A vector of losses.
#' @param	rps					The return periods at which to calculate the EPs
#'
#' @returns
#' A matrix with 2 sets of return levels in it (with 2 rows)
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @seealso
#'\itemize{
#'\item \code{make_ep_by_sorting} which is what this routine uses
#'}
#'
#' @example man/examples/example_024_make_2_ep_by_sorting.R
#'
#' @export
#'
make_2_ep_by_sorting=function(losses1,losses2,rps){

		ep2=matrix(0,2,length(rps))

		ep2[1,]=make_ep_by_sorting(losses1,rps)
		ep2[2,]=make_ep_by_sorting(losses2,rps)

	return(ep2)
}

#' Calculate Beta Distribution Parameters for a List of Events
#'
#' @description
#' Calculates beta distribution parameters from by-event values of
#' mean, standard deviation and exposure.
#'
#' @details
#' Maybe I should change this one at some point so that it reads in an ELT, rather
#' than just separate variables. But for now it reads 3 separate variables.
#'
#' @param mloss			mean loss by event
#' @param sloss			sd loss by event
#' @param expo			exposure by event
#'
#' @returns
#' A list containing beta distribution alpha and beta parameters, by event.
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_022_calc_beta_params.R
#'
#' @export
#'
calc_beta_params=function(mloss,sloss,expo){
#
# translated from the js
#
	nevents=length(mloss)
	fsloss=matrix(0,nevents)
	fmloss=matrix(0,nevents)
	eventalpha=matrix(0,nevents)
	eventbeta=matrix(0,nevents)
	eps=0.00000000000001

	for (i in 1:nevents){

		if(expo[i]==0){message("One of your exposures is zero...exiting.");stop()}

 		fsloss[i]=max(eps,sloss[i]/expo[i]); #avoids problems with sd=0
		fmloss[i]=mloss[i]/expo[i];

# the max in the next line deals with situations in which fmloss=1
		eventnu=max(0,-1+(fmloss[i]*(1-fmloss[i]))/(fsloss[i]*fsloss[i]));

		eventalpha[i]=eventnu*fmloss[i];
		eventbeta[i]=eventnu*(1-fmloss[i]);
	}

	list(eventalpha=eventalpha,eventbeta=eventbeta)

}

#
# 1 create a long YLT with cat
#
cat("1. make the longylt:\n")
year=c(1,1,1,2,4,5,6,7,8,8)
loss=seq(10,55,5)
cat=c(1,2,3,4,5,6,7,8,9,10)
longylt=data.frame(year,loss,cat)
print(longylt)
#
# 2 make the shortylt
#
cat("2. make the shortylt:\n")
shortylt=ylt_long2short(longylt,nyearsinylt=10)
print(shortylt)

#' Stops code intentionally, with message that says that
#'
#' @description
#' Stops execution and returns a message saying the stop was intentional
#'
#' @param location		An optional string giving the routine being called from, which is then
#' included in the message.
#'
#' @returns
#' A message to the screen.
#'
#' @details
#' Not much more to say about this really.
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
stopi=function(location=FALSE){
	message("*************Stopping intentionally*************.\n")
	if(location!=FALSE)message("in routine: ",location)
	stop()
}

#
# 1 set the hours clause settings
#
hcdays=15
hckm=200
#
# 2 make an 8 year ylt with 10 events
#
cat("1. make longylt:\n")
nyearsinylt=8
year	=c(1	,1	,1	,2	,4	,5	,6	,7	,8	,8)
day		=c(1	,2	,51	,101,151,201,251,300,350,360)
evid	=c(1	,2	,3	,4	,5	,6	,7	,8	,9	,10)
lat		=c(10	,11	,30	,30	,30	,30	,30	,30	,30	,50)	
lon		=c(10	,11	,30	,30	,30	,30	,30	,30	,30	,50)	
loss	=seq(10,55,5)
longylt1=data.frame(year,day,evid,lat,lon,loss)
#
# 3 apply the hours clause and generate a new ylt
#
longylt2=hours_clause(longylt1,hcdays,hckm,rust=FALSE,rrrr=TRUE,verbose=TRUE)
#
print(head(longylt1,n=10))
print(head(longylt2,n=10))
#

#' Adds a region column to a longylt, based on the lat-lons already in the longylt
#'
#' @description
#' Calculates region from lat lon
#' (where the regions relate to the Jewson (2023) BAMS paper).
#'
#' @param longylt			A data frame containing the long YLT. Must contain
#' \code{year}, \code{lflat}, \code{lflon}.
#'
#' @returns
#' A new ylt with a region column added
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_540_ylt_add_region_2_longylt.R
#' 
#' @export
#'
ylt_add_region_2_longylt=function(longylt){

#	source('./countrydata v16 for this new project.R')

	input_checks(longylt,c("year","lflon","lflat"),"ylt_longylt_add_region")

	nyltevents=length(longylt$year)

	lon=longylt$lflon
	lat=longylt$lflat
	reg=numeric(nyltevents)
	for (ir in 1:18){
			regdef=defineregion(ir)
			flag=pracma::inpolygon(lon,lat,regdef$regx,regdef$regy,boundary=TRUE) #I did get a case on the boundary in one client file!
# the following gives regions that agree exactly with the online tool
			for(ie in 1:nyltevents){
				if((flag[ie])&&(reg[ie]==0))reg[ie]=ir
			}
	}

	longylt2=longylt
	longylt2$region=reg

# run checks for unassigned events
	for (ie in 1:nyltevents){
		if(reg[ie]==0){
			message("reg=0 error!")
			message("ie=",ie)
			message("lon=",lon[ie])
			message("lat=",lat[ie])
			stop()
		}
	}

	return(longylt2)
}

#' Converts US state and country region abbreviations into numbers from 1 to 7.
#'
#' @description
#' This is based on one particular method for assigning 7 regions to a NAHU model.
#'
#' @param rg	Region abbreviations 
#'
#' @returns
#' The region from 1 to 7
#' 
#' @details
#' Uses the following regions:
#' 
#'	region 1=c("TX","LA","MS","AL")
#'
#'	region 2=c("FL")
#'
#'	region 3=c("GA","SC","NC","VA")
#'
#'	region 4=c("MD","DE","RI","MA","ME","NY","NJ")
#'
#'	region 5=c("Mexico")
#'
#'	region 6=c("Panama","Costa Rica","Nicaragua","Honduras","El Salvador","Gautemala","Belize")
#'
#'  region 7=undefined
#'  
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_026_whatreg.R
#'
#' @export
whatreg=function(rg){

	reg1=c("TX","LA","MS","AL")
	reg2=c("FL")
	reg3=c("GA","SC","NC","VA")
	reg4=c("MD","DE","RI","MA","ME","NY","NJ")
	reg5=c("Mexico")
	reg6=c("Panama","Costa Rica","Nicaragua","Honduras","El Salvador","Gautemala","Belize")

	if			(rg%in%reg1){reg=1
	}else if(rg%in%reg2){reg=2
	}else if(rg%in%reg3){reg=3
	}else if(rg%in%reg4){reg=4
	}else if(rg%in%reg5){reg=5
	}else if(rg%in%reg6){reg=6
	}else {reg=7
	}
	return(reg)
}

#' Long YLT Diagnostics
#'
#' @description
#' Long YLT diagnostics,
#' Works by creating a shortylt using \code{ylt_long2short}, and then using \code{ylt_diagnostics_aaeaal}.
#' A bit stupid because the output contains blank weighted values, because \code{ylt_long2short},
#' returns weighted values, but there's no way in this case to set the weights.
#' Oh well, never mind. It's fine.
#' You don't really need this one. You can always use \code{ylt_long2short} yourself,
#' and then use \code{ylt_diagnostics_aaeaal}.
#' So this is a good candidate for deletion tbh.
#'
#' @param longylt					A data frame containing the long YLT
#' @param nyearsinylt  Sometimes, by chance, the long YLT might not have any
#' events in year 100, even
#' though technically it's supposed to be 100 years long. So it's good to specify
#' the number of actual years (in this example, 100). Then the short YLT will have
#' 100 years in it. The last year just won't have any events in it. If you just leave
#' this to the default value of 0, then the short YLT will just stop at the last year
#' in the long YLT.
#'
#' @returns
#' AAE, AAL, SAE and SAL.
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_580_ylt_diagnostics_aaeaal.R
#'
#' @export
#'
ylt_diagnostics_aaeaal=function(longylt,nyearsinylt=0){

# sort out the length mess
# so that even if there are years at the end with no events
# and which don't appear in the input
# the calculations will still be done correctly using nyearsinylt
#

# calculate the short ylt
  shortylt=ylt_long2short(longylt,nyearsinylt)

#  
 	nevents_in_year		=shortylt$nevents_in_year
	loss_in_year			=shortylt$loss_in_year

	nyears=length(loss_in_year)

	AAE=mean(nevents_in_year)
	AAL=mean(loss_in_year)

	SAE=sd(nevents_in_year)
	SAL=sd(loss_in_year)
  
	return(list(AAE=AAE,AAL=AAL,SAE=SAE,SAL=SAL))
}

#
# create an elt with 3 rows
#
set.seed(1)
#
# essential parameters
evid=seq(1000,1002,1) 
mrate=seq(0.1,0.3,0.1)
mloss=seq(100,300,100)
#
# optional parameters
wspd=c(50,51,52) #testing copying extra columns
region=c("A","B","C")
#
# make the input elt
elt=data.frame(evid,mrate,mloss,wspd,region)
print(elt)
#
# and simulate a ylt with 5 years
#
longylt=yltsim(5,elt,columns2copy=c("wspd","region"))
#
message("Here's the simulated long ylt:")
print(longylt)
#
shortylt=ylt_long2short(longylt,nyearsinylt=5)
#
message("And here's a short ylt derived from it:")
print(shortylt)

#' For an ELT with multiple occurrences of each event, collapses to 1 per event
#'
#' @description
#' Takes in an ELT that might have multiple occurrences of each event,
#' representing different regions, and combines them together to give
#' one occurrence of that event.
#' Assumes that the occurrences of each event are consecutive.
#' Processes other columns cleverly, depending on what they contain.
#' For instance, adds up losses and exposures, counts regions.
#'
#' @details
#' Recognizes and processes the following columns if they exist:
#' \code{mloss} (sums them up),
#' \code{sloss} (assumes independent),
#' \code{expo}	(sums them up),
#' \code{mrate} (copies the first one).
#' \code{lfreg} (counts them).
#' For other specified columns, copies the first value for each event.
#' How to combine \code{sloss} though? Right now I'm using independence.
#' But presumably I should use correlation of secondary uncertainty.
#'
#' @param elt1			A data frame containing the ELT.
#' The ELT must contain \code{evid}.
#' @param columns2copy 	Copies these columns into the output
#' @param combine If false, then just copies the first set of values
#' @param verbose Logical for verbose or not
#'
#'
#' @returns
#' A new ELT with just single occurrence of each event
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_415_elt_collapse_regions.R
#'
#' @export
#'
elt_collapse_regions=function(elt1,columns2copy=NULL,combine=TRUE,verbose=TRUE){

input_checks(elt1,c("evid"),"elt_collapse_regions")

# processes the following intelligently
mrateflag	=('mrate'		%in% names(elt1))
expoflag	=('expo'		%in% names(elt1))
mlossflag	=('mloss'		%in% names(elt1))
slossflag	=('sloss'		%in% names(elt1))
lfregflag	=('lfreg'		%in% names(elt1))

evid=elt1$evid
nevents1=length(evid)
nevents2=dplyr::n_distinct(evid)

if(verbose)message("nevents1=",nevents1,"\n")
if(verbose)message("nevents2=",nevents2,"\n")

evid2=matrix(0,nevents2)
nregions=matrix(0,nevents2)
mrate2	=matrix(0,nevents2)
mloss2=matrix(0,nevents2)
expo2=matrix(0,nevents2)
sloss2=matrix(0,nevents2)
lfreg2=matrix(0,nevents2)

ncopy=length(columns2copy)
copydata=matrix(0,ncopy,nevents2)

ie1=1
ie2=1

while(ie1<nevents1){

#
# first of all, copy the next event, for the main variables
#
	evid2[ie2]	=evid[ie1]
	nregions[ie2]=1
	if(mrateflag)	mrate2	[ie2]	=elt1$mrate	[ie1]
	if(mlossflag)	mloss2[ie2]	=elt1$mloss[ie1]
	if(expoflag)	expo2[ie2]	=elt1$expo	[ie1]
	if(slossflag){
		if(combine){
			sloss2[ie2]	=(elt1$sloss[ie1])^2
		} else {
			sloss2[ie2]	=elt1$sloss[ie1]
		}
	}
#
# and for the copy variables
#
	if(ncopy>0){
		for (i in 1:ncopy){
			copydata[i,ie2]=elt1[ie1,columns2copy[i]]
		}
	}

# then, see if there is a repeat of that event
# if there is, combine intelligently
	continue=TRUE
	while (evid[ie1]==evid[(ie1+1)]&&continue){
		nregions[ie2]=nregions[ie2]+1

		if(combine){
			if(mlossflag)mloss2[ie2]=mloss2[ie2]+elt1$mloss[ie1+1]
			if(expoflag)expo2[ie2]=expo2[ie2]+elt1$expo[ie1+1]
# for sloss, I combine like independent random variables, which is wrong
# I should be used the correlation of secondary uncertaint
			if(slossflag)sloss2[ie2]=sloss2[ie2]+(elt1$mloss[ie1+1])^2
			if(lfregflag)lfreg2[ie2]="multiple"
		}
		ie1=ie1+1
		if(ie1==nevents1)continue=FALSE
	}
	if(combine)sloss2[ie2]=sqrt(sloss2[ie2])
	ie1=ie1+1
	ie2=ie2+1
} #end of loop over all events in elt1


#elt1=data.frame(evid=evid2,mrate=mrate2,mloss=mloss2,expo=expo2,sloss=sloss2,wspd=wspd2,lflat=lflat2,lflon=lflon2,lfreg=lfreg2,nregions=nregions)
elt=data.frame(evid=evid2)

# add the recognized columns
if(mrateflag)	elt["mrate"]		=mrate2
if(mlossflag)	elt["mloss"]		=mloss2
if(expoflag)	elt["expo"]			=expo2
if(slossflag)	elt["sloss"]		=sloss2
if(lfregflag)	elt["nregions"]	=nregions

# add other random columns as specified by the user
	if(ncopy>0){
		for (i in 1:ncopy){
			elt[,columns2copy[i]]=copydata[i,]
		}
	}

return(elt)

}

#
# 1 create a long YLT with evid
#
cat("1. make longylt:\n")
year=c(1,1,1,2,2)
loss=rep(0,5) 
evid=c(1,2,3,4,5)
longylt=data.frame(year,loss,evid)
#
# 2 run the check
#
cat("4. run the diagnostics:\n")
op=ylt_check_for_same_events_in_one_year(longylt)

#
# create an elt with 3 rows
#
set.seed(2)
mrate=seq(0.1,0.3,0.1)
mloss=seq(100,300,100)
evid=seq(1000,1002,1)
region=c("A","B","C")
nevents=length(mrate)
elt=data.frame(evid,mrate,mloss,region)
#
# simulate ylt1 with 10 years
#
nyears=10
longylt1=yltsim(nyears,elt,columns2copy="region")
cat("*************************ylt1*************************\n")
print(longylt1)
#
# define adjustments
#
nevents_in_ylt1=length(longylt1$year)
rate_adjustments_by_event=matrix(0,nevents_in_ylt1,2)
rate_adjustments_by_event[,1]=2 #double the rates
rate_adjustments_by_event[,2]=0 #no sd on the changes
#
# simulate ylt2 with those adjustments (but not referring back to the ELT)
#
cat("*************************ylt2*************************\n")
longylt2=yltsurgery(longylt1,rate_adjustments_by_event,columns2copy="region")
print(longylt2)
#
# now look at changes
#
ylt_diagnostics_nchanges(longylt1,longylt2,maxchange=6)

#' Sees how many years have changed between a YLT and an adjusted YLT
#'
#' @description
#' Because they are longylts, requires the number of years.
#'
#' @param longylt1				A data frame containing longylt1
#' @param longylt2				A data frame containing longylt2
#' @param nyearsinylt			nyearsinylt
#' @param maxchange				How high to count when looking at how many years have
#' n more events. The default value of 5 is probably fine.
#'
#' @returns
#' Prints changes to the screen
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_591_ylt_diagnostics_nchanges.R
#'
#' @export
ylt_diagnostics_nchanges=function(longylt1,longylt2,nyearsinylt=0,maxchange=5){

# 1: look at how many years have different numbers of events
	shortylt1=ylt_long2short(longylt1,nyearsinylt)
	shortylt2=ylt_long2short(longylt2,nyearsinylt)

	nyears1=length(shortylt1$year)
	nyears2=length(shortylt2$year)
	if(nyears1!=nyears2){
		message("Stopping in ylt_diagnostics_nchanges because the two longylts have different lengths.\n")
		stop()
	}

	message("ylt length = ",nyears1)
	count_same=0
	count_fewer=0
	count_more=0
	count_fewerj=numeric(maxchange)
	count_morej	=numeric(maxchange)
	for (i in 1:nyears1){
		nevents_in_year1=shortylt1$nevents_in_year[i]
		nevents_in_year2=shortylt2$nevents_in_year[i]
		diff=nevents_in_year2-nevents_in_year1
		if(diff==0)	count_same	=count_same+1
		if(diff<0)	count_fewer=count_fewer+1
		if(diff>0)	count_more	=count_more+1
		for (j in 1:maxchange){
			if(diff==-j)count_fewerj[j]=count_fewerj[j]+1
			if(diff== j)count_morej [j]=count_morej	[j]+1
		}
	}
	fewermorej=data.frame(c(1:maxchange),count_fewerj,count_morej)
	colnames(fewermorej)=c("n","nyears with n fewer","nyears with n more")
	message("test 1: number of years with the same number of events = ",count_same)
	message("test 2: number of years with fewer events = ",count_fewer)
	message("test 3: number of years with more events = ",count_more)

# 2 look at how many years have exactly the same events
	count_same_events=0
	for (i in 1:nyears1){
		same=TRUE
		nevents_in_year1=shortylt1$nevents_in_year[i]
		nevents_in_year2=shortylt2$nevents_in_year[i]
		if(nevents_in_year1!=nevents_in_year2)same=FALSE
		i0=shortylt2$longylt_start_row[i]
		i1=i0+shortylt2$nevents_in_year[i]-1
		if(!is.na(i0)){
			origins=longylt2$origin[i0:i1]
			added=c("added") %in% origins
			if(added)same=FALSE
		}
		if(same)count_same_events=count_same_events+1
	}

	message("test 4: number of years with exactly the same events = ",count_same_events)
	message("test 5: number of years with n fewer or more events...")
	print(fewermorej,row.names=FALSE)
}

#
# create an elt
#
cat_by_event=c(1,2,2,3,3,3)
reg_by_event=c(1,2,2,1,2,2)
elt=data.frame(cat=cat_by_event,region=reg_by_event)
#
# make the adjustments by reg-cat
# (2 regions, 3 cats)
#
mean=matrix(1,2,3)
sd=matrix(0,2,3)
rate_adjustments_by_regcat=list(mn=mean,sd=sd)
#
# call
#
rate_adjustments_by_event=elt_rate_adjustments_regcat_2_event(elt,rate_adjustments_by_regcat)
#
print(elt)
print(rate_adjustments_by_event)

#
# 1 create an ELT
#
evid=c(1,2,3)
mrate=c(1,1,1)
mloss=c(10,20,30)
elt=data.frame(evid,mrate,mloss)
#
# 2 create a YLT
#
longylt=yltsim(1000,elt)
#
# 3 call diagnostics
#
ylt_diagnostics_aaeaal_printf(longylt)
#

#' Imports
#'
#' @description
#' Centralized imports
#'
#' @importFrom stats optim sd var lm runif optimize quantile
#' @importFrom stats rpois rbeta rnorm rbinom
#' @importFrom stats qnorm
#' @importFrom dplyr n_distinct
#' @importFrom utils write.table read.csv head write.csv
#' @importFrom pracma inpolygon tic toc
#' @importFrom geosphere distm distHaversine
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@gmail.com}
#'
#'
imports=function(){
}

#' A template for R code
#'
#' @description
#' Longer description here
#'
#' @param x		Input parameter \code{x}
#'
#' @returns
#' Something
#'
#' @details
#' Does something.
#'
#' More details here.
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@gmail.com}
#'
#' @seealso
#'\itemize{
#'\item \code{something else} 	Does something else
#'}
#'
#' @example man/examples/example_215_nahu_k2020_rates_interpolation.R
#'
#' @export
#'
template=function(x){
	message("Hello world, from inside the template.\n")
}

#' Adds a cat column to an elt, calculated from wind speed.
#'
#' @description
#' Takes an ELT, calculates NAHU cat from windspeed, and adds a column with cat.
#' The ELT has to contain windspeed to start with.
#'
#' @param elt			A data frame containing the elt. Requires \code{wspd}.
#' @param units		must be \code{knots}, or \code{mph}.
#'
#' @returns
#' A new elt with a cat column added, where cat runs from -1 to 5.
#'
#' @details
#' I've used the Wikipedia, and filled gaps with halves.
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_425_elt_add_nahu_cat_2.R
#' 
#' @export
#'
elt_add_nahu_cat=function(elt,units){

	input_checks(elt,c("wspd"),"add_nahu_cat_2_elt")

	neltevents=length(elt$wspd)
	catbyeltevent=matrix(0,neltevents)

	for (ie in 1:neltevents){
		ws=elt$wspd[ie]
		catbyeltevent[ie]=ws2catf(ws,units)
	}

	elt2=elt
	elt2$cat=catbyeltevent

	return(elt2)
}

#
# create an elt
#
cat=c(1,2,2,3,3,3) #only cat is required
elt=data.frame(cat)
#
# make the adjustments by cat
#
rate_adjustments_by_cat=list(mn=c(2,4,6),sd=c(0,0,0))
#
# call
#
rate_adjustments_by_event=elt_rate_adjustments_cat_2_event(elt,rate_adjustments_by_cat)
#
print(elt)
print(rate_adjustments_by_event)

#
# 1 create a long YLT with cat
#
cat("1. make longylt:\n")
year=c(1,1,1,2,2)
day=c(1,2,3,4,5)
loss=rep(0,5) #needs an mloss column for long2short
longylt=data.frame(year,loss,day)
#
# 2 run the check
#
cat("4. run the diagnostics:\n")
op=ylt_check_for_2_events_on_same_day(longylt)

#' Converts ELT rates into plotting positions for CEP, EEF and OEP, with rate adjustments
#'
#' @description Takes an ELT, and takes adjustments by cat and *year*, and makes curves,
#' without simulating, but using very clever analytical expressions.
#' Supports any number of cats (so not just for hurricane).
#' So generalizes \code{elt_diagnostics_epcurves}.
#'
#' @details
#' One could debate what plotting positions to use, as always.
#' This one uses Hazen. Perhaps Weibull would be better.
#'
#' @returns
#' A list containing plotting positions for CEP, EEF and OEP
#'
#' @param elt			needs \code{mrate} and \code{cat}
#' @param adjustmentsbycatyear the adjustments
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_421_elt_diagnostics_epcurves_with_adj.R
#'
#' @export
#'
elt_diagnostics_epcurves_with_adj=function(elt,adjustmentsbycatyear){

	input_checks(elt,c("mrate","cat"),"ep_from_adjusted_elt_5m15")

	nevents=length(elt$mrate)
	ncats	=dim(adjustmentsbycatyear)[1]
	nyears=dim(adjustmentsbycatyear)[2]
	mrate=elt$mrate
#	sevent_loss=elt$mloss

# convert cat into a flag to make calculations easier
 flagsm15=matrix(0,ncats,nevents)
 for (i in 1:nevents){
 	for (k in 1:ncats){
	 	cat=elt$cat[i]
  	if(cat==k){flagsm15[k,i]=1}
 	}
 }

 cep=matrix(0,nevents)
 eef=matrix(0,nevents)
 oep=matrix(0,nevents)
 
 rate=matrix(0,nyears,nevents)
 for(j in 1:nyears){
 	for (i in 1:nevents){
	 	rate[j,i]=(sum(adjustmentsbycatyear[,j]*flagsm15[,i]))*mrate[i]
 	}
 }
 sumrate1=matrix(0,nyears)
 for(i in 1:nyears)sumrate1[i]=sum(rate[i,]) #vector function of nyears
  nrate=matrix(0,nyears,nevents)
 for(i in 1:nyears)nrate[i,]=rate[i,]/sumrate1[i] #vector function of nyears
 rm(rate)
 
# cep
 cep1=matrix(0,nyears,nevents)
 cep1[,1]=1-nrate[,1]/2
 for (j in 2:nevents){cep1[,j]=cep1[,j-1]-nrate[,j-1]/2-nrate[,j]/2}
 for (j in 1:nevents)cep[j]=mean(cep1[,j])
 rm(nrate)

# EEF
 eef1=matrix(0,nyears,nevents)
 for (i in 1:nyears)eef1[i,]=sumrate1[i]*cep1[i,]
 for (j in 1:nevents)eef[j]=mean(eef1[,j])
 rm(cep1)

# amw
 amw1=1-exp(-eef1)
 for (j in 1:nevents)oep[j]=mean(amw1[,j])
 rm(eef1,amw1)
 gc()
 
# return(all3)
 return(list(cep=cep,eef=eef,oep=oep))
 }

#' Adjusts a long YLT to make a new long YLT using the grouped surgery algorithm
#'
#' @description
#' The simulated YLT is copied from the input YLT, with events added and deleted to reflect
#' the specified rates changes, according to the 'grouped surgery' algorithm.
#' This algorithm attempts to minimize differences due to random noise between the two YLTs
#' and gives more accurate estimates of change than just simulating the second YLT using independent simulation.
#' Within each group, it chooses the number of events to try and hit the target
#' as closely as possible.
#' The rates changes are specified by event.
#' They can be scalar or log-normal distributed, in order to capture adjustment uncertainty.
#' Adjustment uncertainty is simulated using the 'stochastic parameter' simulation algorithm.
#'
#' @param longylt1		A data frame containing a YLT
#' @param rate_adjustments_by_event A matrix of multiplicative adjustments for the Poisson rate.
#' The first column gives the mean rate adjustment and the second column gives the standard deviation of the rate adjustment. Both columns must be of same length as the columns in \code{elt}.
#' @param groups Specifies which group each event is in.
#' @param columns2copy Specifies a list of columns to be copied from the original YLT, such as \code{cat}.
#' @param verbose A logical.
#' @param randomday Do you want the days to be randomized or copied?
#' @param secunc A logical to indicate whether secondary uncertainty should be simulated
#' (requires \code{sloss} column). Not implemented yet.
#'
#' @returns
#' A data frame containing the new long YLTs.
#'
#' @details
#' The input mean and standard deviation rate adjustments are used to define a log-normal distribution for each event.
#' The log-normal is used to simulate different rate adjustments for each year.
#' The log-normal adjustments are perfectly correlated between different events.
#'
#' The rate adjustments are specified for all the events in the YLT, in order.
#' The algorithm consists of two parts.
#' In the first part, events may or may not be copied from YLT1 to YLT2, depending on a coin flip,
#' based on a probability derived from the rate adjustment.
#' If there is no adjustment, an event will be copied. If there is a large reduction in the rate,
#' it may well not be copied.
#' YLT1 provides the evid for each event, which is used to determine the rate adjustment.
#' In the second part, events with increasing rates are selected randomly from YLT1 (weighted by the increase),
#' and added to YLT2.
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@gmail.com}
#'
#' @references
#'
#' For the stochastic parameter simulation algorithm see: https://doi.org/10.1007/s00477-023-02409-0
#'
#' and: https://en.wikipedia.org/wiki/Year_loss_table#Incremental_Simulation
#'
#' For the incremental simulation algorithm see: https://doi.org/10.1007/s00477-022-02198-y
#'
#' and: https://en.wikipedia.org/wiki/Year_loss_table#Stochastic_Parameter_YLTs
#'
#' @example man/examples/example_106_yltsurgery_groups.R
#'
#' @export
#'
yltsurgery_groups=function(longylt1,rate_adjustments_by_event,groups,columns2copy=NULL,secunc=FALSE,verbose=FALSE,randomday=TRUE){

	input_checks(longylt1,c("year","evid","loss",columns2copy),"yltsurgery_groups")

	if(verbose)message(" inside yltsurgery_groups")
	debug=TRUE
	debug=FALSE

	ncopy=length(columns2copy)

# make the corresponding shortylt
	shortylt1=ylt_long2short(longylt1)

# convert rate adjustments (which are real mean and sd) to log parameters (logmean and logsd)
	ee=rate_adjustments_by_event[,1]
	vv=rate_adjustments_by_event[,2]
	if(debug)message("ee=",ee[1:7])
	if(debug)message("vv=",vv[1:7])
	ff=1+vv/(ee*ee)
	mu=log(ee/sqrt(ff))
	sg=sqrt(log(ff))
	if(debug)message("mu=",mu[1:7])
	if(debug)message("sg=",sg[1:7])

# figure out what extra columns the YLT has, that will be copied
	dayflag 	=ifelse("day"%in%colnames(longylt1),TRUE, FALSE)

# secunc related
	mlossflag =ifelse("mloss"%in%colnames(longylt1),TRUE, FALSE)
	slossflag =ifelse("sloss"%in%colnames(longylt1),TRUE, FALSE)
	expoflag	=ifelse("expo"%in%colnames(longylt1),TRUE, FALSE)
	if((secunc)&&(!mlossflag)){message("You've selected secunc, but not provided mloss...exiting");stop()}
	if((secunc)&&(!slossflag)){message("You've selected secunc, but not provided sloss...exiting");stop()}
	if((secunc)&&(!expoflag)){message("You've selected secunc, but not provided expo...exiting");stop()}
	if(secunc){
		betaparams=calc_beta_params(longylt1$mloss,longylt1$sloss,longylt1$expo)
		eventalpha=betaparams$eventalpha
		eventbeta=betaparams$eventbeta
		expo=longylt1$expo
	}


# set up random days
	if(dayflag&&randomday)alldays=longylt1$day

# initialize
	nevents_in_ylt1=length(longylt1$loss)
	nyears_in_ylt1=length(shortylt1$year)
	message("nevents_in_ylt1=",nevents_in_ylt1)
	message("nyears_in_ylt1=",nyears_in_ylt1)
	extrarate=matrix(0,nevents_in_ylt1)

# shortylt outputs
#	yearshort2					=matrix(0,nyears_in_ylt1)
#	loss_in_year2				=matrix(0,nyears_in_ylt1)
#	max_loss_in_year2		=matrix(0,nyears_in_ylt1)
#	nevents_in_year2		=matrix(0,nyears_in_ylt1)

# this is still needed in the algorithm, even if shortylt isn't output anymore
		longylt_start_row2	=matrix(0,nyears_in_ylt1)

# longylt outputs
# -since we don't know the final length, and appending in R is slow, I've used the old-fashioned
# -method of just setting aside masses of memory (3x the length of the original YLT).
# -This method would fail if the rates increases are around 3x the original rates, but that's way beyond typical use cases.
# -Ideally, I guess, I would code up the periodic increases method.
	initial_nrows_in_ylt2=nevents_in_ylt1*3
#	message("  initial_nrows_in_ylt2=",initial_nrows_in_ylt2)
	yearlong2		=matrix(0,initial_nrows_in_ylt2)
	evid2				=matrix(0,initial_nrows_in_ylt2)
	origin2			=matrix(0,initial_nrows_in_ylt2)
	oldyltrow2	=matrix(0,initial_nrows_in_ylt2)
	oldyear2		=matrix(0,initial_nrows_in_ylt2)
	yltrow2			=matrix(0,initial_nrows_in_ylt2)
	loss2		=matrix(0,initial_nrows_in_ylt2)
	copydata=matrix(0,ncopy,initial_nrows_in_ylt2)

# loop over groups
	ngroups=max(groups)
	maxperyearinylt1=max(shortylt1$nevents_in_year)
	grouplengths=tabulate(groups)

	removelist=matrix(FALSE,nevents_in_ylt1)	#list of events to remove, by event

	addlistbyyear=matrix(0,nyears_in_ylt1,3*maxperyearinylt1)
	addcount=matrix(0,nyears_in_ylt1)

#	message("ngroups=",ngroups)

	for (ig in 1:ngroups){
#		message("group=",ig)
# find the events
		grouplength=grouplengths[ig]

		if(grouplength>0){

# make a vector of all the events in this group
			onegroup=which(groups==ig)
# find the total rate change for this group
			groupratechange=sum(rate_adjustments_by_event[which(groups==ig)])/grouplength
#			message("  groupratechange=",groupratechange)

			if(groupratechange<1){
#
# removing logic
#
# work out how many we need to remove
#				num=ceiling(grouplength*(1-groupratechange))
				num=round(grouplength*(1-groupratechange))
# select which ones to remove
# -without replacement, so each one is only selected once
				removelist1=sample(onegroup,num)
# copy into the big remove list
				for (j in 1:num){
					removelist[removelist1[j]]=TRUE
				}

			}	else{
# adding
# work out how many we need for adding
#				num=floor(grouplength*(groupratechange-1))
#				num=ceiling(grouplength*(groupratechange-1)) # bad, because gives huge increases when the number is very small
				num=round(grouplength*(groupratechange-1)) # bad, because gives huge increases when the number is very small
# pick out the ones to add
# -if possible without replacement, so each one is only selected once
# -unless we need more than there actually are in the group
# -in which case double the group etc
				lenonegroup=length(onegroup)
				if(num<=lenonegroup){
					addlist1=sample(onegroup,num)
				}	else{
					ratio=ceiling(num/lenonegroup)
					biggroup=rep(onegroup,ratio)
					addlist1=sample(biggroup,num)
				}
# and give them random years
# -this time with replacement, so a year can get two new events
				yearlist=sample(c(1:nyears_in_ylt1),num,replace=TRUE)
# copy into the year list, and keep track of how many in that year so far
				for (j in 1:num){
					year=yearlist[j]
					addcount[year]=addcount[year]+1
					addlistbyyear[year,addcount[year]]=addlist1[j]
				}
			}

# show
#			message("  groupratechange,num,grouplength=",groupratechange,num,grouplength)
		} #end of "if length>0"
	}

# have a look
#	for (i in 1:5){
#		message("year=",i)
#		message(" addlistbyyear=",addlistbyyear[i,])
#	}

# loop over the years
	longyltrow2=1
	if(verbose)message(" -simulating...")
	for (j in 1:nyears_in_ylt1){
		if(verbose&&((j%%10000)==0))message(" --simulation year:",j)
		if(debug)message("copy section for year",j)
#
# set up outputs that don't depend on event occurrences, and hence which can be set up now
#
# -shortylt
#		yearshort2[j]=j

# for each year, create a single z value, and the actual rate adjustments for all events
# which leads to the changes for different events to be perfectly correlated
#		if(debug)message(" simulate z")
#		z=rnorm(1)
#		actual_rate_adjustments_by_event=exp(mu+z*sg)
#		if(debug)message("actual_rate_adjustments_by_event=",actual_rate_adjustments_by_event[1:7])

#
# part 1 of 2 parts: copying
#

#
# if there are no events in ylt1 in this year, then there's no event copying,
# -but there's still a row in the shortylt, so need to set up shortylt output
#
#		longylt_start_row2[j]=longyltrow2
#		nevents_in_year2[j]=0
#		loss_in_year2[j]=0
#		max_loss_in_year2[j]=0
		emptyyear=TRUE
#
# if there are events in ylt1 in this year...
#
		nevents_in_year1=shortylt1$nevents_in_year[j]
		if(nevents_in_year1>0){
			emptyyear=FALSE

# extract this year, if there are some events this year
			if(debug)message(" extract year ",j)
			start_row1=shortylt1$longylt_start_row[j]
			eventsthisyear1=matrix(0,nevents_in_year1)
			for (k in 1:nevents_in_year1){
				kk=start_row1+k-1
				eventsthisyear1[k]=longylt1$evid[kk]
			}
			if(debug)message("  eventsthisyear1=",j,eventsthisyear1)
#
# loop thru all events in that year in YLT1
#
			if(debug)message(" loop thru events in this year in YLT1")
			for (k in 1:nevents_in_year1){
				copythisevent=TRUE
#
# extract information about this event from the ylt
#
				longylt1_row=start_row1+k-1 #this is the row for the event in ylt1
#				message("elt_row=",elt_row)
# copying for lowering rates (i.e. rate changes <1)
				if(removelist[longylt1_row])copythisevent=FALSE

				if(copythisevent){
					if(debug)message("copying an event in year:",j,longyltrow2)
# extract event loss
					simloss=longylt1$loss[longylt1_row]
# shortylt output
#					nevents_in_year2[j]=nevents_in_year2[j]+1
#					loss_in_year2[j]=loss_in_year2[j]+simloss
#					max_loss_in_year2[j]=max(max_loss_in_year2[j],simloss)
# longylt output
					yearlong2 [longyltrow2]=j
					evid2			[longyltrow2]=longylt1$evid[longylt1_row]
					oldyltrow2[longyltrow2]=longylt1_row
					oldyear2	[longyltrow2]=longylt1$year[longylt1_row]
					yltrow2		[longyltrow2]=longyltrow2
					loss2			[longyltrow2]=simloss
					origin2		[longyltrow2]	="copied"
# the day column is a bit different because there is the option to randomize it
					if(dayflag){
						if(randomday){
							day2	[longyltrow2]=sample(alldays,1)
						} else{
							day2	[longyltrow2]=longylt1$day[longylt1_row]
						}
					}
#
# and for the optional copy columns
#
#	message("longylt1_row=",longylt1_row)
#	message("columns2copy=",columns2copy)
#	message("longylt1")
	if(ncopy>0){
		for (i in 1:ncopy){
			copydata[i,longyltrow2]=noquote(longylt1[longylt1_row,columns2copy[i]])
		}
	}
					longyltrow2=longyltrow2+1;
				}#end of copy event loop
			}#end of loop over events in ylt1 for copying
		}#end of if for >0 events in this year

# note that we're still inside the year loop

#
# part 2 of 2: adding extras
# -calculate extra rate, and then just simulate like in yltsim
#
# calculate extra rate over the whole ylt, just for this one year
		if(debug)message("add",j)

# extract total number of extra storms in this year
			nextraevents_in_year2=addcount[j]

# loop over events in year j (but only if there is at least one event)
# -this is the number of extra events we are putting into year j...nothing to do with ylt1
			if(nextraevents_in_year2>0){
				emptyyear=FALSE
				for (ievent in 1:nextraevents_in_year2){
# extract which events will occur in year j
					selectedid=addlistbyyear[j,ievent]

# get the loss
#					simloss=longylt1$mloss[selectedid]
				if(secunc){
					simloss=longylt1$expo[selectedid]*rbeta(1,eventalpha[selectedid],eventbeta[selectedid]);
				} else {
					simloss=longylt1$loss[selectedid]
				}

# create output
# shortylt output
#					nevents_in_year2[j]=nevents_in_year2[j]+1
#					loss_in_year2[j]=loss_in_year2[j]+simloss
#					max_loss_in_year2[j]=max(max_loss_in_year2[j],simloss)
# longylt output
#					message("j,longyltrow=",j,longyltrow,elt$lfreg[selectedid])
					yearlong2	[longyltrow2]=j
					evid2			[longyltrow2]=longylt1$evid[selectedid]
					oldyltrow2[longyltrow2]=selectedid
					oldyear2	[longyltrow2]=longylt1$year[selectedid]
					yltrow2		[longyltrow2]=longyltrow2
					loss2			[longyltrow2]=simloss
					origin2[longyltrow2]	="added"
# the day column is a bit different because there is the option to randomize it
					if(dayflag){
						if(randomday){
							day2	[longyltrow2]=sample(alldays,1)
						} else{
							day2	[longyltrow2]=longylt1$day	 [selectedid]
						}
					}
#
# and for optional copy columns
#
	if(ncopy>0){
		for (i in 1:ncopy){
			copydata[i,longyltrow2]=noquote(longylt1[selectedid,columns2copy[i]])
		}
	}

# increment
					longyltrow2=longyltrow2+1

				}#end of loop over events in year j
			}#end of if statement
			if(emptyyear)longylt_start_row2[j]=NA
	}#end of year loop


	if(debug)message("end of simulation loop")


# format output
#	shortylt2=data.frame(year=yearshort2,
#											longylt_start_row=longylt_start_row2,
#											nevents_in_year=nevents_in_year2,
#											loss_in_year=loss_in_year2,
#											max_loss_in_year=max_loss_in_year2)

# start it off
	longylt2 =data.frame(	year			=yearlong2	[1:(longyltrow2-1)])
# day may or may not be copied
	if(dayflag)longylt2["day"]=day2[1:(longyltrow2-1)]
# various essential columns
	longylt2["origin"]		=origin2		[1:(longyltrow2-1)]
	longylt2["oldyear"]		=oldyear2		[1:(longyltrow2-1)]
	longylt2["oldyltrow"]	=oldyltrow2	[1:(longyltrow2-1)]
	longylt2["evid"]			=evid2			[1:(longyltrow2-1)]
	longylt2["newyltrow"]	=yltrow2		[1:(longyltrow2-1)]
	longylt2["loss"]			=loss2			[1:(longyltrow2-1)]

# and then other random columns as specified by the user
	if(ncopy>0){
		for (i in 1:ncopy){
			longylt2[,columns2copy[i]]=copydata[i,1:(longyltrow2-1)]
		}
	}

# return
#	output=list(	shortylt=shortylt2,
#								longylt=longylt2)
	return(longylt=longylt2)

}

#
# 1 create a 10 year YLT
# -2 regions
# -7 cats
#
cat("1. longylt:\n")
year=c(1,1,1,2,2,3,3,4,4,4)
cat	=c(-1,0,1,2,3,4,5,5,5,5)
longylt=data.frame(year,cat)
print(head(longylt))
#
# 2 make adjustments
#
mn=matrix(0,7)
for (j in 1:7){
	mn[j]=cat[j]
}
sd=matrix(0,7)
ratesbycat=list(mn=mn,sd=sd)
# 3 convert adjustments
#
adj=ylt_rate_adjustments_cat_2_row(longylt,ratesbycat)
print(head(adj))

#
# create an elt with 3 rows
#
set.seed(2)
evid=seq(1000,1002,1)
mrate=seq(0.1,0.3,0.1)
mloss=seq(100,300,100)
region=c("A","B","C")
nevents=length(mrate)
elt=data.frame(mrate,mloss,evid,region)
#
# simulate ylt1 with 10 years
#
nyears=10
longylt1=yltsim(nyears,elt,columns2copy=c("region"))
# add an evid flag to the ylt just to test that goes through into ylt2
cat("*************************ylt1*************************\n")
print(head(longylt1))
#
# define adjustments
#
nevents_in_ylt1=length(longylt1$evid)
rate_adjustments_by_event=matrix(0,nevents_in_ylt1,2)
rate_adjustments_by_event[,1]=2 #double the rates
rate_adjustments_by_event[,2]=0
groups=matrix(1,nevents_in_ylt1)
#
# simulate ylt2 with those adjustments (but not referring back to the ELT)
#
ylt2=yltsurgery_groups(longylt1,rate_adjustments_by_event,groups,columns2copy="region")
cat("*************************ylt2*************************\n")
print(head(ylt2))

#' Applies CatXL Layers to a YLT
#'
#' @description
#' Reads a YLT generated by \code{yltsim} format and applies CatXL layers,
#' to generate multiple outputs and diagnostics.
#'
#' @param longylt					A longylt in \code{yltsim} format
#' @param	limit						A vector of limits for the CatXL layers.
#' @param deductible			A vector of deductibles for the CatXL layers.
#' @param nrst						A vector giving the numbers of reinstatements in each layer
#' @param premium					The overall premium (can be set to 0)
#' @param rst_premium_pc	The reinstatement premium, as a percentage
#'
#' @returns
#' A list containing 3 data frames:
#' \itemize{
#' \item \code{summary}AAL ann average annual premium for each layer
#' \item \code{shortrecord}Diagnostics by year by layer
#' \item \code{longrecord}Diagnostics by event (aka claim) by layer
#' }
#'
#' @details
#' Based on the description of catXL pricing given at:
# https://www.linkedin.com/pulse/reinstatement-premiums-excess-loss-reinsurance-iranya-joseph/
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @seealso
#' \code{yltsim}, to generate the required YLT input
#'
#' @example man/examples/example_600_catxl.R
#'
#' @export
catxl=function(longylt,limit,deductible,nrst,premium,rst_premium_pc){
#
# intro
#
original_limit=limit
nlayers=length(original_limit)
shortylt=ylt_long2short(longylt)
#
# checks
#
if(nlayers<1){message("no layers defined: exiting.");stop()}
if(length(deductible)!=nlayers){message("number of limits and deductibles doesn't match.");stop()}
if(length(rst_premium_pc)!=nlayers){message("number of limits and reinstatement premiums doesn't match.");stop()}
#
nevents=sum(shortylt$nevents_in_year)
nyears=length(shortylt$year)
nlrows=nevents*nlayers
nsrows=nyears*nlayers
original_rst_cover=nrst*original_limit #summed over all reinstatements
#
#	result arrays by layer and event for longrecord output
#
yridl=matrix(0,nlrows)
layeridl=matrix(0,nlrows)
eid=matrix(0,nlrows)
limitl=matrix(0,nlrows)
deductiblel=matrix(0,nlrows)
rst_coverl=matrix(0,nlrows)
limit_b4=matrix(0,nlrows)
rst_cover_b4=matrix(0,nlrows)
claim=matrix(0,nlrows)
loss2layer=matrix(0,nlrows)
rst=matrix(0,nlrows)
rst_premium=matrix(0,nlrows)
limit_after=matrix(0,nlrows)
rst_cover_after=matrix(0,nlrows)
#
# result arrays by layer and year for shortrecord output
#
yrids=matrix(0,nsrows)
layerids=matrix(0,nsrows)
limits=matrix(0,nsrows)
deductibles=matrix(0,nsrows)
rst_covers=matrix(0,nsrows)
ann_loss2layer=matrix(0,nsrows)
ann_rst_premium=matrix(0,nsrows)
#
# result arrays by layer for summary output
#
AAL2layer=matrix(0,nlayers)
AA_rst_premium=matrix(0,nlayers)
AA_total_premium=matrix(0,nlayers)
layeridsum=matrix(0,nlayers)
premiumsum=matrix(0,nlayers)
#
# loop over years, and start event id counter
# -looping over years first reflects how I want to save the longrecord...by years first
#
lrow=1
srow=1
for (iy in 1:nyears){
	start_row=shortylt$longylt_start_row[iy]
	nevents_in_year=shortylt$nevents_in_year[iy]
##
# loop over layers
#
	for (il in 1:nlayers){
		layeridsum[il]=il
		layerids[srow]=il
		yrids[srow]=iy
		deductibles[srow]=deductible[il]
		limits[srow]=original_limit[il]
		rst_covers[srow]=original_rst_cover[il]

#
# initialisation for this year for this layer
# -limit1 is the evolving limit during the year
# -rst_cover1 is the evolving rst_cover during the year
		limit1=original_limit[il]
		rst_cover1=original_rst_cover[il]

# only bother if there are events in the year
		if(nevents_in_year>0){

# loop over the events
			for (ie in 1:nevents_in_year){
				layeridl[lrow]=il
				yridl[lrow]=iy
				deductiblel[lrow]=deductible[il]
				limitl[lrow]=original_limit[il]
				rst_coverl[lrow]=original_rst_cover[il]

# record the values b4 applying the event
				limit_b4[lrow]=limit1
				rst_cover_b4[lrow]=rst_cover1

# dig out the claim and event id from the YLT
				ii=start_row+(ie-1)
 				claim[lrow]=longylt$mloss[ii]
 				eid[lrow]=longylt$evid[ii]

# calculate the loss, taking into account the deductible and remaining limit
				loss2layer[lrow]=min(max(claim[lrow]-deductiblel[lrow],0),limit1)

# calculate the amount of reinstatement, based on the remaining reinstatement cover
				rst[lrow]=min(loss2layer[lrow],rst_cover1)

# reinstatement premiums
				rst_premium[lrow]=(rst[lrow]/original_limit[il])*
																(rst_premium_pc[il]/100)*premium
# update the remaining limit
				limit1=limit1-loss2layer[lrow]+rst[lrow]

# update the remaining reinstatement cover
				rst_cover1=
					rst_cover1-rst[lrow]

# record values after applying event
				limit_after[lrow]=limit1
				rst_cover_after[lrow]=rst_cover1

# update annual values
				ann_loss2layer[srow]=ann_loss2layer[srow]+loss2layer[lrow]
				ann_rst_premium[srow]=ann_rst_premium[srow]+rst_premium[lrow]

				lrow=lrow+1
 			} #end of events loop
		} #end of events if
		srow=srow+1
# update layer values
		AAL2layer[il]=AAL2layer[il]+ann_loss2layer[srow-1]
		AA_rst_premium[il]=AA_rst_premium[il]+ann_rst_premium[srow-1]
	} #end of layers loop
} #end of years loop

# fix
# final results for this year

AAL2layer=AAL2layer/nyears
AA_rst_premium=AA_rst_premium/nyears
AA_total_premium=premium+AA_rst_premium

longrecord=data.frame(
								yridl,
								layeridl,
								limitl,
								deductiblel,
								rst_coverl,
								eid,
								limit_b4,
								rst_cover_b4,
								claim,
								loss2layer,
								rst,
								rst_premium,
								limit_after,
								rst_cover_after)
colnames(longrecord)=c("yrid","layerid","limit","deductible","rst_cover",
	"eid","limit_b4","rst_cover_b4","claim","loss2layer",
	"rst","rst_premium","limit_after","rst_cover_after")
#
shortrecord=data.frame(
												yrids,
												layerids,
												limits,
												deductibles,
												rst_covers,
												ann_loss2layer,
												ann_rst_premium)
colnames(shortrecord)=c("yrid","layerid","limit","deductible","rst_cover",
	"ann_loss2layer","ann_rst_premium")
#
summary=data.frame(	layeridsum,
										AAL2layer,
										premium,
										AA_rst_premium,
										AA_total_premium)
colnames(summary)=c("layerid","AAL2layer","premium","AA_rst_premium","AA_total_premium")

output=list(summary=summary,shortrecord=shortrecord,longrecord=longrecord)
}

#' Converts ELT rates into plotting positions for CEP, EEF and OEP
#'
#' @param elt			needs \code{mrate} only
#'
#' @details
#' One could debate what plotting positions to use, as always.
#' This one uses Hazen. Perhaps Weibull would be better.
#'
#' @returns
#' A list containing plotting positions for CEP, EEF and OEP
#'
#' @author
#' Stephen Jewson \email{stephen.jewson@@gmail.com}
#'
#' @example man/examples/example_420_elt_diagnostics_epcurves.R
#'
#' @export
#'
elt_diagnostics_epcurves=function(elt){
# copied from 'ep3 variable rates poisson'
nevents=length(elt$mrate)
er=elt$mrate
annualrate=sum(er)
ner=er/annualrate
#
# ner=normalized event rates (have to sum to one)
#
curves=matrix(0,3,nevents)
#
# assign cep
#
cep=matrix(0,nevents)
cep[1]=1-ner[1]/2
for (i in 2:nevents){cep[i]=cep[i-1]-ner[i-1]/2-ner[i]/2}
#
# calc EEF
#
eef=matrix(0,nevents)
for (i in 1:nevents){eef[i]=annualrate*cep[i]}
#
# calc eop
#
oep=1-exp(-eef)
#
curves[1,]=cep
curves[2,]=eef
curves[3,]=oep
return(list(cep=cep,eef=eef,oep=oep))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/803_hours_clause_apply_part2.R
\name{hours_clause_apply_part2}
\alias{hours_clause_apply_part2}
\title{Function that loops through events in one year and applies an hours clause}
\usage{
hours_clause_apply_part2(
  hcdays,
  hckm,
  byregion = FALSE,
  temploss,
  thisyearday,
  thisyearlon,
  thisyearlat,
  thisyearregion,
  nevents_in_year,
  k
)
}
\arguments{
\item{hcdays}{Hours clause parameter, number of days}

\item{hckm}{Hours clause parameter, distance in km}

\item{byregion}{Whether to use regions, or distances, to measure closeness}

\item{temploss}{Not sure. Part of the algorithm.}

\item{thisyearday}{For events in this year, the days}

\item{thisyearlon}{For events in this year, the lons}

\item{thisyearlat}{For events in this year, the lats}

\item{thisyearregion}{For events in this year, the regions}

\item{nevents_in_year}{Number of events in this year}

\item{k}{The index of the hours clause to apply, of all possible hours clauses}
}
\value{
A loss and a counter
}
\description{
Quite hard to understand.
Having previously found out which value of k gives the hours clause with the
largest loss, this routine applies the hours clause starting with that event.
It also registers which events have been moved, which part 1 does not do.
There are two separate, but very similar, routines, just to make the search
go faster, since in the initial search, there is no need to register which
events have been moved.
}
\details{
To be called from \code{hours_clause}, which loops thru the whole YLT,
and which itself is called from \code{hours_clause_wrapper}, which manages the file i/o.
}
\examples{
#
# 1 set the hours clause settings
#
hcdays=15
hckm=200
#
# 2 make a single year of a ylt
#
cat("1. make longylt:\n")
nyearsinylt=8
nevents_in_year1=10
thisyearloss	=seq(10,55,5)
thisyearday		=c(1	,2	,51	,101,151,201,251,300,350,360)
thisyearlat		=c(10	,11	,30	,30	,30	,30	,30	,30	,30	,50)
thisyearlon		=c(10	,11	,30	,30	,30	,30	,30	,30	,30	,50)
thisyearregion=rep("A",nevents_in_year1)
#
# 3 apply the hours clause routine to position 1
#
cat("1. apply the hours clause calculator:\n")
output=hours_clause_apply_part2(hcdays,hckm,byregion=FALSE,thisyearloss,
				thisyearday,thisyearlon,thisyearlat,thisyearregion,
				nevents_in_year1,k=1)
#
# 4 look at the output
#
cat("losses=",output$temploss,"\n")
cat("hccounter=",output$hccounter,"\n")
}
\references{
x
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/215_nahu_k2020_rates_interpolation.R
\name{nahu_k2020_rates_interpolation}
\alias{nahu_k2020_rates_interpolation}
\title{Interpolates rates in time}
\usage{
nahu_k2020_rates_interpolation(
  rcp,
  baseyear1,
  baseyear2,
  targetyear,
  k2020settings,
  frequnc,
  quantile,
  randomseed,
  gmst,
  landfall,
  test = FALSE,
  verbose = FALSE,
  reflectinputs = FALSE
)
}
\arguments{
\item{rcp}{rcp}

\item{baseyear1}{baseyear1}

\item{baseyear2}{baseyear2}

\item{targetyear}{targetyear}

\item{k2020settings}{k2020settings}

\item{frequnc}{frequnc}

\item{quantile}{quantile}

\item{randomseed}{randomseed}

\item{gmst}{gmst}

\item{landfall}{landfall}

\item{test}{test}

\item{verbose}{verbose}

\item{reflectinputs}{reflectinputs}
}
\value{
Mean rate, sd rate, and GMST change
}
\description{
Longer description
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/001_filetest.R
\name{filetest}
\alias{filetest}
\title{Testing using files}
\usage{
filetest(filename)
}
\arguments{
\item{filename}{the filename}
}
\value{
an integer read in from the file
}
\description{
This is just a test function to illustrate how to open files in functions
inside a package.
}
\details{
The answer to: how can I open a file in a function in a R package,
and test that using an example?
}
\examples{
#
filename=tempfile(fileext=".csv")
#
int=3
#
write.csv(int,file=filename,row.names=FALSE)
#
int2=filetest(filename)
#
message("temporary file name = ",filename)
message("before = ",int," and after = ",int2[1,1])




}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/584_ylt_diagnostics_aaeaal_by_cat_printf.R
\name{ylt_diagnostics_aaeaal_by_cat_printf}
\alias{ylt_diagnostics_aaeaal_by_cat_printf}
\title{Prints AAE and AAL from a YLT to the screen}
\usage{
ylt_diagnostics_aaeaal_by_cat_printf(
  longylt,
  nyearsinylt = 0,
  mincat,
  maxcat,
  verbose = FALSE
)
}
\arguments{
\item{longylt}{The YLT}

\item{nyearsinylt}{The number of years in the YLT.}

\item{mincat}{The minimum cat that is counted}

\item{maxcat}{The maximum cat that is counted}

\item{verbose}{Logical}
}
\value{
Prints changes in AAE, AAL to the screen
}
\description{
Just a way to print the results from \code{ylt_diagnostics_aaeaal_by_catf}
to the screen in a pretty way.
}
\examples{
#
# 1 make YLT
#
cat("1. make ylt1:\n")
year=c(1,1,1,2,2,3,3,3)
loss=seq(10,80,10)
cat=c(1,1,1,2,2,3,4,5)
longylt=data.frame(year,loss,cat)
#
# 2 look 
#
cat("2. print the diagnostics\n")
op=ylt_diagnostics_aaeaal_by_cat_printf(longylt,mincat=1,maxcat=5)
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/022_calc_beta_params.R
\name{calc_beta_params}
\alias{calc_beta_params}
\title{Calculate Beta Distribution Parameters for a List of Events}
\usage{
calc_beta_params(mloss, sloss, expo)
}
\arguments{
\item{mloss}{mean loss by event}

\item{sloss}{sd loss by event}

\item{expo}{exposure by event}
}
\value{
A list containing beta distribution alpha and beta parameters, by event.
}
\description{
Calculates beta distribution parameters from by-event values of
mean, standard deviation and exposure.
}
\details{
Maybe I should change this one at some point so that it reads in an ELT, rather
than just separate variables. But for now it reads 3 separate variables.
}
\examples{
#
# create inputs
#
mloss=seq(100,300,100)
sloss=seq(100,300,100)
expo=rep(1000,3)
#
params=calc_beta_params(mloss,sloss,expo)
#
print(params$eventalpha)
print(params$eventbeta)
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/537_ylt_check_for_2_events_on_same_day.R
\name{ylt_check_for_2_events_on_same_day}
\alias{ylt_check_for_2_events_on_same_day}
\title{Checks a YLT for two events on the same day}
\usage{
ylt_check_for_2_events_on_same_day(longylt)
}
\arguments{
\item{longylt}{The input longylt, which needs a \code{day} column.}
}
\value{
Screen output listing when there are two events on the same day
}
\description{
The assumption is that two events on the same day is bad, so if it
finds two events on the same day, it stops running, and gives a message
saying what day they are on.
}
\examples{
#
# 1 create a long YLT with cat
#
cat("1. make longylt:\n")
year=c(1,1,1,2,2)
day=c(1,2,3,4,5)
loss=rep(0,5) #needs an mloss column for long2short
longylt=data.frame(year,loss,day)
#
# 2 run the check
#
cat("4. run the diagnostics:\n")
op=ylt_check_for_2_events_on_same_day(longylt)
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/026_whatreg.R
\name{whatreg}
\alias{whatreg}
\title{Converts US state and country region abbreviations into numbers from 1 to 7.}
\usage{
whatreg(rg)
}
\arguments{
\item{rg}{Region abbreviations}
}
\value{
The region from 1 to 7
}
\description{
This is based on one particular method for assigning 7 regions to a NAHU model.
}
\details{
Uses the following regions:

region 1=c("TX","LA","MS","AL")

region 2=c("FL")

region 3=c("GA","SC","NC","VA")

region 4=c("MD","DE","RI","MA","ME","NY","NJ")

region 5=c("Mexico")

region 6=c("Panama","Costa Rica","Nicaragua","Honduras","El Salvador","Gautemala","Belize")

region 7=undefined
}
\examples{
reg="Mexico"
message("region input name = ",reg)
message("region output #   = ",whatreg(reg))
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/412_elt_diagnostics_aaeaal_with_adj.R
\name{elt_diagnostics_aaeaal_with_adj}
\alias{elt_diagnostics_aaeaal_with_adj}
\title{Calculates AAE and AAL from an ELT}
\usage{
elt_diagnostics_aaeaal_with_adj(elt, adjustmentsbycatevent)
}
\arguments{
\item{elt}{A data frame containing the ELT.
The ELT must contain \code{mrate}, \code{mloss} and \code{cat} columns.}

\item{adjustmentsbycatevent}{A matrix with rate adjustments (cat 1-ncat, event)
An adjustment of 1 means no change.
Copes with any number of cats, set by the first dimension of this matrix.}
}
\value{
AAE and AAL.
}
\description{
Calculates AAE and AAL from an ELT,
taking into account an input matrix of stochastic parameter adjustments by cat and event.
It doesn't produce an adjusted ELT, just gives the AAE and AAL you would get.
It could, for instance, be used to test code that produces adjusted YLTs.
}
\details{
For historical reasons the adjustments are stored in a matrix by cat-event, not just by event,
which is a bit inefficient.
I could change that at some point.
}
\examples{
#
# create an elt
#
mrate=seq(0.1,0.5,0.1)
mloss=seq(100,500,100)
cat=c(1,1,1,2,2)
elt=data.frame(mrate,mloss,cat)
#
# make the rate adjustments (two sets, for comparison)
#
adjustmentsbycatevent1=matrix(1,7,5)
adjustmentsbycatevent2=matrix(2,7,5)
#
# calculate the AAE and AAL 3 ways
#
op0=elt_diagnostics_aaeaal(elt)
op1=elt_diagnostics_aaeaal_with_adj(elt,adjustmentsbycatevent1)
op2=elt_diagnostics_aaeaal_with_adj(elt,adjustmentsbycatevent2)
#
cat("no adjustments (from the basic elt_diagnostics routine, for comparison):\n")
cat(" AAE=",op0$AAE,"\n")
cat(" AAL=",op0$AAL,"\n")
cat("no adjustments (from this routine, but with adjustments all set to 1):\n")
cat(" AAE=",op1$AAE,"\n")
cat(" AAL=",op1$AAL,"\n")
cat("with adjustments (this routine, with some actual adjustments):\n")
cat(" AAE=",op2$AAE,"\n")
cat(" AAL=",op2$AAL,"\n")
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/425_elt_add_nahu_cat.R
\name{elt_add_nahu_cat}
\alias{elt_add_nahu_cat}
\title{Adds a cat column to an elt, calculated from wind speed.}
\usage{
elt_add_nahu_cat(elt, units)
}
\arguments{
\item{elt}{A data frame containing the elt. Requires \code{wspd}.}

\item{units}{must be \code{knots}, or \code{mph}.}
}
\value{
A new elt with a cat column added, where cat runs from -1 to 5.
}
\description{
Takes an ELT, calculates NAHU cat from windspeed, and adds a column with cat.
The ELT has to contain windspeed to start with.
}
\details{
I've used the Wikipedia, and filled gaps with halves.
}
\examples{
#
# create an elt with just wind speed
#
wspd=seq(10,150,10)
elt1=data.frame(wspd)
#
# call
#
elt2=elt_add_nahu_cat(elt1,units="knots")
#
print(elt2)
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/581_ylt_diagnostics_aaeaal_printf.R
\name{ylt_diagnostics_aaeaal_printf}
\alias{ylt_diagnostics_aaeaal_printf}
\title{Prints AAE and AAL from a Long YLT to the screen}
\usage{
ylt_diagnostics_aaeaal_printf(longylt, nyearsinylt = 0)
}
\arguments{
\item{longylt}{A data frame containing the long YLT}

\item{nyearsinylt}{Sometimes, by chance, the long YLT might not have any
events in year 100, even
though technically it's supposed to be 100 years long. So it's good to specify
the number of actual years (in this example, 100). Then the short YLT will have
100 years in it. The last year just won't have any events in it. If you just leave
this to the default value of 0, then the short YLT will just stop at the last year
in the long YLT.}
}
\value{
Prints AAE, AAL to the screen
}
\description{
Because it's a longylt, you have to specify the \code{nyearsinylt}.
If you have a full ylt, better to use \code{ylt_diagnostics_aaeaal_print},
because then you don't have to specify that.
}
\examples{
#
# 1 create an ELT
#
evid=c(1,2,3)
mrate=c(1,1,1)
mloss=c(10,20,30)
elt=data.frame(evid,mrate,mloss)
#
# 2 create a YLT
#
longylt=yltsim(1000,elt)
#
# 3 call diagnostics
#
ylt_diagnostics_aaeaal_printf(longylt)
#
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/583_ylt_diagnostics_aaeaal_by_catf.R
\name{ylt_diagnostics_aaeaal_by_catf}
\alias{ylt_diagnostics_aaeaal_by_catf}
\title{Calculates YLT AAE and AAL by Cat}
\usage{
ylt_diagnostics_aaeaal_by_catf(
  longylt,
  nyearsinylt = 0,
  mincat = 999,
  maxcat = 999
)
}
\arguments{
\item{longylt}{A data frame containing the YLT}

\item{nyearsinylt}{The number of years in the YLT.}

\item{mincat}{The minimum cat that is counted}

\item{maxcat}{The maximum cat that is counted}
}
\value{
AAE, AAL, SAE and SAL.
}
\description{
Deals with the number-of-years issue because that's given by the shortylt.
}
\details{
Let me explain mincat and maxcat.
For hurricane the cat column goes from -1 to 5
the code deals with that using dcat
if you specify minc and maxc, then that's what it counts
if you don't specify them, it uses the data
but using the data has the problem that the returned data shape depends on the data
which is really awkward for any further processing
so it's best to specify
}
\examples{
#
# 1 make YLT
#
cat("1. make ylt1:\n")
year=c(1,1,1,2,2,3,3,3)
loss=seq(10,80,10)
cat=c(1,1,1,2,2,3,4,5)
longylt=data.frame(year,loss,cat)
#
# 2 look 
#
op=ylt_diagnostics_aaeaal_by_catf(longylt,mincat=1,maxcat=5)
print(op)
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/extendr-wrappers.R
\name{rust_square}
\alias{rust_square}
\title{Square an integer.
Just an example.}
\usage{
rust_square(x)
}
\arguments{
\item{x}{An integer.}
}
\value{
The square of the input.
}
\description{
Square an integer.
Just an example.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/420_elt_diagnostics_epcurves.R
\name{elt_diagnostics_epcurves}
\alias{elt_diagnostics_epcurves}
\title{Converts ELT rates into plotting positions for CEP, EEF and OEP}
\usage{
elt_diagnostics_epcurves(elt)
}
\arguments{
\item{elt}{needs \code{mrate} only}
}
\value{
A list containing plotting positions for CEP, EEF and OEP
}
\description{
Converts ELT rates into plotting positions for CEP, EEF and OEP
}
\details{
One could debate what plotting positions to use, as always.
This one uses Hazen. Perhaps Weibull would be better.
}
\examples{
#
# 1 make elt
#
nx=100
mrate=runif(nx)
elt=data.frame(mrate)
#
# 2 make the curves
#
op=elt_diagnostics_epcurves(elt)
#
# 3 add some loss data
#
loss=sort(rnorm(nx))
#
# 4 plot
#
old_par <- par(no.readonly = TRUE)
par(old_par)
par(mfrow=c(2,2))
#
plot(loss,op$cep,main="CEP")
lines(loss,op$cep,col="red")
#
plot(loss,op$eef,main="EEF")
lines(loss,op$eef,col="red")
#
plot(loss,op$oep,main="OEP")
lines(loss,op$oep,col="red")
#
par(old_par)


}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/000_template.R
\name{template}
\alias{template}
\title{A template for R code}
\usage{
template(x)
}
\arguments{
\item{x}{Input parameter \code{x}}
}
\value{
Something
}
\description{
Longer description here
}
\details{
Does something.

More details here.
}
\examples{
#
# set up all the arguments
#
rcp=8
baseyear1=1900
baseyear2=2022
targetyear=2099
k2020settings="Linear and Landfall"
frequnc="Use distribution"
quantile=90
randomseed=0
gmst=nahu_define_gmst_scenarios()
landfall=nahu_define_k2020_zenodo_landfall_adj()
#
# and calculate the implied landfall rates changes
#
rates=nahu_k2020_rates_interpolation(rcp,baseyear1,baseyear2,targetyear,
	k2020settings,frequnc,quantile,randomseed,gmst,landfall)
#
# have a look at region 1, mean change, all 7 cats
#
print(rates$mn1[1,])

}
\seealso{
\itemize{
\item \code{something else} 	Does something else
}
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/202_nahu_write_settings.R
\name{nahu_write_settings}
\alias{nahu_write_settings}
\title{Writes out settings to file for \code{nahu_ylt_surgery}}
\usage{
nahu_write_settings(
  ipfilename,
  settingsfilename,
  rcp,
  baseyear1,
  baseyear2,
  targetyear,
  k2020settings,
  frequnc,
  quantile,
  randomseed,
  manual,
  manualadjustments
)
}
\arguments{
\item{ipfilename}{ipfilename}

\item{settingsfilename}{settingsfilename}

\item{rcp}{rcp}

\item{baseyear1}{baseyear1}

\item{baseyear2}{baseyear2}

\item{targetyear}{targetyear}

\item{k2020settings}{k2020settings}

\item{frequnc}{frequnc}

\item{quantile}{quantile}

\item{randomseed}{randomseed}

\item{manual}{manual}

\item{manualadjustments}{manualadjustments}
}
\value{
Writes out a csv file
}
\description{
Writes out settings to file for \code{nahu_ylt_surgery}
}
\examples{
ipfilename="settings.csv"
settingsfilename=tempfile(fileext=".csv")
rcp=8
baseyear1=1900
baseyear2=2022
targetyear=2099
k2020settings="Linear and Landfall"
frequnc="Use distribution"
quantile=90
randomseed=0
manual=FALSE
manualadjustments=list(mn=1,sd=0)
#
nahu_write_settings(ipfilename,settingsfilename,rcp,baseyear1,baseyear2,targetyear,
		k2020settings,frequnc,quantile,randomseed,manual,manualadjustments)
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/582_ylt_diagnostics_aaeaal_change_print.R
\name{ylt_diagnostics_aaeaal_change_printf}
\alias{ylt_diagnostics_aaeaal_change_printf}
\title{Prints changes in AAE and AAL from a two longylts to the screen}
\usage{
ylt_diagnostics_aaeaal_change_printf(longylt1, longylt2, nyearsinylt = 0)
}
\arguments{
\item{longylt1}{A data frame containing longylt1}

\item{longylt2}{A data frame containing longylt2}

\item{nyearsinylt}{nyearsinylt}
}
\value{
Prints changes in AAE, AAL to the screen
}
\description{
Because they are longylts, requires the number of years.
}
\examples{
#
# 1 create an ELT
#
evid=c(1,2,3)
mrate=c(1,1,1)
mloss=c(10,20,30)
elt=data.frame(evid,mrate,mloss)
#
# 2 create YLTs
#
longylt1=yltsim(1000,elt)
longylt2=yltsim(1000,elt)
#
# 3 call diagnostics
#
ylt_diagnostics_aaeaal_change_printf(longylt1,longylt2)
#
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/411_elt_diagnostics_aaeaal_by_cat.R
\name{elt_diagnostics_aaeaal_by_cat}
\alias{elt_diagnostics_aaeaal_by_cat}
\title{Calculates AAE and AAL from an ELT, and by cat}
\usage{
elt_diagnostics_aaeaal_by_cat(elt)
}
\arguments{
\item{elt}{A data frame containing the ELT.
Must contain \code{mrate}, \code{mloss} and \code{cat} columns.
See the example for how to make the ELT.}
}
\value{
A list containing AAE and AAL, and then AAE and AAL by cat.
}
\description{
Calculates AAE and AAL from an ELT, and AAE and AAL by cat.
There can be any number of cats, labelled using integers.
So this routine is not only applicable to hurricane: the cat can indicate anything, for any peril.
}
\examples{
#
# create an elt with cat
#
mrate=seq(0.1,0.5,0.1)
mloss=seq(100,500,100)
cat=c(1,1,1,2,2)
elt=data.frame(mrate,mloss,cat)
#
op1=elt_diagnostics_aaeaal(elt)
op2=elt_diagnostics_aaeaal_by_cat(elt)
#
cat("AAE=",op1$AAE,"\n")
cat("AAL=",op1$AAL,"\n")
cat("AAEbycat=",op2$AAEbycat,"\n")
cat("AALbycat=",op2$AALbycat,"\n")
cat("AALbycatpc=",op2$AALbycatpc,"\n")
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/554_ylt_writeNresults2csv.R
\name{writeNresults2csv}
\alias{writeNresults2csv}
\title{Writes results from N YLTs to csv format.}
\usage{
writeNresults2csv(
  nyearsinylt,
  mincat,
  maxcat,
  nrp,
  nylt,
  maxnumberevents,
  bsaepsd,
  bsoepsd,
  aal,
  pcaal,
  aalbc,
  pcaalbc,
  aae,
  pcaae,
  aaebc,
  pcaaebc,
  nbc,
  probs,
  rps,
  aep,
  daep,
  oep,
  doep,
  lossthresholds,
  thresholdcounts,
  justone = FALSE,
  iylt
)
}
\arguments{
\item{nyearsinylt}{number of years}

\item{mincat}{minimum cat}

\item{maxcat}{maximum cat}

\item{nrp}{number of return periods}

\item{nylt}{number of ylts}

\item{maxnumberevents}{related to the threshold counting}

\item{bsaepsd}{bootstraps sds for AEP}

\item{bsoepsd}{bootstraps sds for OEP}

\item{aal}{AAL results}

\item{pcaal}{AAL as percentages}

\item{aalbc}{AAL results}

\item{pcaalbc}{AAL as percentages by cat}

\item{aae}{AAE results}

\item{pcaae}{AAE as percentages}

\item{aaebc}{AAE results by cat}

\item{pcaaebc}{AAE results as percentage}

\item{nbc}{Number by cat results}

\item{probs}{return probabilities being used}

\item{rps}{return levels being used}

\item{aep}{AEP results}

\item{daep}{AEP changes}

\item{oep}{OEP results}

\item{doep}{OEP changes}

\item{lossthresholds}{For the threshold counting}

\item{thresholdcounts}{threshold counting results}

\item{justone}{logical if there's just one run to be processed}

\item{iylt}{if there's just one, what is the i}
}
\value{
CSV output, for screen or file.
}
\description{
Writes various results from N YLTs to csv.
Can be used with \code{sink()} to make a nicely formatted csv file.
The result are:
AAE and AAL by cat, AEP, OEP and threshold counting.
}
\examples{
#' Uses the example for routine 201, \code{nahu_ylt_surgery}.
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/100_yltsim.R
\name{yltsim}
\alias{yltsim}
\title{Simulates a long YLT from a Poisson ELT}
\usage{
yltsim(nyearsinylt, elt, columns2copy = NULL, verbose = FALSE, secuncb = FALSE)
}
\arguments{
\item{nyearsinylt}{The number of years of simulation required.}

\item{elt}{A data frame containing the ELT.
Must contain \code{evid}, \code{mrate} and \code{mloss} columns, at least.}

\item{columns2copy}{Which extra columns to copy}

\item{verbose}{A logical.}

\item{secuncb}{A logical to indicate whether secondary uncertainty should be simulated.
Requires \code{sloss} and \code{expo} columns.}
}
\value{
A data frame containing a long YLT.
}
\description{
Simulates a long YLT (long format year loss table) from an ELT (event loss table)
using the Poisson distribution,
with or without secondary uncertainty.
Copies standard columns by default, and extra columns if asked to.
Previous versions included the short YLT, but now the idea is that this routine
just produces the longylt, and \code{ylt_long2short} can be used to generate
the shortylt if it is required.
}
\details{
Uses Poisson simulation.

The ELT data frame must contain the following two columns
\itemize{
\item \code{evid:  } The event ids
\item \code{mloss: } The mean losses by event
\item \code{mrate: } The mean rates by event (can be constant if appropriate).
}

If secondary uncertainty is required, the ELT data frame must also contain
the following two columns:
\itemize{
\item \code{sloss: } The standard deviation of losses by event
\item \code{expo: }  The exposure by event
}

The following columns will be passed through into the output YLT.
\itemize{
\item \code{evid: }
\item \code{mloss:}
}
Other columns can be passed thru if they are specified (see the example).

The whole issue of event ids is complicated. Here's what I do:
\itemize{
\item \code{evid: } 	The event id. This will have
whatever numbers it had in the ELT. They don't have to start from one.
This might end up
repeated in the YLT, if the simulations end up repeating that event.
\item \code{eltrow: } 	I number the events in the ELT from 1. This is that number.
This might end up
repeated in the YLT, if the simulations end up repeating that event.
\item \code{yltrow: } 	I number the events in the YLT from 1. This is that number.
This will not repeat in the YLT, even if two events are the same.
So this is just the row in the YLT.
}
}
\examples{
#
# create an elt with 3 rows
#
set.seed(1)
#
# essential parameters
evid=seq(1000,1002,1) 
mrate=seq(0.1,0.3,0.1)
mloss=seq(100,300,100)
#
# optional parameters
wspd=c(50,51,52) #testing copying extra columns
region=c("A","B","C")
#
# make the input elt
elt=data.frame(evid,mrate,mloss,wspd,region)
print(elt)
#
# and simulate a ylt with 5 years
#
longylt=yltsim(5,elt,columns2copy=c("wspd","region"))
#
message("Here's the simulated long ylt:")
print(longylt)
#
shortylt=ylt_long2short(longylt,nyearsinylt=5)
#
message("And here's a short ylt derived from it:")
print(shortylt)

}
\seealso{
\itemize{
\item \code{yltsim_inc: } 	YLT simulation, but incrementally.
\item \code{yltreduce: } 		YLT length reduction
\item \code{eltmerge: }  A routine for merging historical and model ELTs
\item \code{catxl: }  A routine for evaluating catxl towers.
}
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/415_elt_collapse_regions.R
\name{elt_collapse_regions}
\alias{elt_collapse_regions}
\title{For an ELT with multiple occurrences of each event, collapses to 1 per event}
\usage{
elt_collapse_regions(elt1, columns2copy = NULL, combine = TRUE, verbose = TRUE)
}
\arguments{
\item{elt1}{A data frame containing the ELT.
The ELT must contain \code{evid}.}

\item{columns2copy}{Copies these columns into the output}

\item{combine}{If false, then just copies the first set of values}

\item{verbose}{Logical for verbose or not}
}
\value{
A new ELT with just single occurrence of each event
}
\description{
Takes in an ELT that might have multiple occurrences of each event,
representing different regions, and combines them together to give
one occurrence of that event.
Assumes that the occurrences of each event are consecutive.
Processes other columns cleverly, depending on what they contain.
For instance, adds up losses and exposures, counts regions.
}
\details{
Recognizes and processes the following columns if they exist:
\code{mloss} (sums them up),
\code{sloss} (assumes independent),
\code{expo}	(sums them up),
\code{mrate} (copies the first one).
\code{lfreg} (counts them).
For other specified columns, copies the first value for each event.
How to combine \code{sloss} though? Right now I'm using independence.
But presumably I should use correlation of secondary uncertainty.
}
\examples{
#
# create an elt
#
evid=c(1,2,2,3,3,3,4,4,4,4) #evid is required
#mloss is not required, but is processed intelligently
mloss=rep(1,10)
#jim is not required, but is copied because we specify that
jim=c(1000:1009)
bob=c(2000:2009)
#
elt1=data.frame(evid,mloss,jim,bob)
elt2=elt_collapse_regions(elt1,columns2copy=c("jim"),verbose=TRUE)
#
message("elt1=\n")
print(elt1)
message("elt2=\n")
print(elt2)
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/422_elt_rate_adjustments_cat_2_event.R
\name{elt_rate_adjustments_cat_2_event}
\alias{elt_rate_adjustments_cat_2_event}
\title{Converts rate adjustments from cat to event, for events in an ELT}
\usage{
elt_rate_adjustments_cat_2_event(elt, rate_adjustments_by_cat)
}
\arguments{
\item{elt}{A data frame containing the ELT. Requires \code{cat}.}

\item{rate_adjustments_by_cat}{A list of two vectors containing the mean and sd adjustments by cat,
given by \code{adjustments_by_cat$mn}, \code{adjustments_by_cat$sd}}
}
\value{
A matrix with the adjustments by event
column 1 is the mean of the adjustments.
column 2 is the sd of the adjustments.
}
\description{
Converts rate adjustments by cat to rate adjustments by event.
So that you can specify rate adjustments by cat (which is easy to do),
and then run this routine to assign those adjustments to all the events
in an ELT.
}
\details{
Doesn't do anything except just copy the adjustments. No calculations.
Cat is a positive integer.
}
\examples{
#
# create an elt
#
cat=c(1,2,2,3,3,3) #only cat is required
elt=data.frame(cat)
#
# make the adjustments by cat
#
rate_adjustments_by_cat=list(mn=c(2,4,6),sd=c(0,0,0))
#
# call
#
rate_adjustments_by_event=elt_rate_adjustments_cat_2_event(elt,rate_adjustments_by_cat)
#
print(elt)
print(rate_adjustments_by_event)
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/extendr-wrappers.R
\name{rust_hours_clause_apply_part2}
\alias{rust_hours_clause_apply_part2}
\title{Hours clause function
For a given start event, calculates all possible hours clauses, returns new losses AND a counter}
\usage{
rust_hours_clause_apply_part2(
  hcdays,
  hckm,
  byregion,
  temploss,
  thisyearday,
  thisyearlon,
  thisyearlat,
  thisyearregion,
  nevents_in_year,
  k
)
}
\arguments{
\item{hcdays}{Definition of the hours clause in days}

\item{hckm}{Definition of the hours clause in km}

\item{byregion}{Whether to use regions, or distances, to measure closeness}

\item{temploss}{The losses by event for this year}

\item{thisyearday}{The days by event for this year}

\item{thisyearlon}{The lons by event for this year}

\item{thisyearlat}{The lats by event fo rthis year}

\item{thisyearregion}{For events in this year, the regions}

\item{nevents_in_year}{The number of events in the full year}

\item{k}{The starting event}
}
\value{
Returns a vector of the new losses
}
\description{
Hours clause function
For a given start event, calculates all possible hours clauses, returns new losses AND a counter
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/800_hours_clause_wrapper_ylt.R
\name{hours_clause_wrapper_ylt}
\alias{hours_clause_wrapper_ylt}
\title{Applies an hours clause to a long YLT stored in csv file, and returns the adjusted
YLT in memory and to a csv file}
\usage{
hours_clause_wrapper_ylt(
  ipfilename,
  settingsfilename,
  opfilename,
  nyearsinylt,
  hcdays,
  hckm,
  byregion,
  rust,
  rrrr,
  test = FALSE,
  verbose = FALSE
)
}
\arguments{
\item{ipfilename}{Input filename containing the input long YLT}

\item{settingsfilename}{Output filename for the settings output}

\item{opfilename}{Output filename containing the output YLT}

\item{nyearsinylt}{Number of years in the input YLT}

\item{hcdays}{Hours clause parameter, number of days}

\item{hckm}{Hours clause parameter, distance in km}

\item{byregion}{Whether to use regions, or distances, to measure closeness}

\item{rust}{Rust flag}

\item{rrrr}{R flag}

\item{test}{Logical, not sure what it does}

\item{verbose}{Logical, meaning obvious}
}
\value{
A data frame containing the original long YLT, and the adjusted YLTs.
}
\description{
Can be called from \code{800_hours_clause_wrapper_example}.
}
\details{
Just a pretty dumb wrapper, that writes out the settings, reads the input file, checks it,
looks at some diagnostics, calls the hours clause routine to
apply the hours clause, looks at some diagnostics, writes out the results and returns the results.
}
\examples{
#
# 1 make filenames
#
ipfilename=tempfile(fileext=".csv")
opfilename=tempfile(fileext=".csv")
settingsfilename=tempfile(fileext=".csv")
#
# 2 set the hours clause settings
#
hcdays=15
hckm=200
#
# 3 make an 8 year ylt with 10 events
#
cat("1. make longylt:\n")
nyearsinylt=8
year	=c(1	,1	,1	,2	,4	,5	,6	,7	,8	,8)
day		=c(1	,2	,51	,101,151,201,251,300,350,360)
evid	=c(1	,2	,3	,4	,5	,6	,7	,8	,9	,10)
lat		=c(10	,11	,30	,30	,30	,30	,30	,30	,30	,50)
lon		=c(10	,11	,30	,30	,30	,30	,30	,30	,30	,50)
region=c("A"	,"A"	,"B"	,"B"	,"B"	,"B"	,"B"	,"B"	,"B"	,"B")
loss	=seq(10,55,5)
longylt=data.frame(year,day,evid,lat,lon,loss,region)
write.csv(longylt,file=ipfilename,row.names=FALSE)
#
# 4 apply the hours clause and generate a new ylt
#
ylts=hours_clause_wrapper_ylt(ipfilename,settingsfilename,opfilename,nyearsinylt,
	hcdays,hckm,
	byregion=TRUE,
	rust=TRUE,rrrr=FALSE,
	test=FALSE,verbose=TRUE)
#
longylt1=ylts$longylt1
longylt2=ylts$longylt2
#
print(head(longylt1,n=6))
print(head(longylt2,n=6))
#
#
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/027_input_checks.R
\name{input_checks}
\alias{input_checks}
\title{Checks the columns in an input data frame.}
\usage{
input_checks(df, names, location = FALSE)
}
\arguments{
\item{df}{data frame to check}

\item{names}{names to check}

\item{location}{print where it's being called from}
}
\value{
x
}
\description{
A utility that checks the columns in the input data frame versus a list of required names
}
\examples{
#
# make an elt
#
set.seed(1)
evid=c(1,2,3)
mrate=seq(0.1,0.3,0.1)
mloss=seq(100,300,100)
elt=data.frame(evid,mrate,mloss)
print(elt)
#
# and check if it contains the two columns
#
input_checks(elt,c("evid","mrate","mloss"))
#
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/590_ylt_diagnostics_loss_thresholds.R
\name{ylt_diagnostics_loss_thresholds}
\alias{ylt_diagnostics_loss_thresholds}
\title{Counts number of events per year above loss thresholds}
\usage{
ylt_diagnostics_loss_thresholds(
  longylt,
  lossthresholds,
  maxnumber = 12,
  countequalto = TRUE
)
}
\arguments{
\item{longylt}{A data frame containing the long YLT}

\item{lossthresholds}{A vector of loss thresholds}

\item{maxnumber}{Count up to this number of events}

\item{countequalto}{Logical for how to count}
}
\value{
A matrix (lossthresholds by events) with the counts
}
\description{
Reads in a longylt, and some thresholds, and counts the number of years in which
there are \code{n} or more events exceeding each loss threshold
(think carefully: it's a complicated thing actually).
}
\examples{
#
# 1 create a YLT
#
cat("1. longylt:\n")
year=c(1,1,1,2,2,3,3,4,4,4,5,5,5,5,5)
loss=seq(10,150,10)
longylt=data.frame(year,loss)
print(head(longylt))
#
cat("\n2. calculate results by loss thresholds:\n")
lossthresholds=c(10,30)
maxnumber=3
op=ylt_diagnostics_loss_thresholds(longylt,lossthresholds,maxnumber)
print(op)
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/025_bootstrap_ep_uncertainty.R
\name{bootstrap_ep_uncertainty}
\alias{bootstrap_ep_uncertainty}
\title{Bootstrap EP uncertainty}
\usage{
bootstrap_ep_uncertainty(losses, nbs, rps)
}
\arguments{
\item{losses}{A vector of losses}

\item{nbs}{The number of bootstrap resamples required}

\item{rps}{The return periods required}
}
\value{
A vector of standard deviations, one for each return level
}
\description{
Reads in a vector of annual losses, bootstraps, and calculates
the standard deviation of losses at a list of return levels
}
\details{
Can be used with \code{make_ep_by_sorting}, for the basic EP curve.
Obviously using more bootstrap samples is better, but slower.
}
\examples{
#
# 1 create losses
#
message("1. make losses")
losses=seq(1,1000,1)
#
# 2 set the return periods to look at
#
rps=c(2,3,4,5,10,20,50,100)
#
#
message("2. calculate the losses at the given return levels")
ep=make_ep_by_sorting(losses,rps)
print(ep)
#
message("3. calculate the sd of the uncertainty around those losses")
epsd=bootstrap_ep_uncertainty(losses,nbs=100,rps)
#
print(epsd)

}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/101_yltsim_inc.R
\name{yltsim_inc}
\alias{yltsim_inc}
\title{Simulates an Adjusted long YLT using Incremental Simulation,
based on an input ELT and long YLT}
\usage{
yltsim_inc(
  elt,
  longylt1,
  rate_adjustments_by_event,
  verbose = FALSE,
  secuncb = FALSE,
  randomday = TRUE
)
}
\arguments{
\item{elt}{A data frame containing the ELT.
Must contain \code{mrate} and \code{mloss} columns.}

\item{longylt1}{A data frame containing a longylt in the format produced by the routine \code{yltsim()}.}

\item{rate_adjustments_by_event}{A matrix of multiplicative adjustments for the Poisson rate.
The first column gives the mean rate adjustment and the second column gives the standard deviation of the rate adjustment. Both columns must be of same length as the columns in \code{elt}.}

\item{verbose}{A logical.}

\item{secuncb}{A logical to indicate whether secondary uncertainty should be simulated
(requires \code{sloss} column). Not implemented yet.}

\item{randomday}{A logical. \code{TRUE} means days are randomized, \code{FALSE} means they are copied.}
}
\value{
A data frame containing the new long YLTs.
}
\description{
You have an ELT. And you have a long YLT that you have previously simulated from the ELT using
Poisson simulation (perhaps using the \code{longyltsim}).
Now you want to simulate an adjusted version of the long YLT, based on multiplicative
adjustments which are specified for each event in the ELT, as a mean and a sd for each event.
}
\details{
The simulated long YLT is copied from the input long YLT, and events are then added and deleted to reflect
the specified rates changes, according to the 'incremental simulation' algorithm.
This algorithm is relevant for the workflow situation in which the base long YLT was simulated from the ELT.
If you have a long YLT that wasn't simulated from an ELT, or you've lost the ELT, use \code{yltsurgery} instead.
Incremental simulation attempts to minimize differences due to random noise between the two YLTs
and gives more accurate estimates of change than just simulating the second YLT using independent simulation.
The rates changes are specified by event.
They can be scalar or log-normal distributed, or other distributed, in order to capture adjustment uncertainty.
Adjustment uncertainty is simulated using the 'stochastic parameter' simulation algorithm.
Changes within years are perfectly correlated.

The input mean and standard deviation rate adjustments are used to define a log-normal distribution for each event.
The log-normal is used to simulate different rate adjustments for each year.
The log-normal adjustments are perfectly correlated between different events.

The assumption is that YLT1 was sampled from the ELT, using the rates in the ELT.
The rate adjustments are specified for all the events in the ELT
(some of which may not even occur in YLT1).
The eltrow in the longylt in YLT1 must correspond to the events in the ELT and in the specified rate adjustments
(which it will if the longylt was created by \code{longyltsim}.
The algorithm consists of two parts.
In the first part, events may or may not be copied from YLT1 to YLT2, depending on a coin flip,
based on a probability derived from the rate adjustment.
If there is no adjustment, an event will be copied. If there is a large reduction in the rate,
it may well not be copied.
The longylt part of YLT1 provides the eltrow for each event, which is used to determine the rate adjustment.
In the second part, events with increasing rates are selected randomly from the ELT (weighted by the increase),
and added to the YLT.

The whole issue of event ids is complicated. Here's what I do:
\itemize{
\item \code{evid: } 	An event id. This will have
whatever numbers it had in the ELT. They don't have to start from one.
This might end up
repeated in the YLT, if the simulations end up repeating that event.
\item \code{eltrow: } 	I number the events in the ELT from 1. This is that number.
This might end up
repeated in the YLT, if the simulations end up repeating that event.
\item \code{oldyltrow: } 	For new events, there is no \code{oldyltrow}, because new events are selected
from the ELT, not the old YLT, and so the value is not uniquely defined.
\item \code{yltrow: } 	The row in the new YLT. Might well not be the same as the
row in the old YLT, because of new events being added.
This doesn't repeat in the new YLT.
}
}
\examples{
#
# create an elt with 3 rows
#
set.seed(1)
evid=seq(1000,1002,1)
mrate=seq(0.1,0.3,0.1)
mloss=seq(100,300,100)
elt=data.frame(evid,mrate,mloss)
nevents=length(mrate)
message("*************************elt*************************")
print(elt)
#
# simulate longylt1 with 15 years
#
nyears=15
longylt1=yltsim(nyears,elt)
message("*************************ylt1*************************")
print(longylt1)
#
# define adjustments
#
rate_adjustments_by_event=matrix(0,nevents,2)
rate_adjustments_by_event[,1]=2 #double the rates
rate_adjustments_by_event[,2]=0
#
# simulate longylt2 with those adjustments
#
longylt2=yltsim_inc(elt,longylt1,rate_adjustments_by_event)
message("*************************ylt2*************************")
print(longylt2)

}
\references{
For the stochastic parameter simulation algorithm see: https://doi.org/10.1007/s00477-023-02409-0

and: https://en.wikipedia.org/wiki/Year_loss_table#Incremental_Simulation

For the incremental simulation algorithm see: https://doi.org/10.1007/s00477-022-02198-y

and: https://en.wikipedia.org/wiki/Year_loss_table#Stochastic_Parameter_YLTs
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/003_make_elt.R
\name{make_elt}
\alias{make_elt}
\title{Make an ELT in memory}
\usage{
make_elt()
}
\value{
Nothing.
}
\description{
This code does nothing at all. But the example shows how to make an ELT in memory.
}
\details{
This code just exists as a way to present the example.
}
\examples{
#
# create an elt with 10 rows
#
set.seed(1)
#
# essentials
evid=seq(1000,1009,1) 
mrate=rep(0.1,10)
mloss=seq(100,1000,100)
#
# add an optional column
wspd=seq(50,59,1) 
#
# now make the elt
# the ordering of columns isn't important, but the following is standard
elt=data.frame(evid,mrate,mloss,wspd)
#
# and have a look at it, in different ways
print(elt)
head(elt,n=5)
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/580_ylt_diagnostics_aaeaal.R
\name{ylt_diagnostics_aaeaal}
\alias{ylt_diagnostics_aaeaal}
\title{Long YLT Diagnostics}
\usage{
ylt_diagnostics_aaeaal(longylt, nyearsinylt = 0)
}
\arguments{
\item{longylt}{A data frame containing the long YLT}

\item{nyearsinylt}{Sometimes, by chance, the long YLT might not have any
events in year 100, even
though technically it's supposed to be 100 years long. So it's good to specify
the number of actual years (in this example, 100). Then the short YLT will have
100 years in it. The last year just won't have any events in it. If you just leave
this to the default value of 0, then the short YLT will just stop at the last year
in the long YLT.}
}
\value{
AAE, AAL, SAE and SAL.
}
\description{
Long YLT diagnostics,
Works by creating a shortylt using \code{ylt_long2short}, and then using \code{ylt_diagnostics_aaeaal}.
A bit stupid because the output contains blank weighted values, because \code{ylt_long2short},
returns weighted values, but there's no way in this case to set the weights.
Oh well, never mind. It's fine.
You don't really need this one. You can always use \code{ylt_long2short} yourself,
and then use \code{ylt_diagnostics_aaeaal}.
So this is a good candidate for deletion tbh.
}
\examples{
#
# 1 create an ELT
#
evid=c(1,2,3)
mrate=c(1,1,1)
mloss=c(10,20,30)
elt=data.frame(evid,mrate,mloss)
#
# 2 create a YLT
#
longylt=yltsim(1000,elt)
#
# 3 call diagnostics
#
op=ylt_diagnostics_aaeaal(longylt)
#
cat(" AAE=",op$AAE,"\n")
cat(" AAL=",op$AAL,"\n")
cat(" SAE=",op$SAE,"\n")
cat(" SAL=",op$SAL,"\n")
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/552_ylt_write2results2csv.R
\name{ylt_write2results2csv}
\alias{ylt_write2results2csv}
\title{Writes results from 2 YLTs to csv format.}
\usage{
ylt_write2results2csv(longylt1, longylt2, rps)
}
\arguments{
\item{longylt1}{The first YLT}

\item{longylt2}{The first YLT}

\item{rps}{The return periods you want to calculate}
}
\value{
A csv file.
}
\description{
Writes various results from 2 YLTs to a csv format.
Not to a csv file...but to standard output that could be sent to a csv file
using the \code{sink()} function.
The result are:
AAE and AAL by cat, and AEP.
}
\examples{
#
# 1 create YLT1
#
year=c(1,1,2,2,3)
cat=c(1,2,3,4,5)
loss=seq(10,50,10)
longylt1=data.frame(year,cat,loss)
#
# 2 create YLT2
#
year=c(1,1,2,2,3)
cat=c(1,2,3,4,5)
loss=seq(110,150,10)
longylt2=data.frame(year,cat,loss)
#
# 3 do it
#
rps=c(2,5,10,50,100,130,200,250,500,1000,5000)
ylt_write2results2csv(longylt1,longylt2,rps)


}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/563_ylt_rate_adjustments_catreg_2_row.R
\name{ylt_rate_adjustments_catreg_2_row}
\alias{ylt_rate_adjustments_catreg_2_row}
\title{Makes rates adjustments by event, for events in a YLT}
\usage{
ylt_rate_adjustments_catreg_2_row(longylt, ratesbycatreg)
}
\arguments{
\item{longylt}{A data frame containing the long YLT}

\item{ratesbycatreg}{A list containing the mean and sd adjustments, each of which is a
matrix with dimensions nregions x ncat.}
}
\value{
A matrix with the adjustments by event
column 1 is the mean of the adjustments.
column 2 is the sd of the adjustments.
}
\description{
Maps rate adjustments by cat and region to rate adjustments by event, which
is what \code{yltsurgery} needs as input.
}
\examples{
#
# 1 create a 10 year YLT
# -2 regions
# -7 cats
#
cat("1. longylt:\n")
year	=c(1,1,1,2,2,3,3,4,4,4)
cat		=c(-1,0,1,2,3,4,5,5,5,5)
region=c(1,1,1,1,1,2,2,2,2,2)
longylt=data.frame(year,cat,region)
print(head(longylt))
#
# 2 make adjustments
#
mn=matrix(0,2,7)
for (i in 1:2){
	for (j in 1:7){
		mn[i,j]=(i-1)*cat[j]+cat[j]
	}
}
sd=matrix(0,2,7)
ratesbycatreg=list(mn=mn,sd=sd)
# 3 convert adjustments
#
adj=ylt_rate_adjustments_catreg_2_row(longylt,ratesbycatreg)
print(head(adj))
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/000_imports.R
\name{imports}
\alias{imports}
\title{Imports}
\usage{
imports()
}
\description{
Centralized imports
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/540_ylt_add_region_2_longylt.R
\name{ylt_add_region_2_longylt}
\alias{ylt_add_region_2_longylt}
\title{Adds a region column to a longylt, based on the lat-lons already in the longylt}
\usage{
ylt_add_region_2_longylt(longylt)
}
\arguments{
\item{longylt}{A data frame containing the long YLT. Must contain
\code{year}, \code{lflat}, \code{lflon}.}
}
\value{
A new ylt with a region column added
}
\description{
Calculates region from lat lon
(where the regions relate to the Jewson (2023) BAMS paper).
}
\examples{
#
# 1 create a YLT
#
cat("1. longylt:\n")
year=c(1,2)
lflat=c(40,10)
lflon=c(-40,-40)
loss=c(10,20)
longylt=data.frame(year,loss,lflat,lflon)
print(longylt)
#
op=ylt_add_region_2_longylt(longylt)
print(op)
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/023_make_ep_by_sorting.R
\name{make_ep_by_sorting}
\alias{make_ep_by_sorting}
\title{Make an EP curve by sorting losses}
\usage{
make_ep_by_sorting(losses, rps)
}
\arguments{
\item{losses}{A vector of annual losses}

\item{rps}{A vector of return periods at which losses are required
Must be 1 or greater.}
}
\value{
Losses at the specified return periods, as integers.
}
\description{
Reads in a vector of losses, sorts them, and picks out certain return level losses
}
\details{
Assumes the input losses are one loss per year.
}
\examples{
#
# 1 create losses
#
cat("1. make losses:\n")
losses=seq(1,1000,1)
#
# 2 set the return periods to look at
#
rps=c(0.5,1,2,3,4,5,10,20,50,100,1000,10000)
#
cat("2. calculate the EP:\n")
op=make_ep_by_sorting(losses,rps)
#
print(op)

}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/500_ylt_long2short.R
\name{ylt_long2short}
\alias{ylt_long2short}
\title{Calculate a Short YLT from a Long YLT}
\usage{
ylt_long2short(
  longylt,
  nyearsinylt = 0,
  zeroeventyearsincluded = TRUE,
  verbose = FALSE
)
}
\arguments{
\item{longylt}{A data frame containing the long YLT}

\item{nyearsinylt}{Sometimes, by chance, the long YLT might not have any
events in year 100, even
though technically it's supposed to be 100 years long. So it's good to specify
the number of actual years (in this example, 100). Then the short YLT will have
100 years in it. The last year just won't have any events in it. If you just leave
this to the default value of 0, then the short YLT will just stop at the last year
in the long YLT.}

\item{zeroeventyearsincluded}{What if year 17 doesn't have any events in it? Should
it be included in the short YLT? Yes, it should. And that's the default.
But if you set this to FALSE, then that year will not be included.}

\item{verbose}{If you set this to true, you get some nice information about the
number of years, etc.}
}
\value{
A data frame containing the short YLT, with columns
\code{year}, \code{longylt_start_row}, \code{nevents_in_year},
\code{loss_in_year}, \code{max_loss_in_year}.
Note that if there are years that are missing from the long YLT because they
don't contain any events, they will be listed as start_row=NA, nevents=0.
You might think I could just put the start now, not NA.
But if this is the last year, you need NA, because there is no row in the long YLT.
}
\description{
Calculates a Short YLT from a Long YLT.
Requires \code{year} and \code{loss}.
Assumes that the \code{year} should start from 1 (if there is an event in the first year).
Assumes that the years are in order.
The short YLT output includes years that have no events in the long YLT input.
The example shows how to combine them to make a full YLT.
}
\examples{
#
# 1 create a long YLT with cat
#
cat("1. make the longylt:\n")
year=c(1,1,1,2,4,5,6,7,8,8)
loss=seq(10,55,5)
cat=c(1,2,3,4,5,6,7,8,9,10)
longylt=data.frame(year,loss,cat)
print(longylt)
#
# 2 make the shortylt
#
cat("2. make the shortylt:\n")
shortylt=ylt_long2short(longylt,nyearsinylt=10)
print(shortylt)


}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/805_hours_clause_write_settings.R
\name{hours_clause_write_settings}
\alias{hours_clause_write_settings}
\title{When using \code{hours_clause_wrapper}, writes out the settings to a file.}
\usage{
hours_clause_write_settings(
  ipfilename,
  settingsfilename,
  opfilename,
  time,
  distance
)
}
\arguments{
\item{ipfilename}{Input filename containing the input long YLT}

\item{settingsfilename}{Output filename for the settings output}

\item{opfilename}{Output filename containing the input long YLT}

\item{time}{Hours clause parameter, number of days}

\item{distance}{Hours clause parameter, distance in km}
}
\value{
Just writes to a file
}
\description{
Just for record keeping.
}
\details{
Just to provide a record of each analysis.
}
\examples{
#
# 1 make filenames
#
ipfilename=tempfile(fileext=".csv")
opfilename=tempfile(fileext=".csv")
settingsfilename=tempfile(fileext=".csv")
#
# 2 hc settings
#
time=1
distance=2
#
# 3 call the routine
#
hours_clause_write_settings(ipfilename,settingsfilename,opfilename,time,distance)
#
# 4 have a look at the file it produced
#
x=read.csv(settingsfilename)
print(x)


}
\references{
x
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/002_stop_intentionally.R
\name{stopi}
\alias{stopi}
\title{Stops code intentionally, with message that says that}
\usage{
stopi(location = FALSE)
}
\arguments{
\item{location}{An optional string giving the routine being called from, which is then
included in the message.}
}
\value{
A message to the screen.
}
\description{
Stops execution and returns a message saying the stop was intentional
}
\details{
Not much more to say about this really.
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/801_hours_clause.R
\name{hours_clause}
\alias{hours_clause}
\title{Applies an hours clause to a long YLT, and returns a YLT}
\usage{
hours_clause(
  longylt1,
  hcdays,
  hckm,
  byregion = FALSE,
  rust,
  rrrr,
  verbose = FALSE
)
}
\arguments{
\item{longylt1}{The input long YLT}

\item{hcdays}{Hours clause parameter, number of days}

\item{hckm}{Hours clause parameter, distance in km}

\item{byregion}{Whether to use regions, or distances, to measure closeness}

\item{rust}{Rust logical}

\item{rrrr}{R logical}

\item{verbose}{Logical, meaning obvious}
}
\value{
A long YLT with hours clause applied.
}
\description{
I could simplify the code by just returning a long YLT,
and then leaving the user to create a short YLT using long2short.
}
\details{
Can be called from \code{hours_clause_wrapper}, which manages the file i/o.
Note that exactly what 'applying an hours clause' means some explanation.
We don't have access to footprints, just days of the year (one day per event)
and locations (one point per event). The algorithm looks at the days and
the locations and merges events which are close in both time and space. It only
applies a maximum of one hours clause per year, which is chosen to give the
maximum possible event loss (i.e., the largest possible max loss recovery
for the cedant).
}
\examples{
#
# 1 set the hours clause settings
#
hcdays=15
hckm=200
#
# 2 make an 8 year ylt with 10 events
#
cat("1. make longylt:\n")
nyearsinylt=8
year	=c(1	,1	,1	,2	,4	,5	,6	,7	,8	,8)
day		=c(1	,2	,51	,101,151,201,251,300,350,360)
evid	=c(1	,2	,3	,4	,5	,6	,7	,8	,9	,10)
lat		=c(10	,11	,30	,30	,30	,30	,30	,30	,30	,50)	
lon		=c(10	,11	,30	,30	,30	,30	,30	,30	,30	,50)	
loss	=seq(10,55,5)
longylt1=data.frame(year,day,evid,lat,lon,loss)
#
# 3 apply the hours clause and generate a new ylt
#
longylt2=hours_clause(longylt1,hcdays,hckm,rust=FALSE,rrrr=TRUE,verbose=TRUE)
#
print(head(longylt1,n=10))
print(head(longylt2,n=10))
#
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/538_ylt_check_for_same_events_in_one_year.R
\name{ylt_check_for_same_events_in_one_year}
\alias{ylt_check_for_same_events_in_one_year}
\title{Checks a YLT for the same event occurring twice in one year}
\usage{
ylt_check_for_same_events_in_one_year(longylt)
}
\arguments{
\item{longylt}{The input long, which needs a \code{evid} column.}
}
\value{
Screen output listing when an event occurs twice in the same year
}
\description{
The assumption is that this is undesirable, and so if it happens
then the code stops and reports back when it happened.
}
\examples{
#
# 1 create a long YLT with evid
#
cat("1. make longylt:\n")
year=c(1,1,1,2,2)
loss=rep(0,5) 
evid=c(1,2,3,4,5)
longylt=data.frame(year,loss,evid)
#
# 2 run the check
#
cat("4. run the diagnostics:\n")
op=ylt_check_for_same_events_in_one_year(longylt)
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/004_make_longylt.R
\name{make_ylt}
\alias{make_ylt}
\title{Make an YLT in memory}
\usage{
make_ylt()
}
\value{
Nothing.
}
\description{
This code does nothing at all. But the example shows how to make a YLT in memory.
}
\details{
This code just exists as a way to present the example.
}
\examples{
#
# create an long ylt with 4 years and 10 events
#
set.seed(1)
#
# essentials, illustrating:
# -multiple events in one year
# -some events repeat, but could have different losses
yrid=c(1,1,1,2,2,2,3,3,4,4)
evid=c(1000,1001,1002,1003,1001,1004,1005,1000,1006,1007) 
loss=seq(100,1000,100)
#
# now make the ylt
# column ordering is optional, but the following is standard
longylt=data.frame(yrid,evid,loss)
#
# and have a look at it, in different ways
print(longylt)
head(longylt,n=5)
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in
%   R/585_ylt_diagnostics_aaeaal_by_cat_change_printf.R
\name{ylt_diagnostics_aaeaal_by_cat_change_printf}
\alias{ylt_diagnostics_aaeaal_by_cat_change_printf}
\title{Prints changes in AAE and AAL from a two YLTs to the screen}
\usage{
ylt_diagnostics_aaeaal_by_cat_change_printf(
  longylt1,
  longylt2,
  mincat,
  maxcat,
  nyearsinylt = 0,
  verbose = FALSE
)
}
\arguments{
\item{longylt1}{A data frame containing YLT1}

\item{longylt2}{A data frame containing YLT2}

\item{mincat}{The minimum cat that is counted}

\item{maxcat}{The maximum cat that is counted}

\item{nyearsinylt}{Number of years in the YLT}

\item{verbose}{Logical}
}
\value{
Prints changes in AAE, AAL to the screen
}
\description{
Only works for the case where there are \emph{exactly} 5 cats in both YLTs.
Which is a bit limiting. Could improve that I guess.
}
\examples{
#
# 1 make YLT1
#
cat("1. make ylt1:\n")
year=c(1,1,1,2,2,3,3,3)
loss=seq(10,80,10)
cat=c(1,1,1,2,2,3,4,5)
longylt1=data.frame(year,loss,cat)
#
# 2 make YLT2
#
cat("1. make ylt2:\n")
year=c(1,1,2,2,2,2,3,3)
loss=seq(20,90,10)
cat=c(1,1,1,2,2,3,4,5)
longylt2=data.frame(year,loss,cat)
#
# look at changes
#
cat("calling ylt_change_diagnostics_aaeaal_by_cat_print:\n")
ylt_diagnostics_aaeaal_by_cat_change_printf(longylt1,longylt2,mincat=1,maxcat=5)
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/extendr-wrappers.R
\name{addvectors}
\alias{addvectors}
\title{Adds two vectors element-wise up to length n.}
\usage{
addvectors(x, y, n)
}
\arguments{
\item{x}{A reference to the first input vector (slice of f64)}

\item{y}{A reference to the second input vector (slice of f64)}

\item{n}{The number of elements to process}
}
\value{
The sum of the two input vectors, as a vector.
}
\description{
Adds two vectors element-wise up to length n.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/106_yltsurgery_groups.R
\name{yltsurgery_groups}
\alias{yltsurgery_groups}
\title{Adjusts a long YLT to make a new long YLT using the grouped surgery algorithm}
\usage{
yltsurgery_groups(
  longylt1,
  rate_adjustments_by_event,
  groups,
  columns2copy = NULL,
  secunc = FALSE,
  verbose = FALSE,
  randomday = TRUE
)
}
\arguments{
\item{longylt1}{A data frame containing a YLT}

\item{rate_adjustments_by_event}{A matrix of multiplicative adjustments for the Poisson rate.
The first column gives the mean rate adjustment and the second column gives the standard deviation of the rate adjustment. Both columns must be of same length as the columns in \code{elt}.}

\item{groups}{Specifies which group each event is in.}

\item{columns2copy}{Specifies a list of columns to be copied from the original YLT, such as \code{cat}.}

\item{secunc}{A logical to indicate whether secondary uncertainty should be simulated
(requires \code{sloss} column). Not implemented yet.}

\item{verbose}{A logical.}

\item{randomday}{Do you want the days to be randomized or copied?}
}
\value{
A data frame containing the new long YLTs.
}
\description{
The simulated YLT is copied from the input YLT, with events added and deleted to reflect
the specified rates changes, according to the 'grouped surgery' algorithm.
This algorithm attempts to minimize differences due to random noise between the two YLTs
and gives more accurate estimates of change than just simulating the second YLT using independent simulation.
Within each group, it chooses the number of events to try and hit the target
as closely as possible.
The rates changes are specified by event.
They can be scalar or log-normal distributed, in order to capture adjustment uncertainty.
Adjustment uncertainty is simulated using the 'stochastic parameter' simulation algorithm.
}
\details{
The input mean and standard deviation rate adjustments are used to define a log-normal distribution for each event.
The log-normal is used to simulate different rate adjustments for each year.
The log-normal adjustments are perfectly correlated between different events.

The rate adjustments are specified for all the events in the YLT, in order.
The algorithm consists of two parts.
In the first part, events may or may not be copied from YLT1 to YLT2, depending on a coin flip,
based on a probability derived from the rate adjustment.
If there is no adjustment, an event will be copied. If there is a large reduction in the rate,
it may well not be copied.
YLT1 provides the evid for each event, which is used to determine the rate adjustment.
In the second part, events with increasing rates are selected randomly from YLT1 (weighted by the increase),
and added to YLT2.
}
\examples{
#
# create an elt with 3 rows
#
set.seed(2)
evid=seq(1000,1002,1)
mrate=seq(0.1,0.3,0.1)
mloss=seq(100,300,100)
region=c("A","B","C")
nevents=length(mrate)
elt=data.frame(mrate,mloss,evid,region)
#
# simulate ylt1 with 10 years
#
nyears=10
longylt1=yltsim(nyears,elt,columns2copy=c("region"))
# add an evid flag to the ylt just to test that goes through into ylt2
cat("*************************ylt1*************************\n")
print(head(longylt1))
#
# define adjustments
#
nevents_in_ylt1=length(longylt1$evid)
rate_adjustments_by_event=matrix(0,nevents_in_ylt1,2)
rate_adjustments_by_event[,1]=2 #double the rates
rate_adjustments_by_event[,2]=0
groups=matrix(1,nevents_in_ylt1)
#
# simulate ylt2 with those adjustments (but not referring back to the ELT)
#
ylt2=yltsurgery_groups(longylt1,rate_adjustments_by_event,groups,columns2copy="region")
cat("*************************ylt2*************************\n")
print(head(ylt2))

}
\references{
For the stochastic parameter simulation algorithm see: https://doi.org/10.1007/s00477-023-02409-0

and: https://en.wikipedia.org/wiki/Year_loss_table#Incremental_Simulation

For the incremental simulation algorithm see: https://doi.org/10.1007/s00477-022-02198-y

and: https://en.wikipedia.org/wiki/Year_loss_table#Stochastic_Parameter_YLTs
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/410_elt_diagnostics_aaeaal.R
\name{elt_diagnostics_aaeaal}
\alias{elt_diagnostics_aaeaal}
\title{Calculates AAE and AAL from an ELT}
\usage{
elt_diagnostics_aaeaal(elt)
}
\arguments{
\item{elt}{A data frame containing the ELT.
The ELT must contain \code{mrate} and \code{mloss} columns.
See the example for how to make the ELT.}
}
\value{
AAE and AAL.
EP curves are in a separate routine \code{epfromelt3}.
}
\description{
Calculates AAE and AAL from an ELT
}
\examples{
#
# create an elt
#
mrate=seq(0.1,0.3,0.1)
mloss=seq(100,300,100)
elt=data.frame(mrate,mloss)
#
op=elt_diagnostics_aaeaal(elt)
#
cat("AAE=",op$AAE,"\n")
cat("AAL=",op$AAL,"\n")
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/539_ylt_add_cat_2_longylt.R
\name{ylt_add_cat_2_longylt}
\alias{ylt_add_cat_2_longylt}
\title{Adds a cat column to a long ylt, based on windspeed}
\usage{
ylt_add_cat_2_longylt(longylt, units)
}
\arguments{
\item{longylt}{A data frame containing the long YLT}

\item{units}{"knots","mph"}
}
\value{
A new longylt with a cat column added
}
\description{
Calculates cat from windspeed, and adds a column for that.
Requires \code{wspd} in the input longylt.
}
\details{
Cat runs from -1 to 5.
Different people use different cat boundaries.
To see the boundaries being used, type \code{ws2catf}.
}
\examples{
#
# 1 create a long YLT
#
cat("1. longylt:\n")
year=c(1,1,1,2,2,3,3,4,4,4,5,5,5,5,5)
wspd=seq(10,150,10)
longylt1=data.frame(year,wspd)
print(longylt1)
#
longylt2=ylt_add_cat_2_longylt(longylt1,units="knots")
#
print(longylt2)
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/201_nahu_ylt_surgery.R
\name{nahu_ylt_surgery}
\alias{nahu_ylt_surgery}
\title{An example workflow for applying \code{ylt_surgery_groups} or \code{ylt_surgery_groups} to NAHU.}
\usage{
nahu_ylt_surgery(
  type_of_analysis,
  ipfilename,
  settingsfilename,
  ylt_opfilename,
  results_opfilename,
  nyearsinylt,
  rcp,
  baseyear1,
  baseyear2,
  targetyear,
  k2020settings,
  frequnc,
  quantile,
  units,
  randomseed,
  manual,
  manualadjustments,
  mincat,
  maxcat,
  test = FALSE,
  verbose = FALSE
)
}
\arguments{
\item{type_of_analysis}{"groups" or "notgroups"}

\item{ipfilename}{ipfilename}

\item{settingsfilename}{settingsfilename}

\item{ylt_opfilename}{ylt_opfilename}

\item{results_opfilename}{results_opfilename}

\item{nyearsinylt}{nyearsinylt}

\item{rcp}{rcp}

\item{baseyear1}{baseyear1}

\item{baseyear2}{baseyear2}

\item{targetyear}{targetyear}

\item{k2020settings}{k2020settings}

\item{frequnc}{frequnc}

\item{quantile}{quantile}

\item{units}{units}

\item{randomseed}{randomseed}

\item{manual}{manual}

\item{manualadjustments}{manualadjustments}

\item{mincat}{The minimum cat that is counted}

\item{maxcat}{The maximum cat that is counted}

\item{test}{test}

\item{verbose}{verbose}
}
\value{
Returns the two YLTs (each consisting of a long and short ylt),
and writes the new longylt to a csv file.
}
\description{
Shows how to take a YLT (that must have wspd, lat and lon columns) and apply climate
change adjustments.
}
\details{
The sections in the code are as follows:

1-writes out the settings to a csv file, for future reference

2-reads an input longylt from the file ipfilename

3-makes some input checks, to make sure the right columns are available in the input file

4-uses the wspd column to add a cat column to the longylt (from 1 to 7, which is cat -1 to 5)
(change this line if you want to make adjustments based on some other feature of the events)

5-uses the lon lat columns to add global region as a column to the longylt (regions from 1 to 18, from the Jewson BAMS paper)
(change this line if you want to use different regions)

6-looks at some diagnostics on the input ylt

7-sets up the GMST scenarios
(change this line if you want to use different GMST scenarios)

8-sets up the rates changes from the BAMS article supporting material on zenodo
(change this line if you want to use different rate changes)

9-does the temporal interpolation based on the input options, GMST scenarios, and zenodo rates

10-converts the adjustments from “by reg-cat” to “by-event”, so they are ready to apply to the ylt

11-defines groups in a certain way...currently just by cat)
(change this line if you want to define groups differently)

12-actually does the adjustment, and makes a new ylt

13-makes joint ylts from the input and results

14-looks at some diagnostics for the new ylt

15-looks at AAE, AAL change diagnostics

16-looks at AAE, AAL change diagnostics, now by cat

17-writes out the new longylt to a csv file

18-returns
}
\examples{
#
# This long example gives a complete end-to-end example of how to adjust a
# hurricane ylt for climate change.
# It uses either surgery, or surgery with groups (according to the settings below).
#
# Here's roughly what it does:
# -creates a ylt
# -sets up some parameters that define climate change adjustments
#  (years, scenarios, etc)
# -sets up some parameters that define what outputs to look at
# -and then adjusts the ylt nylt times, so we can see the variability in the
#  effect of the adjustments
# -it also process the adjusted ylts, and processes and prints the results in
#  nice format to screen and files
#
# 1 make the input ylt csv file:
# -3 years, 4 events
# -wspd, lats and lons will be used to generate appropriate rate adjustments
#
library(pracma)
tic()
message("1. make the input ylt csv file")
year=c(1,1,2,3)
evid=c(12,34,56,78)
loss=c(10,20,30,40)
wspd=c(60,90,120,150)
lflat=c(34.779,29.855,28.891,28.83)
lflon=c(-76.596,-84.174,-95.425,-95.515)
df=data.frame(year,evid,loss,wspd,lflat,lflon)
ipfilename=tempfile(fileext=".csv")
write.csv(df,file=ipfilename,row.names=FALSE)
#
# 2 specify the filenames, and nyearsinylt
#
message("2. specify the filenames etc")
results_Nx_opfilename			=tempfile(fileext=".csv")
settingsfilename					=tempfile(fileext=".csv")
# base only filenames
ylt_opfilename_base				="ylt_op"
results_1x_opfilename_base="results"
nyearsinylt=4
# the nyearsinylt variable forces the code to understand that the ylt represents
# e.g. 50k, even if year 50k is missing, which it might be in some ylts,
# if there are no events in that year
#
# 3 set the other settings (scenarios, etc)
#
message("3. adjustment settings")
type_of_analysis="groups"
type_of_analysis="notgroups"
nylt=1
rcp=8
baseyear1=1900
baseyear2=2022
targetyear=2099
k2020settings="Linear and Landfall"
frequnc="Use distribution"
quantile=90
units="mph"
randomseed=0
manual=FALSE
mn=c(1,1,1.1,1.2,1.3,1.4,1.5)#note that it has 7 values for cat -1 to cat 5
sd=c(0,0,0,0,0,0,0)
manualadjustments=list(mn=mn,sd=sd)
#
# 4 output analyis settings
#
message("4. output analysis settings")
onemillion=1000000
lossthresholds=c(0,30)*onemillion
maxnumberevents=12
countequalto=TRUE
rps=c(2,5)
rpi=pmax(round(nyearsinylt/rps),1)
probs=round(100/rps,digits=1)
nrp=length(rps)
mincat=0
maxcat=5
ncat=1+maxcat-mincat
ncatp1=ncat+1 #since I've added an extra row at the end for the total
nbs=100
nlossthresholds=length(lossthresholds)
#
# 5 output analysis arrays
#
message("5. output analysis arrays")
aal	=matrix(0,2,nylt)
pcaal=matrix(0,2,nylt)

aalbc	=array(0,c(2,nylt,ncatp1))
pcaalbc=matrix(0,nylt,ncatp1)

aae	=matrix(0,2,nylt)
pcaae=matrix(0,2,nylt)

aaebc	=array(0,c(2,nylt,ncatp1))
pcaaebc=matrix(0,nylt,ncatp1)

nbc	=array(0,c(2,nylt,ncatp1))

aep	=array(0,c(2,nylt,nrp))
daep=matrix(0,nylt,nrp)

oep	=array(0,c(2,nylt,nrp))
doep=matrix(0,nylt,nrp)

thresholdcounts	=array(0,c(2,nylt,nlossthresholds,(maxnumberevents+1)))
#+1 to cope with 0
#
# 6 loop to generate the new ylts
#
message("6. loop to generate the new ylts")
for (iylt in 1:nylt){
	cat("running version:",iylt,"\n")
	randomseed=iylt

# the new two lines have two options
	ylt_opfilename				=tempfile(fileext=".csv")
	results_1x_opfilename	=tempfile(fileext=".csv")

	cat("...calling nahu_ylt_surgery\n")
# this is where the actual adjustment takes place, given all the settings
	bothylts=nahu_ylt_surgery(type_of_analysis=type_of_analysis,
		ipfilename,settingsfilename,ylt_opfilename,results_opfilename="",nyearsinylt,
		rcp,baseyear1,baseyear2,targetyear,k2020settings,frequnc,quantile,units,randomseed,
		manual,manualadjustments,mincat,maxcat,
		test=FALSE,verbose=TRUE)
	cat("...back from nahu_ylt_surgery\n")

# for each iteration, extract and store what we need for the output file

# 2 extra ylts, make short ylts
	longylt1=bothylts$longylt1
	longylt2=bothylts$longylt2
	shortylt1=ylt_long2short(longylt1)
	shortylt2=ylt_long2short(longylt2)

# 1 bootstrap uncertainty on base
	if(iylt==1){
		bsaepsd=bootstrap_ep_uncertainty(shortylt1$loss_in_year,nbs,rps)
		bsoepsd=bootstrap_ep_uncertainty(shortylt1$max_loss_in_year,nbs,rps)
	}


# 3 aae and aal diagnostics
# -if there are 7 cats in the file, returns 7 cats
	aae[1,iylt]=ylt_diagnostics_aaeaal(longylt1)$AAE
	aae[2,iylt]=ylt_diagnostics_aaeaal(longylt2)$AAE
	pcaae[iylt]=round(100*(aae[2,iylt]-aae[1,iylt])/aae[1,iylt],digits=2)
	aal[1,iylt]=ylt_diagnostics_aaeaal(longylt1)$AAL
	aal[2,iylt]=ylt_diagnostics_aaeaal(longylt2)$AAL
	pcaal[iylt]=round(100*(aal[2,iylt]-aal[1,iylt])/aal[1,iylt],digits=2)

# 4 aae and aal diagnostics by cat
	aaeaalbc1=ylt_diagnostics_aaeaal_by_catf(longylt1,mincat=mincat,maxcat=maxcat)
	aaeaalbc2=ylt_diagnostics_aaeaal_by_catf(longylt2,mincat=mincat,maxcat=maxcat)
# aae by cat
	aaebc[1,iylt,]	=round(aaeaalbc1$AAEbycat,digits=2)
	aaebc[2,iylt,]	=round(aaeaalbc2$AAEbycat,digits=2)
	nbc[1,iylt,]	=aaeaalbc1$Nbycat
	nbc[2,iylt,]	=aaeaalbc2$Nbycat
	pcaaebc[iylt,]=round(100*(aaeaalbc2$AAEbycat-aaeaalbc1$AAEbycat)/aaeaalbc1$AAEbycat,
		digits=1)
# aal by cat
	aalbc[1,iylt,]=round(aaeaalbc1$AALbycat,digits=0)
	aalbc[2,iylt,]=round(aaeaalbc2$AALbycat,digits=0)
	pcaalbc[iylt,]=round(100*(aaeaalbc2$AALbycat-aaeaalbc1$AALbycat)/aaeaalbc1$AALbycat,
		digits=1)

# 5 calculate AEPs
	aep[,iylt,]=make_2_ep_by_sorting(shortylt1$loss_in_year,shortylt2$loss_in_year,rps)
	daep[iylt,]=round(100*(aep[2,iylt,]-aep[1,iylt,])/aep[1,iylt,],digits=1)

# 6 calculate OEPs
	oep[,iylt,]=make_2_ep_by_sorting(shortylt1$max_loss_in_year,shortylt2$max_loss_in_year,
		rps)
	doep[iylt,]=round(100*(oep[2,iylt,]-oep[1,iylt,])/oep[1,iylt,],digits=1)

# 7 number of years with n events greater than x loss
	m30=30000000
	thresholdcounts[1,iylt,,]=ylt_diagnostics_loss_thresholds(longylt1,lossthresholds,
		maxnumberevents,countequalto)
	thresholdcounts[2,iylt,,]=ylt_diagnostics_loss_thresholds(longylt2,lossthresholds,
		maxnumberevents,countequalto)

# write results for each ylt separately, just in case you need that
con=file(results_1x_opfilename)
sink(con,append=TRUE)
sink(con,append=TRUE,type="message")
	writeNresults2csv(nyearsinylt,mincat,maxcat,nrp,nylt,maxnumberevents,bsaepsd,bsoepsd,
		aal,pcaal,aalbc,pcaalbc,
		aae,pcaae,aaebc,pcaaebc,
		nbc,
		probs,rps,aep,daep,oep,doep,lossthresholds,thresholdcounts,justone=TRUE,iylt)
closeAllConnections()

}

# write results for all ylts together into one file...this is the main output
con=file(results_Nx_opfilename)
sink(con,append=TRUE)
sink(con,append=TRUE,type="message")
	writeNresults2csv(nyearsinylt,mincat,maxcat,nrp,nylt,maxnumberevents,bsaepsd,bsoepsd,
		aal,pcaal,aalbc,pcaalbc,
		aae,pcaae,aaebc,pcaaebc,
		nbc,
		probs,rps,aep,daep,oep,doep,lossthresholds,thresholdcounts,justone=FALSE,iylt=999)
closeAllConnections()

toc()

}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/024_make_2_ep_by_sorting.R
\name{make_2_ep_by_sorting}
\alias{make_2_ep_by_sorting}
\title{Make 2 EP curves by sorting losses}
\usage{
make_2_ep_by_sorting(losses1, losses2, rps)
}
\arguments{
\item{losses1}{A vector of losses.}

\item{losses2}{A vector of losses.}

\item{rps}{The return periods at which to calculate the EPs}
}
\value{
A matrix with 2 sets of return levels in it (with 2 rows)
}
\description{
Calculates 2 EPs, from two vectors of losses, just by calling
\code{make_ep_by_sorting} twice.
This somewhat trivial routine is included because it is a very common
operation, to compare losses between two cases (two models, often
an original model and an adjusted model).
}
\examples{
#
# 1 create losses
#
cat("1. make losses:\n")
losses1=seq(1,1000,1)
losses2=seq(1001,2000,1)
#
# 2 set the return periods to look at
#
rps=c(1,2,3,4,5,10,20,50,100)
#
cat("2. calculate the EP:\n")
op=make_2_ep_by_sorting(losses1,losses2,rps)
#
print(op)

}
\seealso{
\itemize{
\item \code{make_ep_by_sorting} which is what this routine uses
}
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/600_catxl.R
\name{catxl}
\alias{catxl}
\title{Applies CatXL Layers to a YLT}
\usage{
catxl(longylt, limit, deductible, nrst, premium, rst_premium_pc)
}
\arguments{
\item{longylt}{A longylt in \code{yltsim} format}

\item{limit}{A vector of limits for the CatXL layers.}

\item{deductible}{A vector of deductibles for the CatXL layers.}

\item{nrst}{A vector giving the numbers of reinstatements in each layer}

\item{premium}{The overall premium (can be set to 0)}

\item{rst_premium_pc}{The reinstatement premium, as a percentage}
}
\value{
A list containing 3 data frames:
\itemize{
\item \code{summary}AAL ann average annual premium for each layer
\item \code{shortrecord}Diagnostics by year by layer
\item \code{longrecord}Diagnostics by event (aka claim) by layer
}
}
\description{
Reads a YLT generated by \code{yltsim} format and applies CatXL layers,
to generate multiple outputs and diagnostics.
}
\details{
Based on the description of catXL pricing given at:
}
\examples{
#
# 1 create an example ELT
#
nevents=1000
totalannualrate=3
evid=c(1:nevents)
mloss=(c(1:nevents)^2)/100 #max is 10k
mrate=rep(totalannualrate/nevents,nevents)
elt=data.frame(evid,mrate,mloss)
#
# 2 example 1
#
message("**************************************************************")
message("Example 1: 2 years of simulation, 2 layers, detailed outputs  ")
message("**************************************************************")
#
# 3 simulate a 2 year YLT
#
nyears=2
set.seed(3)
ylt=yltsim(nyears=nyears,elt)
#
# 4 set up 2 catXL layers
#
limit=c(2000,4000)
deductible=c(1000,3000)
nrst=c(2,2)
premium=1000
rst_premium_pc=c(80,90)
#
# 5 analyze the catXL
#
catxlresults=catxl(ylt,limit,deductible,nrst,premium,rst_premium_pc)
#
# 6 look at the results
#
message("\nsummary:")
print(catxlresults$summary)
message("\nshortrecord:")
print(catxlresults$shortrecord)
message("\nlongrecord:")
print(catxlresults$longrecord)
#
# 7 example 2
#
message("**************************************************************")
message("Example 2: 1k years of simulation, 1 layer, summary outputs")
message("**************************************************************")
nyears=100
#
# 8 simulate 2x 1k YLTs to investigate convergence
#
set.seed(1);ylt1=yltsim(nyears=nyears,elt)
set.seed(2);ylt2=yltsim(nyears=nyears,elt)
#
# 9 set up 1 catXL layer this time
#
limit=c(2000)
deductible=c(1000)
nrst=c(1)
premium=1000
rst_premium_pc=c(80)
#
# 10 analyze the catXL and look at the summary results
#
message("\nylt1 summary:")
print(catxl(ylt1,limit,deductible,nrst,premium,rst_premium_pc)$summary)
message("\nylt2 summary:")
print(catxl(ylt2,limit,deductible,nrst,premium,rst_premium_pc)$summary)
}
\seealso{
\code{yltsim}, to generate the required YLT input
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/extendr-wrappers.R
\name{rust_hello_world}
\alias{rust_hello_world}
\title{Return string \code{"Hello world!"} to R.
Just a test.}
\usage{
rust_hello_world()
}
\value{
A message to the screen.
}
\description{
Return string \code{"Hello world!"} to R.
Just a test.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/806_hours_clause_compare_distance_routines.R
\name{compare_distance_routines}
\alias{compare_distance_routines}
\title{Function for testing that R and Rust give the same distances between events}
\usage{
compare_distance_routines(longylt)
}
\arguments{
\item{longylt}{Input YLT}
}
\value{
Writes mismatches to the screen.
Always stops.
}
\description{
This isn't actually used for anything, except doing this test.
But it's an important test. Getting R and Rust to agree was difficult.
}
\examples{
#
# 1 make longylt
#
cat("1. make longylt:\n")
year=c(1,1,1)
lon=c(-111.8817,-111.1963,-119.891)
lat=c(35.1067,31.4196,39.3254)
longylt=data.frame(year,lon,lat)
#
# 2 run
#
compare_distance_routines(longylt)
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/028_ws2cat.R
\name{ws2catf}
\alias{ws2catf}
\title{Convert windspeed in knots into a generalized version of the SSHWS category.}
\usage{
ws2catf(ws, units)
}
\arguments{
\item{ws}{input windspeed in units}

\item{units}{The units: knots, mph or mph2}
}
\value{
The cat from -1,0,1,2,3,4,5, where -1 means TD and 0 means TS.
}
\description{
Converts windspeed
}
\details{
I took the definitions from Wikipedia/Saffir-Simpson_scale.
Note that the definitions on Wikipedia have gaps, such as between
63 and 64 knots. I close the gaps by using halves.
}
\examples{
cat("\n")
ws=70
cat("ws in knots=",ws,"\n")
cat("cat=",ws2catf(ws,units="knots"),"\n")
#
cat("\n")
cat("ws in mph=",ws,"\n")
cat("cat=",ws2catf(ws,units="mph"),"\n")
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/214_nahu_define_k2020_zenodo_landfall_adj.R
\name{nahu_define_k2020_zenodo_landfall_adj}
\alias{nahu_define_k2020_zenodo_landfall_adj}
\title{Define Jewson landfall rates Scenarios from the BAMS paper}
\usage{
nahu_define_k2020_zenodo_landfall_adj()
}
\value{
An array with 19 landfall scenarios, described in the Jewson (2023) BAMS paper.
}
\description{
Multiplicative landfalling hurricane rate adjustments, mean and sd.
}
\details{
For the mean, a value of 1 is no change in the rate.
For the sd, value of 0 is no uncertainty in the rate change.
The distribution of rate changes is considered to be log-normal.
Index 1, from 1 to 19, specifies the region, as in the BAMS paper.
Index 2, specifies mean (1) or sd(2).
Index 3, specifies what set of categories. The 7 categories are -1,0,1,2,3,4,5 on the SSHWS.
}
\examples{
adjustments=nahu_define_k2020_zenodo_landfall_adj()
region=1
variance=1
cat=1
print(adjustments[1,1,1])

}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/900_countrydata_v16.R
\name{defineregion}
\alias{defineregion}
\title{Defines the 19 Global Regions from My BAMS Paper}
\usage{
defineregion(iregion)
}
\arguments{
\item{iregion}{Region index}
}
\value{
A list with two vectors, for longitudes and latitudes of corners of the region
}
\description{
Defines the 19 Global Regions from My BAMS Paper
}
\examples{
reg=defineregion(2)
cat("regx=",reg$regx,"\n")
cat("regy=",reg$regy,"\n")
}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/extendr-wrappers.R
\name{rust_dist_haversine}
\alias{rust_dist_haversine}
\title{Function to calculate the Haversine distance between two points.
This matches the functionality of geosphere::distHaversine in R.}
\usage{
rust_dist_haversine(lon1, lat1, lon2, lat2)
}
\arguments{
\item{lon1}{Lon of first point.}

\item{lat1}{Lat of first point.}

\item{lon2}{Lon of second point.}

\item{lat2}{You guess.}
}
\value{
Returns distance in meters.

A message to the screen.
}
\description{
Function to calculate the Haversine distance between two points.
This matches the functionality of geosphere::distHaversine in R.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/213_nahu_define_gmst_scenarios.R
\name{nahu_define_gmst_scenarios}
\alias{nahu_define_gmst_scenarios}
\title{Defines 4 GMST Scenarios}
\usage{
nahu_define_gmst_scenarios(verbose = FALSE)
}
\arguments{
\item{verbose}{logical}
}
\value{
An array with 4 GMST scenarios.
}
\description{
These are the 4 GMST scenarios for 2.6,...,8.5, by year,
derived from CMIP (from the JAMC paper Jewson(2021)).
From 1880 to 2100.
}
\examples{
gmst=nahu_define_gmst_scenarios()
print(head(gmst[,1:5]))

}
\author{
Stephen Jewson \email{stephen.jewson@gmail.com}
}
